<?php
/**
* @copyright	Copyright (C) 2009 - 2011 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		PayPlans
* @subpackage	Frontend
* @contact 		payplans@readybytes.in
* website		http://www.jpayplans.com
* Technical Support : Forum -	http://www.jpayplans.com/support/support-forum.html
*/
if(defined('_JEXEC')===false) die();

class PayplansadminControllerTransaction extends XiController
{
	protected	$_defaultOrderingDirection = 'DESC';
	public function _save(array $data, $itemId = null)
	{
		if(!$itemId){
			XiError::assert(isset($data['payment_id']) && $data['payment_id'], XiText::_('COM_PAYPLANS_ERROR_INVALID_PAYMENT_ID'));
		}
		
		if(!empty($data['params'])){
			$data['params'] = PayplansHelperParam::arrayToIni($data['params']);
		}
		
		$invoice_id = $data['invoice_id'];
		$invoice = PayplansInvoice::getInstance($invoice_id);
		$amount = $invoice->getTotal();
		
		//create new lib instance
		$transaction  = PayplansTransaction::getInstance($itemId)
								->bind($data);
		
		// trigger the event for free invoice only
		if(floatval($amount) == floatval(0)){
			// trigger the event 
			$args = array($transaction, $amount);
			PayplansHelperEvent::trigger('onPayplansWalletUpdate', $args);
		}

		$transaction->save();

		return true;
	}
	
	public function newTransaction()
	{
		$this->setTemplate('newtransaction');
		return true;
	}
	
}

