/**
* @copyright	Copyright (C) 2009-2012 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @contact 		shyam@readybytes.in
*/

//define payplans, if not defined.
if (typeof(payplans)=='undefined'){
	var payplans = {}
}

// all admin function should be in admin scope 
if(typeof(payplans.admin)=='undefined'){
	payplans.admin = {};
}

//all admin function should be in admin scope 
if(typeof(Joomla)=='undefined'){
	Joomla = {};
}

//Backward compatibility with 1.4.x code
payplansAdmin = {};


(function($){
// START : 	
// Scoping code for easy and non-conflicting access to $.
// Should be first line, write code below this line.	
	
	
/*--------------------------------------------------------------
payplans.admin.grid
	submit
	filters
--------------------------------------------------------------*/
payplans.admin.grid = {
		
		//default submit function
		submit : function( view, action, validActions){
			
			// try views function if exist
			var funcName = view+'_'+ action ; 
			if(this[funcName] instanceof Function) {
				if(this[funcName].apply(this) == false)
					return false;
			}
			
			// then lastly submit form
			//submitform( action );
			if (action) {
		        document.adminForm.task.value=action;
		    }
			
			// validate actions
			//XITODO : send values as key of array , saving a loop
			validActions = eval(validActions);
			var isValidAction = false;
			for(var i=0; i < validActions.length ; i++){
				if(validActions[i] == action){
					isValidAction = true;
					break;
				}
			}
			
			
			// remove time offset
			payplans.time.removeOffset();
						
			var result = true;
		    if (document.adminForm.onsubmit instanceof Function) {
			    result = document.adminForm.onsubmit.apply(this, Array(isValidAction));
				// below code is not working on IE7+, so added above line
		        //result=document.adminForm.onsubmit(isValidAction);
		    }
		    if(result){
		    	document.adminForm.submit();
		    }
		},
		
		filters : {
			reset : function(form){
				 // loop through form elements
			    var str = new Array();
                            var i=0;
			    for(i=0; i<form.elements.length; i++)
			    {
			        var string = form.elements[i].name;
			        if (string && string.substring(0,6) == 'filter' && (string!='filter_reset' && string!='filter_submit'))
			        {
			            form.elements[i].value = '';
			        }
			    }
				this.submit(view,null,validActions);
			}
		}		
};

//Backward compatibility with 1.4.x code
payplansAdmin.submit 	= payplans.admin.grid.submit
payplansAdmin.redirect 	= payplans.url.redirect
payplansAdmin.resetFilters = payplans.admin.grid.filters.reset

/*--------------------------------------------------------------
  payplans.admin.search
	dropdown: 
	keydown :
	keyup	:
--------------------------------------------------------------*/
payplans.admin.search = {
	dropdown : function(){
        
        $(".pp-admin-search").position({
        	my:        "right top",    
        	at:        "right bottom",    
        	of:        $('#pp-button-searchpayplans'),  
        	collision: "fit"
        	})
        $(".pp-admin-search").toggle();
	},

	keydown : function(e){
		/*Track Enter and post module data for search result*/
		if (e.keyCode == 13){
			payplans.admin.search.go();
		}else if(e.keyCode == 27) { 
			payplans.admin.search.dropdown();
		}
		
		/*Ignor page postback on enter press*/
		$('#pp-search-box-form').submit(function() {return false;});
	},
 	
	keyup : function(e){
		/*Track Enter and post module data for search result*/
		if (e.keyCode != 13 && e.keyCode != 27) { 
			payplans.admin.search.go();
		}
	},

	 go: function(){
            var searchText = $('#pp-search-box-form-search-text').val();
            // do not search for empty
            if(!searchText){
                    $('#pp-search-box-form-search-results').css('display','none');
                    return false;
            }
            
            var url = "index.php?option=com_payplans&view=dashboard&task=modsearch&headerFooter=0&domObject=payplans-search-results&searchText="+searchText;
            $('#pp-search-box-form-search-results').css('display','block');
            xiajax.call(url);
    }
};


//Backward compatibility with 1.4.x code
xi.dashboard = {};
xi.dashboard.modsearch 			= payplans.admin.search.go;
payplansAdmin.searchBoxDropdown	= payplans.admin.search.dropdown;
payplansAdmin.searchBoxKeyDown	= payplans.admin.search.keydown;
payplansAdmin.searchBoxKeyUp	= payplans.admin.search.keyup;


/*--------------------------------------------------------------
payplans.admin.app
	filtertags	: on app screen, filter displayed app as per tag 
	clickapp	: show details of particular app
--------------------------------------------------------------*/
payplans.admin.app = {
	filtertags: function(){
    	$('#filtertags').live('change', function(){
           var filterval = $('select#filtertags option:selected').val();
           
           // hide all
           $('.pp-app.f-all').hide().removeClass('pp-grid_11');
           
           // display selected tags 
           $('.pp-app.f-'+filterval).show();
           
           // hide all descriptions
           $('.pp-appdetail').hide();
           
           $('#type').attr('value','#')           
        });
	},

	clickapp: function(value){
		//1. check if selected class is added to this button or not 
		if($('#type').attr('value') !='#' && $('#type').attr('value') == value ){
			payplans.url.submitParentForm('payplans-app-new-next');
		}

		// set value
		$('input#type').attr('value',value);

		// hide all apps but selected
		$('.pp-app').hide();
		$('.pp-app-'+value).show().addClass('pp-grid_11');
    
		// display description
		$('.pp-appdetail').hide();
		$('.pp-appdetail-'+value).show();
	}
};




/*--------------------------------------------------------------
  payplans.admin.migrate
  	setup	: setup the migration screen
	start	: start migration
	update	: update migration screen
	complete: post migrate information display
--------------------------------------------------------------*/
payplans.admin.migrate = {

	setup: function(plugin){
	    var url = "index.php?option=com_payplans&view=dashboard&task=migrate&plugin="+plugin+'&action=pre';
	    xi.ui.dialog.create({'url':url, 'data':{}});
	    return false;
	},

	start: function(plugin){
		var data = $('.pp-migrate-pre').closest('form').serializeArray();
	    var url = "index.php?option=com_payplans&view=dashboard&task=migrate&plugin="+plugin+'&action=Do';
	    if(typeof data == 'undefined'){
	    	xi.ui.dialog.create({'url':url, 'data':{}});
	    }
	    else{
	    	xi.ui.dialog.create({'url':url, 'data':data});
	    }
	},

	update: function(plugin, progress){
	    var url = "index.php?option=com_payplans&view=dashboard&task=migrate&plugin="+plugin+'&action=Do';
	    // update the progressbar length
	    $('#dashboard-migrate-progress-bar').css('width',progress+'%');
	    xiajax.call(url);
	},

	complete: function(plugin){
	    var url = "index.php?option=com_payplans&view=dashboard&task=migrate&plugin="+plugin+'&action=post';
	    xi.ui.dialog.create({'url':url, 'data':{}});
	}	
};

// Backward compatibility with 1.4.x code
xi.dashboard = {};
xi.dashboard.preMigration 	= payplans.admin.migrate.setup;
xi.dashboard.doMigration	= payplans.admin.migrate.start;
xi.dashboard.updateMigration= payplans.admin.migrate.update;
xi.dashboard.postMigration	= payplans.admin.migrate.complete;

/*--------------------------------------------------------------
  payplans.admin.user
--------------------------------------------------------------*/
payplans.admin.user = {
    applyPlan: function(){
            window.top.document.forms.adminForm.plan_id.value = window.top.document.forms.selectPlanForm.plan_id.value;
            window.top.document.forms.adminForm.task.value = 'applyPlan';
            window.top.document.forms.adminForm.submit();                   
    }
};
    
// Backward compatibility with 1.4.x code
xi.user = {};
xi.user.applyPlan = payplans.admin.user.applyPlan;



/*--------------------------------------------------------------
	payplans.admin.subscription
	- extend : extend selected subscriptions
--------------------------------------------------------------*/
payplans.admin.subscription = {
    extend: function(){
			var extendTime = $('#pp-admin-subscription-extend').contents().find('input[name="extend_time"]').attr('value');
            
			// add extend_time element to admin Form
            var extendElement = $('<input>').attr({
            		'type' : 'hidden',
        			'name' : 'extend_time',
        			'value': extendTime
            	}).appendTo('#adminForm');

            window.top.document.forms.adminForm.task.value = 'extend';
            window.top.document.forms.adminForm.submit();                   
    }
};


//Backward compatibility with 1.4.x code
xi.subscription = {};
xi.subscription.extend = payplans.admin.subscription.extend;



/*--------------------------------------------------------------
payplans.admin.dashboard--------------------------------------------------------------*/
payplans.admin.dashboard = {
		changeStatistics : function(durationType){
					var url = 'index.php?option=com_payplans&view=dashboard&task=statisticsCharts&duration='+durationType;
					var args = {};
					payplans.ajax.go(url, args);
		},
		
		removeErrorLog : function(log_id){
			var url = 'index.php?option=com_payplans&view=dashboard&task=markRead&logId='+log_id;
			var args = {};
			payplans.ajax.go(url, args);
		},
		
		customDateStatistics : function(first, last){
			var url = 'index.php?option=com_payplans&view=dashboard&task=customStatistics&statisticsFirstDate='+first+'&statisticsLastDate='+last;
			var args = {};
			payplans.ajax.go(url, args);
		}

};

//Created for Handling of Rebuilding statistics process
payplans.admin.dashboard.rebuildstats = {
		
					setup: function() {
								var url = 'index.php?option=com_payplans&view=dashboard&task=rebuildstats&action=start';
								xi.ui.dialog.create({'url':url, 'data':{}},xi.cms.text._('COM_PAYPLANS_JS_DASHBOARD_REBUILD_START_DIALOG_TITLE', 'Start Rebuild'),500);
							    return false;
							},
	
					start: function(){
								 var url = 'index.php?option=com_payplans&view=dashboard&task=rebuildstats&action=do&start=0';
								 xi.ui.dialog.create({'url':url, 'data':{}},xi.cms.text._('COM_PAYPLANS_JS_DASHBOARD_REBUILD_CALCULATING_DIALOG_TITLE', 'Calculating Statistics'),500);
								 return false;
							},
	
					update: function(start){
								var url = 'index.php?option=com_payplans&view=dashboard&task=rebuildstats&action=do&start='+start;
							    xiajax.call(url);
							},
					complete: function (){
								var url = 'index.php?option=com_payplans&view=dashboard&task=rebuildstats&action=complete';
								xi.ui.dialog.create({'url':url, 'data':{}}, xi.cms.text._('COM_PAYPLANS_JS_DASHBOARD_REBUILD_COMPLETED_DIALOG_TITLE', 'Rebuilding Completed'),500);
							},
						
					close: function (){
							xi.ui.dialog.autoclose(2000);
							payplans.ajax.go("index.php?option=com_payplans&view=dashboard&task=rebuildstats&action=close");
							}
			};


/*--------------------------------------------------------------
payplans.admin.manage
--------------------------------------------------------------*/
payplans.admin.manage = {
		install: function(plg_type, plg_name){
					var url = 'index.php?option=com_payplans&view=manage&task=install&plg_type='+plg_type+'&plg_name='+plg_name;
					var args = {};		
					payplans.jQuery('.pp-app-running-status-'+plg_type+'-'+plg_name).addClass('loading').html(xi.cms.text._('COM_PAYPLANS_JS_MANAGE_INSTALLING', 'Installing.....'));					
					payplans.jQuery('#pp-install'+'-'+plg_type+'-'+plg_name).parent().html('<div class="loading" id="pp-install'+'-'+plg_type+'-'+plg_name+'">Installing.....</div>');
					
					payplans.ajax.go(url, args);
					return false;
		},
		
		install_response : function(plg_type, plg_name, response){
					response = JSON.parse(response);
					
					var teaser = xi.cms.text._('COM_PAYPLANS_JS_MANAGE_RESPONSE_ERROR', 'Error');
					// success
					if(response.response_code == 200){
						teaser = xi.cms.text._('COM_PAYPLANS_JS_MANAGE_RESPONSE_SUCCESS', 'SUCCESS');
					}
					
					// error					
					payplans.jQuery('.pp-app-running-status-'+plg_type+'-'+plg_name).removeClass('loading').html(teaser);					
					payplans.jQuery('#pp-install'+'-'+plg_type+'-'+plg_name).html(xi.cms.text._('COM_PAYPLANS_JS_MANAGE_ERROR_CODE_'+response.error_code, response.error_code)).removeClass('loading');
					return true;
		}
};


payplans.admin.subscription = {

		subStatusEditWarning: function(statusid){
	   
	    if(statusid == '1601')
	    {
	    	xi.jQuery.apprise(xi.cms.text._('COM_PAYPLANS_JS_SUBSCRIPTION_EDIT_SCREEN_WARNING', 'Warning'));
	    }
	},
		
		
	  subStatusGridWarning: function(statusid,entityid,recordkey){
	   
	    if(statusid == '1601')
	    {
	    	xi.jQuery.apprise(xi.cms.text._('COM_PAYPLANS_JS_SUBSCRIPTION_GRID_SCREEN_WARNING', 'Warning'),
	 			   {
	 					'verify':true
	 			   }, 
	 					function(r){
	 						if(r){
	 							window.location.replace(xi_url_base +'index.php?option=com_payplans&view='+ xi_view +'&task=update&name=status&value=' + statusid +'&'+recordkey+'='+entityid);    
	 						} 
	 						else{
	 							window.location.replace(xi_url_base +'index.php?option=com_payplans&view='+ xi_view);
	 						}
	 					});
	    }
	    else
	    window.location.replace(xi_url_base +'index.php?option=com_payplans&view='+ xi_view +'&task=update&name=status&value=' + statusid +'&'+recordkey+'='+entityid);
	}
  };

/*--------------------------------------------------------------
  on Document ready 
--------------------------------------------------------------*/
$(document).ready(function(){
	var count = 0;
	
    $('a[href*="view=appmanager"]').append('<span class="pp-new-tag"></span>');

    if(xi_vars['version']['jfamily'] == '35')
    	var value = $('.active').children().attr('href');
    else
    	var value = $('.active').attr('href');
    
	if( value == "index.php?option=com_payplans&view=appmanager"){
		$(".pp-new-tag").remove();
	}

	//admin update status
	$(".gridupdatestatus").change(function(){
		 var statusid = $(this).val();
		 var entityid= $(this).attr('entity-id');
		 var recordkey = $(this).attr('record-key');
		payplans.admin.subscription.subStatusGridWarning(statusid,entityid,recordkey);
	});
	
	
	$(".editupdatestatus").change(function(){
		 var statusid = $(this).val();
		payplans.admin.subscription.subStatusEditWarning(statusid);
	});
	
	
	// dashbord statistics
	$("input[name^='displaystatisticschart']").click(function(){
			payplans.admin.dashboard.changeStatistics(this.value);
	});
	
	$('.pp-err-cancel').click(function(){
		var value = this.id;
		// Step 1:- mark status of error log as read
		payplans.admin.dashboard.removeErrorLog(value);
		// Step 2:- hide the div(single log entry)
		$("#pp-log-"+value).hide();
	});
	
	$('.pp-dates-label').live('click',function(){
		$('.pp-dates-text').css("display", "block");
		$(this).css("display", "none");
	});
	
	$(this).mouseup(function(e){
		var container = $('.pp-dates-text');
	    if (container.has(e.target).length === 0){
	    	$('.pp-dates-label').css("display", "block");
	        container.css("display", "none");
	    }
		
	});
	
	$("input[name^='statisticsCustomDates']").click(function(){
		var first = $("input[name^='statisticsFirstDate']").val();
		var last = $("input[name^='statisticsLastDate']").val();
		payplans.admin.dashboard.customDateStatistics(first, last);
	});
	
	
	$(".remove-error-message").click(function(){
		$(this).parents(".error-message-body").hide();
	});
	
});

//ENDING :
//Scoping code for easy and non-conflicting access to $.
//Should be last line, write code above this line.
})(payplans.jQuery);