<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.ajax.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

switch( $task ) 
{
	case "getclient":
		GetClientAjax();
		break;
	case "getuser":
		GetUserAjax();
		break;
	case "getusermails":
		GetUserMailsAjax();
		break;
	case "cvs":
		GetCVS();
		break;
	case "csvclientm":
		GetCVSClientReport();
		break;
	case "filemanager":
		Filemanager();
		break;
}

function Filemanager()
{
	$user = JFactory::getUser();
	$html = '';
	
	if( !$user->id ) 
		return false;
	
	if ($handle = opendir('.')) {
		while (false !== ($entry = readdir($handle))) {
			if ($entry != "." && $entry != "..") {
				$html.= '<img src="../components/com_maqmahelpdesk/images/16px/'.(is_dir($entry) ? '' : '').'.png" alt="" /> $entry <br />';
			}
		}
		closedir($handle);
	}
	
	echo $html;
}

function GetCVSClientReport()
{
	include(JPATH_SITE.'/components/com_maqmahelpdesk/includes/reportclientcsv.php');
}

function GetCVS()
{
	include(JPATH_SITE.'/components/com_maqmahelpdesk/includes/makecvs.php');
}

function GetUserMailsAjax()
{
	global $supportConfig;
	
	$database = JFactory::getDBO();
	$userl = JFactory::getUser();
	
	if( !$userl->id || !$supportConfig->extra_email_notification ) 
		return false;
	
	$data = '';

	$name = mysql_escape_string(trim($_GET["q"]));
	if (!$name) return;

	// Search Users and Clients tables
	$sql = "SELECT u.name, u.email 
			FROM #__users u 
			WHERE UCASE(u.name) LIKE UCASE('%".$database->getEscaped($name)."%') 
			   OR UCASE(u.email) LIKE UCASE('%".$database->getEscaped($name)."%') 
			   OR UCASE(u.username) LIKE UCASE('%".$database->getEscaped($name)."%')
			ORDER BY u.name, u.email 
			LIMIT 0, 10";
	$database->setQuery( $sql );
	$users = $database->loadObjectList();
	
	for( $i=0; $i<count($users); $i++ )
	{
		$userr = $users[$i];
		$data.= $userr->email.'|'.$userr->name."\n";
	}
	
	echo $data;
}

function GetUserAjax() 
{
	$database = JFactory::getDBO();
	$userl = JFactory::getUser();
	
	if( !$userl->id )
		return false;
	
	$data = '';

	$name = JRequest::getVar( 'q', '', '', 'string' );
	if (!$name) return;

	// Maximum number of users that will be displayed in the results ajax box
	$results_item_limit = 20;

	// Search Users and Clients tables
	$sql = "SELECT u.id, u.name, c.clientname, c.id AS id_client, u.email 
			FROM #__users u 
				 LEFT JOIN #__support_client_users cu ON cu.id_user=u.id 
				 LEFT JOIN #__support_client c ON c.id=cu.id_client 
			WHERE UCASE(u.name) LIKE UCASE('%".$database->getEscaped($name)."%') 
			   OR UCASE(c.clientname) LIKE UCASE('%".$database->getEscaped($name)."%') 
			   OR UCASE(u.username) LIKE UCASE('%".$database->getEscaped($name)."%') 
			ORDER BY u.name, c.clientname 
			LIMIT 0, ".$results_item_limit."";
	$database->setQuery( $sql );
	$rows = $database->loadObjectList();
	
	for( $i=0; $i<count($rows); $i++ )
	{
		$row = $rows[$i];
		$data.= $row->id."|".$row->name."|".$row->id_client."|".$row->clientname."|".$row->email."|".mqm_getavatar($row->id)."\n";
	}
	
	echo $data;
}

function GetClientAjax() 
{
	$database = JFactory::getDBO();
	$userl = JFactory::getUser();
	
	if( !$userl->id )
		return false;
	
	$data = '';

	$name = JRequest::getVar( 'q', '', '', 'string' );
	if (!$name) return;

	// Maximum number of users that will be displayed in the results ajax box
	$results_item_limit = 20;

	// Search Users and Clients tables
	$sql = "SELECT c.id, c.clientname, c.logo
			FROM #__support_client c 
			WHERE UCASE(c.clientname) LIKE UCASE('%".$database->getEscaped($name)."%') 
			ORDER BY c.clientname 
			LIMIT 0, ".$results_item_limit."";
	$database->setQuery( $sql );
	$rows = $database->loadObjectList();
	
	for( $i=0; $i<count($rows); $i++ )
	{
		$row = $rows[$i];
		$data.= $row->id."|".$row->clientname."|".($row->logo!='' ? $row->logo : JURI::root().'components/com_maqmahelpdesk/images/title/clients.png')."\n";
	}
	
	echo $data;
}
