<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.calendar.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

include_once( JPATH_SITE. '/components/com_maqmahelpdesk/includes/common.php' );
require_once( "components/com_maqmahelpdesk/html/admin.calendar.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

$id          = JRequest::getVar( 'id', 			'', '', 'string' );
$date        = JRequest::getVar( 'date_time', 	'', '', 'string' );		
$taskhour    = JRequest::getVar( 'taskhour', 	'', '', 'string' );		
$taskmin     = JRequest::getVar( 'taskmin', 	'', '', 'string' );		
$status      = JRequest::getVar( 'status', 		'', '', 'string' );		
$id_user	 = JRequest::getVar( 'id_user', 	'', '', 'string' );

// Activities logger
mqm_activitylog('admin', 'calendar', $task);

switch ($task) {
	case "save":
		saveCalendar( $date, $taskhour, $taskmin, $status, $id_user );
		break;

	case "new":
		editCalendar( 0 );
		break;
}

function editCalendar( $uid=0 ) {
	$database = JFactory::getDBO();
	$row = new mosSupportTask( $database );
	// load the row from the db table
	$row->load( $uid );
	
	// Build Support Staff select list
	$sql = "SELECT DISTINCT(u.`id`) AS value, u.`name` AS text FROM #__support_permission p, #__users u WHERE p.id_user=u.id ORDER BY u.name";
	$database->setQuery($sql);
	$rows_staff = $database->loadObjectList();
	$rows_staff = array_merge(array(JHTML::_('select.option', '0', JText::_('select3'))), $rows_staff);
	$lists['id_user'] = JHTML::_('select.genericlist',$rows_staff, 'id_user', 'class="inputbox" size="1"', 'value', 'text', $row->id_user);
	
	$task_date = '';
	$task_date = $row->date_time;

	// Build Date without time
	$date_task = '';
	$date_task = substr($task_date, 0, 10);
	
	// Build Hours without time
	$hour_task = '';
	$hour_task = substr($task_date, 11, -6);
	
	// Build Mins without time
	$mins_task = '';
	$mins_task = substr($task_date, 14, -3);

	// Gets the ticket ID and Subject (only if task is associated with one ticket)
	$sql = "SELECT ticketmask, subject FROM #__support_ticket WHERE id='".$row->id_ticket."'";
	$database->setQuery($sql);
	$ticket_info = null;
	$ticket_info = $database->loadObject();
	
	calendar_html::edit( $row, $lists, $date_task, $hour_task, $mins_task, $ticket_info );
}

function saveCalendar( $date, $taskhour, $taskmin, $status, $id_user ) {
	$database = JFactory::getDBO();
	$CONFIG = new JConfig();
	$mainframe = JFactory::getApplication();
	$user	= JFactory::getUser();
	$supportConfig = GetConfig();
	
	$taskfield = JRequest::getVar( 'taskfield', '', 'POST', 'string', 4 );
	$date = $date . " " . $taskhour . ":" . $taskmin . ":00";
	$database->setQuery( "INSERT INTO #__support_task(id_ticket, id_user, date_time, task, status) VALUES('0', '".$id_user."', ".$database->quote($date).", ".$database->quote($taskfield).", '".$status."')" );
	$database->query();
	
	// Informs the user about the task in case it's not the logged user
	if( $user->id != $id_user ) {
		$taskuser = null;
		$database->setQuery( "SELECT name, email FROM #__users WHERE id='".$id_user."'" );
		$taskuser = $database->loadObject();
		
		// ==================================================================================================================
		// Get the template for the page
		$tmpl_code->htmlcode = getSCTemplate( 0, 'mail/tsk_notify_new' );
		// ==================================================================================================================
		
		// Replaces message body variables for the values
		$msginfo->message = str_replace( "%ticket", '-', $tmpl_code->htmlcode );			// Replaces the %ticket
		$msginfo->message = str_replace( "%staff", $taskuser->name, $msginfo->message );					// Replaces the %staff
		$msginfo->message = str_replace( "%task",JRequest::getVar( 'taskfield', '', 'POST', 'string', 4 ), $msginfo->message );		// Replaces the %message
		$msginfo->message = str_replace( "%calendar", JURI::root(), $msginfo->message );			// Replaces the %email
		$msginfo->message = str_replace( "%url", JURI::root(), $msginfo->message );					// Replaces the %url
		
		$sendmail = JUtility::sendMail( $CONFIG->mailfrom, $CONFIG->sitename, $taskuser->email, JText::_('tsk_notify_new_subj'), $msginfo->message, 1 );
		if( $sendmail != true ) {
			print JText::_('mail_error');
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk", JText::_('task_saved')  );
}

?>
