<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.category.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'category', $task, $cid[0]);

switch ($task) {
	case "new":
		editCategory( 0 );
		break;

	case "edit":
		editCategory( $cid[0] );
		break;

	case "save":
		saveCategory();
		break;

	case "remove":
		removeCategory( $cid );
		break;

	case "publish":
		publishCategory( $cid, 1 );
		break;

	case "unpublish":
		publishCategory( $cid, 0 );
		break;

	default:
		showCategory();
		break;
}

/**
* Compiles a list of workgroups
* @param string The component name
*/
function showCategory() 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = JRequest::getInt( 'limitstart', 0 );
	$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
	
	// Build Workgroup select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('all'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist', $rows_wk, 'id_workgroup', 'class="inputbox" size="1" onchange="document.filterForm.submit();"', 'value', 'text', $id_workgroup);
	
	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_category ".($id_workgroup ? "WHERE id_workgroup=".$id_workgroup : "") );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$query = "SELECT c.id, c.name AS title, c.name, c.show, w.wkdesc as workgroup, c.parent AS parent_id, c.parent, c.tickets, c.downloads, c.kb, c.bugtracker, c.`discussions`, c.`level`"
	. "\nFROM #__support_category c, #__support_workgroup w"
	. "\nWHERE c.id_workgroup=w.id ".($id_workgroup ? "AND id_workgroup=".$id_workgroup : "")
	. "\n ORDER BY c.parent, c.name"
	;
	$database->setQuery( $query );
	$rows2 = $database->loadObjectList();

	// establish the hierarchy of the menu
	$children = array();
	// first pass - collect children
	foreach ($rows2 as $v ) {
		$pt = $v->parent;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push( $list, $v );
		$children[$pt] = $list;
	}
	// second pass - get an indent list of the items
	$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, max( 0, 10 ), 0, 0 );
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	// slice out elements based on limits
	$list = array_slice( $list, $pageNav->limitstart, $pageNav->limit );
	
	category_html::show( $list, $pageNav, $lists );
}

function Parent( &$row ) {
	$database = JFactory::getDBO();

	// get a list of the menu items
	$query = "SELECT c.id, c.name AS title, c.name, c.show, w.wkdesc as workgroup, c.parent, c.parent AS parent_id"
	. "\nFROM #__support_category c, #__support_workgroup w"
	. "\nWHERE c.id_workgroup=w.id"
	. "\n ORDER BY c.parent"
	;
	$database->setQuery( $query );
	$mitems = $database->loadObjectList();

	// establish the hierarchy of the menu
	$children = array();
	// first pass - collect children
	foreach ( $mitems as $v ) {
		$pt = $v->parent;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push( $list, $v );
		$children[$pt] = $list;
	}
	// second pass - get an indent list of the items
	$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );

	// assemble menu items to the array
	$mitems = array();
	$mitems[] = JHTML::_('select.option',  '0', JText::_('top') );

	$this_treename = '';
	foreach ( $list as $item ) {
		if ( $this_treename ) {
			if ( $item->id != $row->id && strpos( $item->name, $this_treename ) === false) {
				$mitems[] = JHTML::_('select.option',  $item->id, $item->name );
			}
		} else {
			//if ( $item->id != $row->id ) {
				$mitems[] = JHTML::_('select.option',  $item->id, $item->name );
			//} else {
			//	$this_treename = "$item->treename/";
			//}
		}
	}
	$parent = JHTML::_('select.genericlist', $mitems, 'parent', 'class="inputbox" size="1"', 'value', 'text', $row->parent );

	return $parent;
}

/**
* Compiles information to add or edit a category
* @param database A database connector object
* @param string The component name
*/
function editCategory( $uid=0 ) {
	$database = JFactory::getDBO();
	$row = new mosSupportCategory( $database );
	// load the row from the db table
	$row->load( $uid );

	// Build Workgroup select list
	$sql = "SELECT `id` AS value, `wkdesc` AS text FROM #__support_workgroup";
	$database->setQuery($sql);
	$rows_wk = $database->loadObjectList();
	$rows_wk = array_merge(array(JHTML::_('select.option', '0', JText::_('select3'))), $rows_wk);
	$lists['workgroup'] = JHTML::_('select.genericlist',$rows_wk, 'id_workgroup', 'class="inputbox" size="1"', 'value', 'text', $row->id_workgroup);
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );

	$lists['downloads'] = mqm_switchcheckbox('radio', 'downloads', $captions, $values, $row->downloads, 'switch');
	$lists['tickets'] = mqm_switchcheckbox('radio', 'tickets', $captions, $values, $row->tickets, 'switch');
	$lists['kb'] = mqm_switchcheckbox('radio', 'kb', $captions, $values, $row->kb, 'switch');
	$lists['discussions'] = mqm_switchcheckbox('radio', 'discussions', $captions, $values, $row->discussions, 'switch');
	$lists['bugtracker'] = mqm_switchcheckbox('radio', 'bugtracker', $captions, $values, $row->bugtracker, 'switch');
	$lists['show'] = mqm_switchcheckbox('radio', 'show', $captions, $values, $row->show, 'switch');

	$lists['parent'] = Parent( $row );

	category_html::edit( $row, $lists );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveCategory() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportCategory( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	
	// Update the category level
	if( $row->parent ) {
		// Get parent level
		$sql = "SELECT `level`
				FROM `#__support_category`
				WHERE `id`=".$row->parent;
		$database->setQuery( $sql );
		$level = $database->loadResult();
		// Increase the level of current category
		$sql = "UPDATE `#__support_category`
				SET `level`=".($level+1)."
				WHERE `id`=".$row->id;
		$database->setQuery( $sql );
		$database->query();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=category"  );
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function removeCategory( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script> alert('".JText::_('category_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_category WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=category"  );
}

/**
* Publishes or Unpublishes one or more workgroups
* @param database A database connector object
* @param array An array of unique workgroup id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The name of the component
*/
function publishCategory( $cid=null, $publish=1 ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script type='text/javascript'> alert('".JText::_('category_action')." ".$action."'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );
	$count = count( $cid );

	$database->setQuery( "UPDATE #__support_category SET `show`='$publish' WHERE id IN (".$database->quote($cids).")" );

	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=category"  );
}
?>
