<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.config.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// Include the HTML file
require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );
require_once( JPATH_SITE.'/components/com_maqmahelpdesk/maqmahelpdesk.class.php' );

// Activities logger
mqm_activitylog('admin', 'config', $task);

switch( $task ) {
    case "apply":
        SaveConfig( true );
        break;
		
    case "save":
        SaveConfig( false );
        break;
        
    case "ajax":
    	ConfigInclude();
    	break;

    default:
        ShowConfig();
        break;
}

function ConfigInclude()
{
	$page = JRequest::getCmd( 'page', '', '', 'string' );
	include_once (JPATH_SITE.'/administrator/components/com_maqmahelpdesk/ajax/'.$page.'.php');
}

function SaveConfig( $apply=false ) 
{
    $database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
    $row = new mosSupportConfig( $database );

    if (!$row->bind( $_POST )) {
        echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
    }
    if (!$row->check()) {
        echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
    }
    if (!$row->store()) {
        echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
    }

    $row->checkin();
	
	if( $apply ) {
		$mainframe->redirect("index.php?option=com_maqmahelpdesk&task=config", JText::_('config_saved') );
	}else{
		$mainframe->redirect("index.php?option=com_maqmahelpdesk", JText::_('config_saved') );
	}
}

function ShowConfig() {
    global $supportConfig;

	$database = JFactory::getDBO();
	
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/tablednd.min.js"></script>';
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists = array();
    $lists['post_kb_creation_in_wall'] = mqm_switchcheckbox('radio', 'post_kb_creation_in_wall', $captions, $values, $supportConfig->post_kb_creation_in_wall, 'switch');
    $lists['post_comments_in_wall'] = mqm_switchcheckbox('radio', 'post_comments_in_wall', $captions, $values, $supportConfig->post_comments_in_wall, 'switch');
    $lists['use_jomsocial_avatars'] = mqm_switchcheckbox('radio', 'use_jomsocial_avatars', $captions, $values, $supportConfig->use_jomsocial_avatars, 'switch');
    $lists['field_width'] = mqm_switchcheckbox('radio', 'field_width', $captions, $values, $supportConfig->field_width, 'switch');
    $lists['client_change_status'] = mqm_switchcheckbox('radio', 'client_change_status', $captions, $values, $supportConfig->client_change_status, 'switch');
    $lists['public_attach'] = mqm_switchcheckbox('radio', 'public_attach', $captions, $values, $supportConfig->public_attach, 'switch');
    $lists['receive_mail'] = mqm_switchcheckbox('radio', 'receive_mail', $captions, $values, $supportConfig->receive_mail, 'switch');
    $lists['ac_active'] = mqm_switchcheckbox('radio', 'ac_active', $captions, $values, $supportConfig->ac_active, 'switch');
    $lists['kb_popinfo'] = mqm_switchcheckbox('radio', 'kb_popinfo', $captions, $values, $supportConfig->kb_popinfo, 'switch');
    $lists['notify_rate'] = mqm_switchcheckbox('radio', 'notify_rate', $captions, $values, $supportConfig->notify_rate, 'switch');
    $lists['unregister'] = mqm_switchcheckbox('radio', 'unregister', $captions, $values, $supportConfig->unregister, 'switch');
    $lists['kb_moderate'] = mqm_switchcheckbox('radio', 'kb_moderate', $captions, $values, $supportConfig->kb_moderate, 'switch');
    $lists['faq_kb_manual'] = mqm_switchcheckbox('radio', 'faq_kb_manual', $captions, $values, $supportConfig->faq_kb_manual, 'switch');
    $lists['faq_kb_hits'] = mqm_switchcheckbox('radio', 'faq_kb_hits', $captions, $values, $supportConfig->faq_kb_hits, 'switch');
    $lists['readmail_create_user'] = mqm_switchcheckbox('radio', 'readmail_create_user', $captions, $values, $supportConfig->readmail_create_user, 'switch');
    $lists['license_agreement'] = mqm_switchcheckbox('radio', 'license_agreement', $captions, $values, $supportConfig->license_agreement, 'switch');
    $lists['company_info'] = mqm_switchcheckbox('radio', 'company_info', $captions, $values, $supportConfig->company_info, 'switch');
    $lists['create_client'] = mqm_switchcheckbox('radio', 'create_client', $captions, $values, $supportConfig->create_client, 'switch');
    $lists['rf_phone'] = mqm_switchcheckbox('radio', 'rf_phone', $captions, $values, $supportConfig->rf_phone, 'switch');
    $lists['rf_fax'] = mqm_switchcheckbox('radio', 'rf_fax', $captions, $values, $supportConfig->rf_fax, 'switch');
    $lists['rf_mobile'] = mqm_switchcheckbox('radio', 'rf_mobile', $captions, $values, $supportConfig->rf_mobile, 'switch');
    $lists['rf_address1'] = mqm_switchcheckbox('radio', 'rf_address1', $captions, $values, $supportConfig->rf_address1, 'switch');
    $lists['rf_address2'] = mqm_switchcheckbox('radio', 'rf_address2', $captions, $values, $supportConfig->rf_address2, 'switch');
    $lists['rf_zipcode'] = mqm_switchcheckbox('radio', 'rf_zipcode', $captions, $values, $supportConfig->rf_zipcode, 'switch');
    $lists['rf_location'] = mqm_switchcheckbox('radio', 'rf_location', $captions, $values, $supportConfig->rf_location, 'switch');
    $lists['rf_country'] = mqm_switchcheckbox('radio', 'rf_country', $captions, $values, $supportConfig->rf_country, 'switch');
    $lists['rf_city'] = mqm_switchcheckbox('radio', 'rf_city', $captions, $values, $supportConfig->rf_city, 'switch');
    $lists['users_registration'] = mqm_switchcheckbox('radio', 'users_registration', $captions, $values, $supportConfig->users_registration, 'switch');
    $lists['users_login'] = mqm_switchcheckbox('radio', 'users_login', $captions, $values, $supportConfig->users_login, 'switch');
    $lists['use_uncategorized'] = mqm_switchcheckbox('radio', 'use_uncategorized', $captions, $values, $supportConfig->use_uncategorized, 'switch');
    $lists['show_dashboard_support'] = mqm_switchcheckbox('radio', 'show_dashboard_support', $captions, $values, $supportConfig->show_dashboard_support, 'switch');
    $lists['show_dashboard_customer'] = mqm_switchcheckbox('radio', 'show_dashboard_customer', $captions, $values, $supportConfig->show_dashboard_customer, 'switch');
    $lists['anonymous_tickets'] = mqm_switchcheckbox('radio', 'anonymous_tickets', $captions, $values, $supportConfig->anonymous_tickets, 'switch');
    $lists['register_user_change_status'] = mqm_switchcheckbox('radio', 'register_user_change_status', $captions, $values, $supportConfig->register_user_change_status, 'switch');
    $lists['support_only_show_assign'] = mqm_switchcheckbox('radio', 'support_only_show_assign', $captions, $values, $supportConfig->support_only_show_assign, 'switch');
    $lists['support_workgroup_only'] = mqm_switchcheckbox('radio', 'support_workgroup_only', $captions, $values, $supportConfig->support_workgroup_only, 'switch');
    $lists['mail_queue'] = mqm_switchcheckbox('radio', 'mail_queue', $captions, $values, $supportConfig->mail_queue, 'switch');
    $lists['extra_email_notification'] = mqm_switchcheckbox('radio', 'extra_email_notification', $captions, $values, $supportConfig->extra_email_notification, 'switch');
    $lists['duedate_algoritm'] = mqm_switchcheckbox('radio', 'duedate_algoritm', $captions, $values, $supportConfig->duedate_algoritm, 'switch', 'duedate_cfg();');
    $lists['duedate_holidays'] = mqm_switchcheckbox('radio', 'duedate_holidays', $captions, $values, $supportConfig->duedate_holidays, 'switch');
    $lists['duedate_vacations'] = mqm_switchcheckbox('radio', 'duedate_vacations', $captions, $values, $supportConfig->duedate_vacations, 'switch');
    $lists['duedate_firstday'] = mqm_switchcheckbox('radio', 'duedate_firstday', $captions, $values, $supportConfig->duedate_firstday, 'switch');
    $lists['duedate_schedule'] = mqm_switchcheckbox('radio', 'duedate_schedule', $captions, $values, $supportConfig->duedate_schedule, 'switch');
    $lists['discussions_moderated'] = mqm_switchcheckbox('radio', 'discussions_moderated', $captions, $values, $supportConfig->discussions_moderated, 'switch');
    $lists['integrate_mtree'] = mqm_switchcheckbox('radio', 'integrate_mtree', $captions, $values, $supportConfig->integrate_mtree, 'switch');
    $lists['integrate_sobi'] = mqm_switchcheckbox('radio', 'integrate_sobi', $captions, $values, $supportConfig->integrate_sobi, 'switch');
    $lists['integrate_artofuser'] = mqm_switchcheckbox('radio', 'integrate_artofuser', $captions, $values, $supportConfig->integrate_artofuser, 'switch');
    $lists['use_cb_avatars'] = mqm_switchcheckbox('radio', 'use_cb_avatars', $captions, $values, $supportConfig->use_cb_avatars, 'switch');
    $lists['mobile_interface'] = mqm_switchcheckbox('radio', 'mobile_interface', $captions, $values, $supportConfig->mobile_interface, 'switch');
    $lists['js_post_question_wall'] = mqm_switchcheckbox('radio', 'js_post_question_wall', $captions, $values, $supportConfig->js_post_question_wall, 'switch');
    $lists['js_post_answer_wall'] = mqm_switchcheckbox('radio', 'js_post_answer_wall', $captions, $values, $supportConfig->js_post_answer_wall, 'switch');
    $lists['js_post_votes_wall'] = mqm_switchcheckbox('radio', 'js_post_votes_wall', $captions, $values, $supportConfig->js_post_votes_wall, 'switch');
    $lists['js_answer_selected_wall'] = mqm_switchcheckbox('radio', 'js_answer_selected_wall', $captions, $values, $supportConfig->js_answer_selected_wall, 'switch');
    $lists['profile_required'] = mqm_switchcheckbox('radio', 'profile_required', $captions, $values, $supportConfig->profile_required, 'switch');
    $lists['stopspam'] = mqm_switchcheckbox('radio', 'stopspam', $captions, $values, $supportConfig->stopspam, 'switch');
    $lists['hide_powered'] = mqm_switchcheckbox('radio', 'hide_powered', $captions, $values, $supportConfig->hide_powered, 'switch');
    $lists['common_ticket_views'] = mqm_switchcheckbox('radio', 'common_ticket_views', $captions, $values, $supportConfig->common_ticket_views, 'switch');
    $lists['use_merge'] = mqm_switchcheckbox('radio', 'use_merge', $captions, $values, $supportConfig->use_merge, 'switch');
    $lists['use_as_reply'] = mqm_switchcheckbox('radio', 'use_as_reply', $captions, $values, $supportConfig->use_as_reply, 'switch');
    $lists['use_parent'] = mqm_switchcheckbox('radio', 'use_parent', $captions, $values, $supportConfig->use_parent, 'switch');
    $lists['use_travel'] = mqm_switchcheckbox('radio', 'use_travel', $captions, $values, $supportConfig->use_travel, 'switch');
    $lists['use_type'] = mqm_switchcheckbox('radio', 'use_type', $captions, $values, $supportConfig->use_type, 'switch');
    $lists['integrate_jbolo'] = mqm_switchcheckbox('radio', 'integrate_jbolo', $captions, $values, $supportConfig->integrate_jbolo, 'switch');
    $lists['integrate_digistore'] = mqm_switchcheckbox('radio', 'integrate_digistore', $captions, $values, $supportConfig->integrate_digistore, 'switch');
    $lists['growl_notifications'] = mqm_switchcheckbox('radio', 'growl_notifications', $captions, $values, $supportConfig->growl_notifications, 'switch');
    $lists['kb_approvement'] = mqm_switchcheckbox('radio', 'kb_approvement', $captions, $values, $supportConfig->kb_approvement, 'switch');
    
    // Build the number of offset list
	$offsetlist[] = JHTML::_( 'select.option', '-12', '-12:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-11', '-11:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-10', '-10:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-9.5', '-09:30' );
	$offsetlist[] = JHTML::_( 'select.option', '-9', '-09:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-8', '-08:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-7', '-07:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-6', '-06:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-5', '-05:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-4.5', '-04:30' );
	$offsetlist[] = JHTML::_( 'select.option', '-4', '-04:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-3.5', '-03:30' );
	$offsetlist[] = JHTML::_( 'select.option', '-3', '-03:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-2', '-02:00' );
	$offsetlist[] = JHTML::_( 'select.option', '-1', '-01:00' );
	$offsetlist[] = JHTML::_( 'select.option', '0', 'n/a' );
	$offsetlist[] = JHTML::_( 'select.option', '1', '+01:00' );
	$offsetlist[] = JHTML::_( 'select.option', '2', '+02:00' );
	$offsetlist[] = JHTML::_( 'select.option', '3', '+03:00' );
	$offsetlist[] = JHTML::_( 'select.option', '3.5', '+03:30' );
	$offsetlist[] = JHTML::_( 'select.option', '4', '+04:00' );
	$offsetlist[] = JHTML::_( 'select.option', '4.5', '+04:30' );
	$offsetlist[] = JHTML::_( 'select.option', '5', '+05:00' );
	$offsetlist[] = JHTML::_( 'select.option', '5.5', '+05:30' );
	$offsetlist[] = JHTML::_( 'select.option', '5.75', '+05:45' );
	$offsetlist[] = JHTML::_( 'select.option', '6', '+06:00' );
	$offsetlist[] = JHTML::_( 'select.option', '6.5', '+06:30' );
	$offsetlist[] = JHTML::_( 'select.option', '7', '+07:00' );
	$offsetlist[] = JHTML::_( 'select.option', '8', '+08:00' );
	$offsetlist[] = JHTML::_( 'select.option', '8.75', '+08:45' );
	$offsetlist[] = JHTML::_( 'select.option', '9', '+09:00' );
	$offsetlist[] = JHTML::_( 'select.option', '9.5', '+09:30' );
	$offsetlist[] = JHTML::_( 'select.option', '10', '+10:00' );
	$offsetlist[] = JHTML::_( 'select.option', '10.5', '+10:30' );
	$offsetlist[] = JHTML::_( 'select.option', '11', '+11:00' );
	$offsetlist[] = JHTML::_( 'select.option', '11.5', '+11:30' );
	$offsetlist[] = JHTML::_( 'select.option', '12', '+12:00' );
	$offsetlist[] = JHTML::_( 'select.option', '12.75', '+12:45' );
	$offsetlist[] = JHTML::_( 'select.option', '13', '+13:00' );
	$offsetlist[] = JHTML::_( 'select.option', '14', '+14:00' );
	$lists['offset'] = JHTML::_('select.genericlist', $offsetlist, 'offset', 'class="inputbox" size="1"', 'value', 'text', $supportConfig->offset );
    
    // Build the number of attachs list
    $attachslist[] = JHTML::_('select.option',  '1', '1' );
    $attachslist[] = JHTML::_('select.option',  '2', '2' );
    $attachslist[] = JHTML::_('select.option',  '3', '3' );
    $attachslist[] = JHTML::_('select.option',  '4', '4' );
    $lists['attachs_num'] = JHTML::_('select.genericlist', $attachslist, 'attachs_num', 'class="inputbox" size="1"', 'value', 'text', $supportConfig->attachs_num );

    // Build the less rate list
    $lessrate[] = JHTML::_('select.option',  '1', '1' );
    $lessrate[] = JHTML::_('select.option',  '2', '2' );
    $lessrate[] = JHTML::_('select.option',  '3', '3' );
    $lessrate[] = JHTML::_('select.option',  '4', '4' );
    $lessrate[] = JHTML::_('select.option',  '5', '5' );
    $lists['less_rate'] = JHTML::_('select.genericlist', $lessrate, 'less_rate', 'class="inputbox" size="1"',
    'value', 'text', $supportConfig->less_rate );

    // Build the weekday list
    $weekday[] = JHTML::_('select.option',  '0', JText::_('week_full_sunday') );
    $weekday[] = JHTML::_('select.option',  '1', JText::_('week_full_monday') );
    $weekday[] = JHTML::_('select.option',  '2', JText::_('week_full_tuesday') );
    $weekday[] = JHTML::_('select.option',  '3', JText::_('week_full_wednesday') );
    $weekday[] = JHTML::_('select.option',  '4', JText::_('week_full_thursday') );
    $weekday[] = JHTML::_('select.option',  '5', JText::_('week_full_friday') );
    $weekday[] = JHTML::_('select.option',  '6', JText::_('week_full_saturday') );
    $lists['week_start'] = JHTML::_('select.genericlist', $weekday, 'week_start', 'class="inputbox" size="1"',
    'value', 'text', $supportConfig->week_start );

    // Build the Source select list
    $sourcelist[] = JHTML::_('select.option', '', JText::_('selectlist'));
    $sourcelist[] = JHTML::_('select.option', 'F', JText::_('fax'));
    $sourcelist[] = JHTML::_('select.option', 'P', JText::_('phone'));
    $sourcelist[] = JHTML::_('select.option', 'M', JText::_('email'));
    $sourcelist[] = JHTML::_('select.option', 'W', JText::_('website'));
    $sourcelist[] = JHTML::_('select.option', 'O', JText::_('other'));
    $lists['source'] = JHTML::_('select.genericlist',$sourcelist, 'default_source', 'class="inputbox" size="1"', 'value', 'text', $supportConfig->default_source);
	
    // Support user types select list
    $sup_usertype[] = JHTML::_('select.option',  '7', JText::_('manager') );
    $sup_usertype[] = JHTML::_('select.option',  '6', JText::_('team_leader') );
    $sup_usertype[] = JHTML::_('select.option',  '5', JText::_('support_user') );
    $lists['sup_usertype'] = JHTML::_('select.genericlist',$sup_usertype, 'support_change_status', 'class="inputbox" size="1"', 'value', 'text', $supportConfig->support_change_status );

    // Get user schedules
    $database->setQuery( "SELECT id, profile FROM #__support_schedule ORDER BY id, profile ");
    $schedules_list = $database->loadObjectList();
    $numb_schedules = sizeof($schedules_list);

    $arr = array();
    for ($i = 0; $i < $numb_schedules; $i++) {
		$arr[] = get_object_vars($schedules_list[$i]);
    }
    $schedules[] = JHTML::_('select.option',  '0', JText::_('schedule_select') );
    for ($i=0; $i < $numb_schedules; $i++) {
		$schedules[] = JHTML::_('select.option', $arr[$i]['id'], $arr[$i]['profile']);
    }
    $lists['schedules'] = JHTML::_('select.genericlist',$schedules, 'id_schedule_default', 'class="inputbox" size="1"', 'value', 'text', $supportConfig->id_schedule_default);

    HTML_config::configForm( $lists );
}
