<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.holidays.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );


// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'holidays', $task, $cid[0]);

switch( $task ) {

	case "new":
		editHoliday( 0 );
		break;

	case "edit":
		editHoliday( $cid[0] );		// edita o 1 selecionado das checkboxes
		break;

	case "save":
		saveHoliday();
		break;

	case "remove":
		removeHoliday( $cid );		// pode eliminar vrios (com checkbox)
		break;

	default:
		showHoliday();
		break;
}

function showHoliday() { 
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	
	$sql = "SELECT count(h.holiday_date) 
			FROM #__support_holidays h 
			WHERE (YEAR(h.holiday_date)='0000' OR h.holiday_date > CURDATE() ) 
			ORDER BY h.holiday_date DESC";
	$database->setQuery( $sql );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	if ($total > 0) {
		$sql = "SELECT * 
				FROM #__support_holidays h 
				WHERE (YEAR(h.holiday_date)='0000' OR h.holiday_date > CURDATE()) 
				ORDER BY h.holiday_date ";
		$database->setQuery( $sql,$pageNav->limitstart, $pageNav->limit );

		$rows = $database->loadObjectList();
		if ($database->getErrorNum()) {
			echo $database->stderr();
			return false;
		}
	}

	holidays_html::show( $rows, $pageNav );
	
} 

function editHoliday( $hid=0 ) {
	$database = JFactory::getDBO();
	$holidayInfo = new mosSupportHolidays( $database );
	// load the row from the db table
	$holidayInfo->load( $hid );

	$lists = "";
	
	holidays_html::edit( $holidayInfo, $lists );
	
} 

function saveHoliday() { 
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new  mosSupportHolidays( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	
//	$row->checkin();

	$id 					= intval( JRequest::getVar( 'id', '', '', 'int' ) );
	$holiday_date 			= JRequest::getVar( 'holiday_date', '0000-00-00', '', 'string' );
	$name 					= JRequest::getVar( 'name', '', '', 'string' );

	$query = "UPDATE #__support_holidays SET `holiday_date` = ".$database->quote($holiday_date).", `name` = ".$database->quote($name)." WHERE `id` = ".$id." ";
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=holidays" );
} 


function removeHoliday( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	// pode escolher mais de uma checkbox para eliminar
	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		echo "<script type='text/javascript'> alert('".JText::_('todo')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_holidays WHERE id IN (".$database->quote($cids).")");
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=holidays" );
}

?>