<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.licenses.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'licenses', $task, $cid[0]);

switch ($task) {
	case "new":
		editLicenses( 0 );
		break;

	case "edit":
		editLicenses( $cid[0] );
		break;

	case "save":
		saveLicenses();
		break;

	case "remove":
		removeLicenses( $cid );
		break;

	default:
		showLicenses();
		break;
}

/**
* Compiles a list of priorities
* @param string The component name
*/
function showLicenses() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_dl_license" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

		jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT *"
	. "\nFROM #__support_dl_license"
	. "\nORDER BY `title`",
	$pageNav->limitstart, $pageNav->limit
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	license_html::show( $rows, $pageNav );
}

/**
* Compiles information to add or edit a priority
* @param database A database connector object
* @param string The component name
*/
function editLicenses( $uid=0 ) {
	$database = JFactory::getDBO();

	$row = new mosSupportLicenses( $database );
	// load the row from the db table
	$row->load( $uid );

	license_html::edit( $row );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveLicenses() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportLicenses( $database );

	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$row->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=licenses" );
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the priority section
* @param array An array of unique priority id numbers
*/
function removeLicenses( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('license_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__support_dl_license WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=licenses" );
}
?>