<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.tools.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );

if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'tools', $task, $cid[0]);

switch ($task) 
{
	case "db1":
		DB1();
		break;
	case "db2":
		DB2();
		break;
	case "billets1":
		Billets1();
		break;
	case "billets2":
		Billets2();
		break;
	case "ambrasubs1":
		Ambrasubs1();
		break;
	case "ambrasubs2":
		Ambrasubs2();
		break;
	case "rstickets1":
		RSTickets1();
		break;
	case "rstickets2":
		RSTickets2();
		break;
}

function RSTickets1() 
{
	$database = JFactory::getDBO();
	
	$sql = "SELECT COUNT(*) FROM #__rstickets_tickets";
	$database->setQuery( $sql );
	$lists['tickets'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__rstickets_files";
	$database->setQuery( $sql );
	$lists['files'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__rstickets_ticket_message";
	$database->setQuery( $sql );
	$lists['messages'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__rstickets_departments";
	$database->setQuery( $sql );
	$lists['departments'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__rstickets_custom_fields";
	$database->setQuery( $sql );
	$lists['cfields'] = $database->loadResult();
	
	tools_html::rstickets1( $lists, 0 );
}

function RSTickets2() 
{
	$database = JFactory::getDBO();
	
	// Get default priority
	
	// Clean attachments
	$sql = "DELETE FROM `#__support_file` WHERE `source`='T'";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean notes
	$sql = "DELETE FROM `#__support_note`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean messages
	$sql = "DELETE FROM `#__support_ticket_resp`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean categories
	$sql = "DELETE FROM `#__support_category`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean statuses
	$sql = "DELETE FROM `#__support_status`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean tickets
	$sql = "DELETE FROM `#__support_ticket`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import attachments
	$sql = "INSERT INTO `#__support_file`(`id_file`, `id`, `date`, `id_user`, `source`, `filename`, `public`, `description`)
			SELECT `id`, `ticketid`, `datetime`, `userid`, 'T', `physicalname`, 1, `` FROM `#__billets_files`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import notes
	$sql = "INSERT INTO `#__support_note`(`id`, `id_ticket`, `id_user`, `date_time`, `note`, `show`)
			SELECT `id`, `ticketid`, `userid`, `datetime`, `message`, 1 FROM `#__billets_comments`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import messages
	$sql = "INSERT INTO `#__support_ticket_resp`(`id`, `id_ticket`, `id_user`, `date`, `message`, `reply_summary`)
			SELECT `id`, `ticketid`, `userid_from`, `datetime`, `message`, `subject` FROM `#__billets_messages`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import categories
	$sql = "INSERT INTO `#__support_category`(`id`, `name`, `show`, `id_workgroup`, `parent`)
			SELECT `id`, `title`, `enabled`, 1, `parent` FROM `#__billets_categories` WHERE `isroot`!=1";
	$database->setQuery( $sql );
	$database->query();
	
	// Import statuses
	$sql = "INSERT INTO `#__support_status`(`id`, `description`, `show`, `isdefault`, `status_group`, `user_access`, `allow_old_status_back`, `ticket_side`, `status_workflow`)
			SELECT `id`, `title`, `enabled`, 0, 'O', 1, 1, 0, '' FROM `#__billets_ticketstates`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import tickets - falta colocar a priority por defeito
	$sql = "INSERT INTO `#__support_ticket`(`id`, `id_user`, `subject`, `message`, `id_status`, `date`, `last_update`, `id_category`, `id_priority`, `ticketmask`, `id_client`, `day_week`, `an_name`, `an_mail`, `duedate`, `id_workgroup`)
			SELECT `id`, `sender_userid`, `title`, `description`, `stateid`, `created_datetime`, `last_modified_datetime`, `categoryid`, 1, '', 0, 0, '', '', `last_modified_datetime`, 1 FROM `#__billets_tickets`";
	$database->setQuery( $sql );
	$database->query();
	
	// Updates some extra details on tickets
	/*
		copiar os ficheiros
		actualizar os workflows dos estados
		actualizar os dias da semana nos tickets
		actualizar os ticketmasks nos tickets
		actualizar o nome e o email da pessoa nos tickets
	 */ 
	
	tools_html::rstickets1( $lists, 1 );
}

function Billets1() 
{
	$database = JFactory::getDBO();
	
	$sql = "SELECT COUNT(*) FROM #__billets_tickets";
	$database->setQuery( $sql );
	$lists['tickets'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_categories";
	$database->setQuery( $sql );
	$lists['categories'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_ticketstates";
	$database->setQuery( $sql );
	$lists['status'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_files";
	$database->setQuery( $sql );
	$lists['files'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_comments";
	$database->setQuery( $sql );
	$lists['notes'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_messages";
	$database->setQuery( $sql );
	$lists['messages'] = $database->loadResult();
	
	tools_html::billets1( $lists, 0 );
}

function Billets2() 
{
	$database = JFactory::getDBO();
	
	// Get default priority
	
	// Clean attachments
	$sql = "DELETE FROM `#__support_file` WHERE `source`='T'";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean notes
	$sql = "DELETE FROM `#__support_note`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean messages
	$sql = "DELETE FROM `#__support_ticket_resp`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean categories
	$sql = "DELETE FROM `#__support_category`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean statuses
	$sql = "DELETE FROM `#__support_status`";
	$database->setQuery( $sql );
	$database->query();
	
	// Clean tickets
	$sql = "DELETE FROM `#__support_ticket`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import attachments
	$sql = "INSERT INTO `#__support_file`(`id_file`, `id`, `date`, `id_user`, `source`, `filename`, `public`, `description`)
			SELECT `id`, `ticketid`, `datetime`, `userid`, 'T', `physicalname`, 1, `` FROM `#__billets_files`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import notes
	$sql = "INSERT INTO `#__support_note`(`id`, `id_ticket`, `id_user`, `date_time`, `note`, `show`)
			SELECT `id`, `ticketid`, `userid`, `datetime`, `message`, 1 FROM `#__billets_comments`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import messages
	$sql = "INSERT INTO `#__support_ticket_resp`(`id`, `id_ticket`, `id_user`, `date`, `message`, `reply_summary`)
			SELECT `id`, `ticketid`, `userid_from`, `datetime`, `message`, `subject` FROM `#__billets_messages`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import categories
	$sql = "INSERT INTO `#__support_category`(`id`, `name`, `show`, `id_workgroup`, `parent`)
			SELECT `id`, `title`, `enabled`, 1, `parent` FROM `#__billets_categories` WHERE `isroot`!=1";
	$database->setQuery( $sql );
	$database->query();
	
	// Import statuses
	$sql = "INSERT INTO `#__support_status`(`id`, `description`, `show`, `isdefault`, `status_group`, `user_access`, `allow_old_status_back`, `ticket_side`, `status_workflow`)
			SELECT `id`, `title`, `enabled`, 0, 'O', 1, 1, 0, '' FROM `#__billets_ticketstates`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import tickets - falta colocar a priority por defeito
	$sql = "INSERT INTO `#__support_ticket`(`id`, `id_user`, `subject`, `message`, `id_status`, `date`, `last_update`, `id_category`, `id_priority`, `ticketmask`, `id_client`, `day_week`, `an_name`, `an_mail`, `duedate`, `id_workgroup`)
			SELECT `id`, `sender_userid`, `title`, `description`, `stateid`, `created_datetime`, `last_modified_datetime`, `categoryid`, 1, '', 0, 0, '', '', `last_modified_datetime`, 1 FROM `#__billets_tickets`";
	$database->setQuery( $sql );
	$database->query();
	
	// Updates some extra details on tickets
	/*
		copiar os ficheiros
		actualizar os workflows dos estados
		actualizar os dias da semana nos tickets
		actualizar os ticketmasks nos tickets
		actualizar o nome e o email da pessoa nos tickets
	 */ 
	
	tools_html::billets1( $lists, 1 );
}

function Ambrasubs1() 
{
	$database = JFactory::getDBO();
	
	$sql = "SELECT COUNT(*) FROM #__billets_tickets";
	$database->setQuery( $sql );
	$lists['tickets'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_categories";
	$database->setQuery( $sql );
	$lists['categories'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_ticketstates";
	$database->setQuery( $sql );
	$lists['status'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_files";
	$database->setQuery( $sql );
	$lists['files'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_comments";
	$database->setQuery( $sql );
	$lists['notes'] = $database->loadResult();
	
	$sql = "SELECT COUNT(*) FROM #__billets_messages";
	$database->setQuery( $sql );
	$lists['messages'] = $database->loadResult();
	
	tools_html::ambrasubs1( $lists, 0 );
}

function Ambrasubs2() 
{
	$database = JFactory::getDBO();
	
	// Get default priority
	
	// Clean categories
	$sql = "DELETE FROM `#__support_dl_category`";
	$database->setQuery( $sql );
	$database->query();
	
	// Import categories
	$sql = "INSERT INTO `#__support_dl_category`(`id`, `name`, `show`, `id_workgroup`, `parent`)
			SELECT `id`, `title`, `enabled`, 1, `parent` FROM `#__billets_categories` WHERE `isroot`!=1";
	$database->setQuery( $sql );
	$database->query();
	
	// Updates some extra details on tickets
	/*
		copiar os ficheiros
	 */ 
	
	tools_html::ambrasubs1( $lists, 1 );
}

function DB1() 
{
	$database = JFactory::getDBO();
		
	$sql = "SELECT COUNT(*) FROM #__support_category WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup)";
	$database->setQuery( $sql );
	$lists['categories'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_kb_category WHERE id_category NOT IN (SELECT id FROM #__support_category)";
	$database->setQuery( $sql );
	$lists['kb_categories'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_announce WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) AND id_workgroup>0";
	$database->setQuery( $sql );
	$lists['announces'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_wk_fields WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup)";
	$database->setQuery( $sql );
	$lists['wk_fields'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_field_value WHERE id_field NOT IN (SELECT id FROM #__support_wk_fields)";
	$database->setQuery( $sql );
	$lists['field_values'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_permission WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$lists['support_staff'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_kb_comment WHERE id_kb NOT IN (SELECT id FROM #__support_kb)";
	$database->setQuery( $sql );
	$lists['kb_comments'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_kb_category WHERE id_kb NOT IN (SELECT id FROM #__support_kb) OR id_category NOT IN (SELECT id FROM #__support_category)";
	$database->setQuery( $sql );
	$lists['kb_categories'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_client_users WHERE id_user NOT IN (SELECT id FROM #__users) OR id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_users'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_ticket_resp WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket)";
	$database->setQuery( $sql );
	$lists['ticket_replies'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_rate WHERE id_table NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users) AND source='T'";
	$database->setQuery( $sql );
	$lists['ticket_rates'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_rate WHERE id_table NOT IN (SELECT id FROM #__support_kb) OR id_user NOT IN (SELECT id FROM #__users) AND source='K'";
	$database->setQuery( $sql );
	$lists['kb_rates'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_client_wk WHERE (id_workgroup NOT IN (SELECT id FROM #__support_workgroup) AND id_workgroup>0) OR id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_wks'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_client_info WHERE id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_info'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_contract WHERE id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_contracts'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_note WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$lists['ticket_notes'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_task WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$lists['tasks'] = $database->loadResult();

	// <!-- added 02-01-2009 -->
	$sql = "SELECT COUNT(*) FROM #__support_ticket WHERE id_priority  NOT IN (SELECT id FROM #__support_priority)";
	$database->setQuery( $sql );
	$lists['tickets_priorities'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_ticket WHERE id_status  NOT IN (SELECT id FROM #__support_status)";
	$database->setQuery( $sql );
	$lists['tickets_status'] = $database->loadResult();

	tools_html::db1( $lists, 0 );
}

function DB2() 
{
	$database = JFactory::getDBO();
	
	$sql = "SELECT COUNT(*) FROM #__support_category WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup)";
	$database->setQuery( $sql );
	$lists['categories'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_kb_category WHERE id_category NOT IN (SELECT id FROM #__support_category)";
	$database->setQuery( $sql );
	$lists['kb_categories'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_announce WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) AND id_workgroup>0";
	$database->setQuery( $sql );
	$lists['announces'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_wk_fields WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup)";
	$database->setQuery( $sql );
	$lists['wk_fields'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_field_value WHERE id_field NOT IN (SELECT id FROM #__support_wk_fields)";
	$database->setQuery( $sql );
	$lists['field_values'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_permission WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$lists['support_staff'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_kb_comment WHERE id_kb NOT IN (SELECT id FROM #__support_kb)";
	$database->setQuery( $sql );
	$lists['kb_comments'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_kb_category WHERE id_kb NOT IN (SELECT id FROM #__support_kb) OR id_category NOT IN (SELECT id FROM #__support_category)";
	$database->setQuery( $sql );
	$lists['kb_categories'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_client_users WHERE id_user NOT IN (SELECT id FROM #__users) OR id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_users'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_ticket_resp WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket)";
	$database->setQuery( $sql );
	$lists['ticket_replies'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_rate WHERE id_table NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users) AND source='T'";
	$database->setQuery( $sql );
	$lists['ticket_rates'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_rate WHERE id_table NOT IN (SELECT id FROM #__support_kb) OR id_user NOT IN (SELECT id FROM #__users) AND source='K'";
	$database->setQuery( $sql );
	$lists['kb_rates'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_client_wk WHERE (id_workgroup NOT IN (SELECT id FROM #__support_workgroup) AND id_workgroup>0) OR id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_wks'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_client_info WHERE id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_info'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_contract WHERE id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$lists['client_contracts'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_note WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$lists['ticket_notes'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_task WHERE (id_ticket NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users)) AND id_ticket > 0";
	$database->setQuery( $sql );
	$lists['tasks'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_ticket WHERE id_priority  NOT IN (SELECT id FROM #__support_priority)";
	$database->setQuery( $sql );
	$lists['tickets_priorities'] = $database->loadResult();

	$sql = "SELECT COUNT(*) FROM #__support_ticket WHERE id_status  NOT IN (SELECT id FROM #__support_status)";
	$database->setQuery( $sql );
	$lists['tickets_status'] = $database->loadResult();
	
	// Delete from database
	$sql = "DELETE FROM #__support_category WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_kb_category WHERE id_category NOT IN (SELECT id FROM #__support_category)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_announce WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) AND id_workgroup>0";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_wk_fields WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_field_value WHERE id_field NOT IN (SELECT id FROM #__support_wk_fields)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_permission WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_kb_comment WHERE id_kb NOT IN (SELECT id FROM #__support_kb)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_kb_category WHERE id_kb NOT IN (SELECT id FROM #__support_kb) OR id_category NOT IN (SELECT id FROM #__support_category)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_client_users WHERE id_user NOT IN (SELECT id FROM #__users) OR id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_ticket_resp WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_rate WHERE id_table NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users) AND source='T'";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_rate WHERE id_table NOT IN (SELECT id FROM #__support_kb) OR id_user NOT IN (SELECT id FROM #__users) AND source='K'";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_client_wk WHERE id_workgroup NOT IN (SELECT id FROM #__support_workgroup) OR id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_client_info WHERE id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_contract WHERE id_client NOT IN (SELECT id FROM #__support_client)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_note WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users)";
	$database->setQuery( $sql );
	$database->query();

	$sql = "DELETE FROM #__support_task WHERE (id_ticket NOT IN (SELECT id FROM #__support_ticket) OR id_user NOT IN (SELECT id FROM #__users)) AND id_ticket > 0";
	$database->setQuery( $sql );
	$database->query();

	$sql = "SELECT ID FROM #__support_priority WHERE isdefault = '1'";
	$database->setQuery( $sql );
	$default_priority = $database->loadResult();
	$sql = "UPDATE #__support_ticket SET id_priority='".$default_priority."' WHERE (id_priority NOT IN (SELECT id FROM #__support_priority))";
	$database->setQuery( $sql );

	$sql = "SELECT ID FROM #__support_status WHERE isdefault = '1'";
	$database->setQuery( $sql );
	$default_status = $database->loadResult();
	$sql = "UPDATE #__support_ticket SET id_status='".$default_status."' WHERE (id_status NOT IN (SELECT id FROM #__support_status))";
	$database->setQuery( $sql );

	
	tools_html::db1( $lists, 1 );
}
