<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.workgroup.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "components/com_maqmahelpdesk/html/admin.$function.html.php" );

// get parameters from the URL or submitted form
$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
if (!is_array( $cid )) {
	$cid = array(0);
}

// Activities logger
mqm_activitylog('admin', 'workgroup', $task, $cid[0]);

switch ($task) {
	case "new":
		editWK( 0 );
		break;

	case "edit":
		editWK( $cid[0] );
		break;

	case "apply":
		saveWK( 1 );
		break;

	case "save":
		saveWK( 0 );
		break;

	case "remove":
		removeWK( $cid );
		break;

	case "publish":
		publishWK( $cid, 1 );
		break;

	case "unpublish":
		publishWK( $cid, 0 );
		break;

	case 'saveorder':
		saveOrder();
		break;
        
    case "ajax":
    	ConfigInclude();
    	break;

	default:
		showWK();
		break;
}

function ConfigInclude()
{
	$page = JRequest::getCmd( 'page', '', '', 'string' );
	include_once (JPATH_SITE.'/administrator/components/com_maqmahelpdesk/ajax/'.$page.'.php');
}

/**
* Compiles a list of workgroups
* @param string The component name
*/
function showWK() 
{
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/tablednd.min.js"></script>';

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_workgroup ORDER BY wkdesc" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

	jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$database->setQuery( "SELECT w.id, w.wkdesc, w.wkmail_address, w.wkmail_address_name, w.show, w.contract, w.ordering"
	. "\nFROM #__support_workgroup w"
	. "\nORDER BY w.ordering",
	$pageNav->limitstart, $pageNav->limit 
	);

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	wk_html::show( $rows, $pageNav );
}

/**
* Compiles information to add or edit a section
* @param database A database connector object
* @param string The component name
*/
function editWK( $uid=0 ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportWK( $database );
	
	// load the row from the db table
	$row->load( $uid );
	
	echo '<script type="text/javascript" src="../components/com_maqmahelpdesk/js/tablednd.min.js"></script>';
	
	$captions = array( JText::_('MQ_NO'), JText::_('MQ_YES') );
	$values = array( '0', '1' );
	
	$lists['show'] = mqm_switchcheckbox('radio', 'show', $captions, $values, $row->show, 'switch');
	$lists['trouble'] = mqm_switchcheckbox('radio', 'trouble', $captions, $values, $row->trouble, 'switch');
	$lists['wkticket'] = mqm_switchcheckbox('radio', 'wkticket', $captions, $values, $row->wkticket, 'switch');
	$lists['wkkb'] = mqm_switchcheckbox('radio', 'wkkb', $captions, $values, $row->wkkb, 'switch');
	$lists['wkdownloads'] = mqm_switchcheckbox('radio', 'wkdownloads', $captions, $values, $row->wkdownloads, 'switch');
	$lists['wkemail'] = mqm_switchcheckbox('radio', 'wkemail', $captions, $values, $row->wkemail, 'switch');
	$lists['wkfaq'] = mqm_switchcheckbox('radio', 'wkfaq', $captions, $values, $row->wkfaq, 'switch');
	$lists['wkglossary'] = mqm_switchcheckbox('radio', 'wkglossary', $captions, $values, $row->wkglossary, 'switch');
	$lists['wkannounces'] = mqm_switchcheckbox('radio', 'wkannounces', $captions, $values, $row->wkannounces, 'switch');
	$lists['contract'] = mqm_switchcheckbox('radio', 'contract', $captions, $values, $row->contract, 'switch');
	$lists['use_activity'] = mqm_switchcheckbox('radio', 'use_activity', $captions, $values, $row->use_activity, 'switch');
	$lists['logo_remove'] = mqm_switchcheckbox('radio', 'logo_remove', $captions, $values, 0, 'switch');
	$lists['lim_actmsgs'] = mqm_switchcheckbox('radio', 'lim_actmsgs', $captions, $values, $row->lim_actmsgs, 'switch');
	$lists['lim_actwords'] = mqm_switchcheckbox('radio', 'lim_actwords', $captions, $values, $row->lim_actwords, 'switch');
	$lists['hyper_links'] = mqm_switchcheckbox('radio', 'hyper_links', $captions, $values, $row->hyper_links, 'switch');
	$lists['tkt_crt_nfy_mgr'] = mqm_switchcheckbox('radio', 'tkt_crt_nfy_mgr', $captions, $values, $row->tkt_crt_nfy_mgr, 'switch');
	$lists['tkt_crt_nfy_admin'] = mqm_switchcheckbox('radio', 'tkt_crt_nfy_admin', $captions, $values, $row->tkt_crt_nfy_admin, 'switch');
	$lists['tkt_asgn_old_asgn'] = mqm_switchcheckbox('radio', 'tkt_asgn_old_asgn', $captions, $values, $row->tkt_asgn_old_asgn, 'switch');
	$lists['tkt_asgn_new_asgn'] = mqm_switchcheckbox('radio', 'tkt_asgn_new_asgn', $captions, $values, $row->tkt_asgn_new_asgn, 'switch');
	$lists['tkt_asgn_nfy_usr_one'] = mqm_switchcheckbox('radio', 'tkt_asgn_nfy_usr_one', $captions, $values, $row->tkt_asgn_nfy_usr_one, 'switch');
	$lists['enable_discussions'] = mqm_switchcheckbox('radio', 'enable_discussions', $captions, $values, $row->enable_discussions, 'switch');
	$lists['contract_total_disable'] = mqm_switchcheckbox('radio', 'contract_total_disable', $captions, $values, $row->contract_total_disable, 'switch');
	$lists['use_account'] = mqm_switchcheckbox('radio', 'use_account', $captions, $values, $row->use_account, 'switch');
	$lists['use_bookmarks'] = mqm_switchcheckbox('radio', 'use_bookmarks', $captions, $values, $row->use_bookmarks, 'switch');
	$lists['add_mail_tag'] = mqm_switchcheckbox('radio', 'add_mail_tag', $captions, $values, $row->add_mail_tag, 'switch');
	$lists['digistore'] = mqm_switchcheckbox('radio', 'digistore', $captions, $values, $row->digistore, 'switch');
    
	$lists['wklogo_browse'] = '<input class="text_area" type="file" name="logo" size="50" maxlength="300" />';
	$lists['lim_actmsgs_chars']	= '<input class="text_area" type="text" name="lim_actmsgs_chars" size="5" maxlength="4" valign="top" value="'.$row->lim_actmsgs_chars.'" />';
	$lists['lim_actmsgs_lines']	= '<input class="text_area" type="text" name="lim_actmsgs_lines" size="5" maxlength="4" valign="top" value="'.$row->lim_actmsgs_lines.'" />';
	$lists['lim_actwords_chars'] = '<input class="text_area" type="text" name="lim_actwords_chars" size="5" maxlength="4" valign="top" value="'.$row->lim_actwords_chars.'" />';
	
	// Build Themes select list
	$directory = JPATH_SITE.'/components/com_maqmahelpdesk/templates/';
	$handle = opendir( $directory );
	while ($file = readdir($handle)) {
		$dir = JPath::clean( $directory.'/'.$file);
		if( is_dir( $dir ) && $file != '.' && $file != '..' ) {
			$langs[] = JHTML::_('select.option',  $file );
		}
	}
	closedir($handle);
	$lists['themes'] = JHTML::_('select.genericlist', $langs, 'theme', 'class="inputbox" size="1"', 'value', 'text', $row->theme );

	// Build Support Staff select list
	$sql = "SELECT DISTINCT(u.`id`) AS value, u.`name` AS text FROM #__support_permission p, #__users u WHERE p.id_user=u.id ORDER BY u.name";
	$database->setQuery($sql);
	$rows_staff = $database->loadObjectList();
	$rows_staff = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $rows_staff);
	$lists['auto_assign'] = JHTML::_('select.genericlist',$rows_staff, 'auto_assign', 'class="inputbox" size="1"', 'value', 'text', $row->auto_assign) ;
	
	// Build Default Priority select list
	$sql = "SELECT `id` AS value, CONCAT(`description`, ' (', `timevalue`, ' ', `timeunit`,')') AS text FROM `#__support_priority` ORDER BY `description`";
	$database->setQuery($sql);
	$priority = $database->loadObjectList();
	$priority = array_merge(array(JHTML::_('select.option', '0', JText::_('selectlist'))), $priority);
	$lists['priority'] = JHTML::_('select.genericlist',$priority, 'id_priority', 'class="inputbox" size="1"', 'value', 'text', $row->id_priority) ;

	wk_html::edit( $row, $lists );
}

/**
* Saves the workgroup
* @param database A database connector object
* @param string The name of the component
*/
function saveWK( $apply ) {
	global $supportConfig;
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$row = new mosSupportWK( $database );
	
	if (!$row->bind( $_POST )) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$row->checkin();
	//$row->updateOrder( "" );
	
	// Delete current logo if necessary
	if( $_FILES['logo']['name'] != '' && $_POST['old_logo'] != '' ) {
		unlink($supportConfig->docspath.'/logos/'.JRequest::getVar( 'old_logo', '', 'POST', 'string' ));
	}

	// Saves the name of the image in the database
	if( $_FILES['logo']['name'] != '' ) {
		$msg = mqm_do_upload( $row->id, 'W', "logo", JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/' );
	}
	
	// Removes the logo from the selected workgroup
	if ( $_POST['logo_remove'] ) {
		unlink(JPATH_SITE.'/components/com_maqmahelpdesk/images/logos/'.JRequest::getVar( 'old_logo', '', 'POST', 'string' ));
		$database->setQuery( "UPDATE #__support_workgroup SET logo=NULL WHERE id='".$row->id."'" );
		$database->query();
		$msg = JText::_('wk_logo_deleted');
	}
	
	if( $apply ) {
		$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=workgroup_edit&cid[0]=".$row->id );
	}else{
		$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=workgroup" );
	}
}

/**
* Deletes one or more categories from the categories table
* @param database A database connector object
* @param string The name of the category section
* @param array An array of unique category id numbers
*/
function removeWK( $cid ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	if (count( $cid ) < 1) {
		echo "<script type='text/javascript'> alert('".JText::_('wk_delete')."'); window.history.go(-1);</script>\n";
		exit;
	}

	// Prevent deletion of last workgroup
	$database->setQuery( "SELECT COUNT(*) FROM #__support_workgroup" );
	if( $database->loadResult() == 1 ) {
		echo "<script type='text/javascript'> alert('".JText::_('wk_delete_last')."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		// Delete selected workgroup(s)
		$database->setQuery( "DELETE FROM #__support_workgroup WHERE id IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Announcements for this Workgroup
		$database->setQuery( "DELETE FROM #__support_announce WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Categories for this Workgroup
		$database->setQuery( "DELETE FROM #__support_category WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Client Permissions for this Workgroup
		$database->setQuery( "DELETE FROM #__support_client_wk WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}		

		// Delete Support Users permissions for this Workgroup
		$database->setQuery( "DELETE FROM #__support_permission WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Mail Fetch settings for this Workgroup
		$database->setQuery( "DELETE FROM #__support_mail_fetch WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}		

		// Delete Tickets for this Workgroup
		$database->setQuery( "DELETE FROM #__support_ticket WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Bookmarks for deleted tickets
		$database->setQuery( "DELETE FROM #__support_bookmark WHERE id NOT IN (SELECT id FROM #__support_ticket) AND source='T'" ); 
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Custom Fields values for deleted tickets
		$database->setQuery( "DELETE FROM #__support_field_value WHERE id_ticket NOT IN (SELECT id FROM #__support_ticket)" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}

		// Delete Custom Fields for this Workgroup
		$database->setQuery( "DELETE FROM #__support_wk_fields WHERE id_workgroup IN (".$database->quote($cids).")" );
		if (!$database->query()) {
			echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=workgroup" );
}

/**
* Publishes or Unpublishes one or more workgroups
* @param database A database connector object
* @param array An array of unique workgroup id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The name of the component
*/
function publishWK( $cid=null, $publish=1 ) {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script type='text/javascript'> alert('".JText::_('wk_select_action')." $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );
	$database->setQuery( "UPDATE #__support_workgroup SET `show`='$publish' WHERE id IN (".$database->quote($cids).")" );

	if (!$database->query()) {
		echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=workgroup" );
}

function saveOrder() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$orders = JRequest::getVar( 'contentTable', array(0), '', 'array' );
	
	for( $i=1; $i<(count($orders)-1); $i++ ) 
	{
		$sql = "UPDATE `#__support_workgroup`
				SET `ordering`=$i
				WHERE `id`=".$orders[$i];
		$database->setQuery( $sql );
		$database->query();
	}

	$mainframe->redirect( "index.php?option=com_maqmahelpdesk&task=workgroup", JText::_('new_ordering_save') );
}
