<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.category.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class category_html 
{
	static function show( &$rows, &$pageNav, $lists ) { ?>
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=category"><?php echo JText::_('categories'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<form action="index.php" method="post" id="filterForm" name="filterForm">
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> <?php echo JText::_('workgroup').': '.$lists['workgroup'];?>
		</div>
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="category" />
		</form>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" align="right">#</td>
				<td width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</td>
				<td class="title"><?php echo JText::_('name'); ?></td>
				<td class="title"><?php echo JText::_('workgroup'); ?></td>
				<td class="title" align="center"><?php echo JText::_('tickets'); ?></td>
				<td class="title" align="center"><?php echo JText::_('kb'); ?></td>
				<td class="title" align="center"><?php echo JText::_('discussions'); ?></td>
				<td width="70" align="center"><?php echo JText::_('published'); ?></td>
			</tr>
			</thead>
			<tbody><?php
			if (count( $rows )==0) { ?>
				<tr><td colspan="8"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) 
				{
					$row = &$rows[$i];
					$img = $row->show ? 'tick' : 'no';
					$task = $row->show ? 'category_unpublish' : 'category_publish';
					$alt = $row->show ? JText::_('published') : JText::_('unpublished'); ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td><?php 
							if( $row->level > 1 ) { ?>
								<img src="components/com_maqmahelpdesk/js/joinbottom.gif" alt="" align="absmiddle" /><?php
								if( $row->level > 2 ) {
									for( $i=2; $i<$row->level; $i++ ) { ?>
										<img src="components/com_maqmahelpdesk/js/line2.gif" alt="" align="absmiddle" /><?php
									}
								}
							} ?>
							<a href="#category_edit" onClick="return listItemTask('cb<?php echo $i;?>','category_edit')">
								<?php echo $row->name; ?>
							</a>
						</td>
						<td><?php echo $row->workgroup; ?></td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row->tickets ? 'tick' : 'no');?>.png" border="0" alt="" />
						</td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row->kb ? 'tick' : 'no');?>.png" border="0" alt="" />
						</td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo ($row->discussions ? 'tick' : 'no');?>.png" border="0" alt="" />
						</td>
						<td width="70" align="center">
							<a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
								<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
							</a>
						</td><?php		
						$k = 1 - $k; ?>
					</tr><?php	
				} // for loop
			} // if ?>
			<tbody>
			<tfoot>
			<tr>
				<td colspan="8">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="category" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) 
	{ 
		$GLOBALS['titulo_category_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('category'); ?>
		
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'category') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
            } else if(form.id_workgroup.value == "0") {
                alert("<?php echo JText::_('workgroup_required');?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'category') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=workgroup"><?php echo JText::_('workgroups'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=category"><?php echo JText::_('categories'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('name'); ?>
				</span> 
				<input class="large" type="text" id="name" name="name" value="<?php echo $row->name; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('parent').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('parent'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['parent']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('workgroup').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('workgroup'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['workgroup']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('tickets').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('tickets'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['tickets']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('kb').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('kb'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['kb']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('discussions').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('discussions'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['discussions']; ?>
				</div>
			</div>
			<!--<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('bugtracker').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('bugtracker'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['bugtracker']; ?>
				</div>
			</div>-->
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('published'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['show']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form><?php 
	}
}
