<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.customfield.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class cfield_html 
{
	static function show( &$rows, &$pageNav, $lists ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=customfield"><?php echo JText::_('cfields'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> <?php echo JText::_('type').': '.$lists['cftype'];?>
		</div>
		
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<th width="20" align="right">#</th>
				<th width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</th>
				<th class="title"><?php echo JText::_('name'); ?></th>
				<th class="title"><?php echo JText::_('type'); ?></th>
				<th class="title"><?php echo JText::_('field_type'); ?></th>
			</tr>
			</thead>
			<tbody>
			<?php
			if (count( $rows )==0) {
				?><tr><td colspan="7"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#customfield_edit" onClick="return listItemTask('cb<?php echo $i;?>','customfield_edit')">
								<?php echo $row->caption; ?>
							</a>
							<?php if ($row->cftype=='W') :?>
							<br />
							<i><?php echo JText::_('cfields_codes'); ?> [cfield<?php echo $row->id;?>_caption] / [cfield<?php echo $row->id;?>_value]</i>
							<?php endif; ?>
						</td>
						<td align="center"><?php 
							if ($row->cftype=='W') echo JText::_('wk_field');
							else if ($row->cftype=='U') echo JText::_('users_field');
							else if ($row->cftype=='C') echo JText::_('contract_field');
						?></td>
						<td align="center"><?php echo JText::_('formfield_'.$row->ftype); ?></td>
						<?php		
						$k = 1 - $k; 
						?>
					</tr>
					<?php	
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
			<tr>
				<td colspan="5">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="customfield" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) { ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'customfield') {
				submitform( pressbutton );
				return;
			}

			if (form.caption.value == ""){
				alert("<?php echo JText::_('caption_required'); ?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'customfield') {
				submitform( pressbutton );
				return;
			}

			if (form.caption.value == ""){
				alert("<?php echo JText::_('caption_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>

		function checkType( FTYPE ) {
			switch( FTYPE )
			{
				
				case 'htmleditor':
				case 'textarea':
					$jMaQma('#d1').hide();
					$jMaQma('#d2').hide();
					$jMaQma('#d3').hide();
					$jMaQma('#d4').show();
					$jMaQma('#d5').hide();
                    $jMaQma('#d6').hide();
					break;

				case 'radio':
				case 'checkbox':
				case 'select':
					$jMaQma('#d1').show();
					$jMaQma('#d2').show();
					$jMaQma('#d3').hide();
					$jMaQma('#d4').show();
					$jMaQma('#d5').hide();
                    $jMaQma('#d6').hide();
					break;
					
				case 'dbselect':
					$jMaQma('#d1').hide();
					$jMaQma('#d2').show();
					$jMaQma('#d3').hide();
					$jMaQma('#d4').show();
					$jMaQma('#d5').show();
                    $jMaQma('#d6').hide();
					break;
				
				case 'date':
					$jMaQma('#d1').hide();
					$jMaQma('#d2').show();
					$jMaQma('#d3').hide();
					$jMaQma('#d4').show();
					$jMaQma('#d5').show();
                    $jMaQma('#d6').hide();
					break;
				
				case 'text':
					$jMaQma('#d1').hide();
					$jMaQma('#d2').hide();
					$jMaQma('#d3').show();
					$jMaQma('#d4').hide();
					$jMaQma('#d5').hide();
                    $jMaQma('#d6').hide();
					break;

				case 'country':
				case 'state':
					$jMaQma('#d1').hide();
					$jMaQma('#d2').show();
					$jMaQma('#d3').hide();
					$jMaQma('#d4').show();
					$jMaQma('#d5').hide();
                    $jMaQma('#d6').hide();
					break;

				case 'note':
					$jMaQma('#d1').hide();
					$jMaQma('#d2').show();
					$jMaQma('#d3').hide();
					$jMaQma('#d4').show();
					$jMaQma('#d5').hide();
					$jMaQma('#d6').show();
					break;
			}

			return false;
		}
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=customfield"><?php echo JText::_('cfields'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('name'); ?>
				</span> 
				<input class="large" type="text" id="caption" name="caption" value="<?php echo $row->caption; ?>" maxlength="100" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('help_text').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('help_text'); ?>
				</span> 
				<textarea class="large" type="text" name="tooltip" cols="50" rows="2"><?php echo $row->tooltip; ?></textarea>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('type').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('type'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['cftype']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('field_type').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('field_type'); ?>
				</span> 
				<table>
				<tr>
					<td>
						<input type="radio" id="ftype0" name="ftype" value="radio" onClick="checkType('radio');" /> <?php echo JText::_('formfield_radio'); ?>
					</td>
					<td>
						<input type="radio" id="ftype1" name="ftype" value="text" onClick="checkType('text');" /> <?php echo JText::_('formfield_text'); ?>
					</td>
					<td>
						<input type="radio" id="ftype2" name="ftype" value="textarea" onClick="checkType('textarea');" /> <?php echo JText::_('formfield_textarea'); ?>
					</td>
					<td>
						<input type="radio" id="ftype6" name="ftype" value="dbselect" onClick="checkType('dbselect');" /> <?php echo JText::_('formfield_dbselect'); ?>
					</td>
				</tr>
				<tr>
					<td>
						<input type="radio" id="ftype3" name="ftype" value="checkbox" onClick="checkType('checkbox');" /> <?php echo JText::_('formfield_checkbox'); ?>
					</td>
					<td>
						<input type="radio" id="ftype4" name="ftype" value="select" onClick="checkType('select');" /> <?php echo JText::_('formfield_select'); ?>
					</td>
					<td>
						<input type="radio" id="ftype5" name="ftype" value="htmleditor" onClick="checkType('htmleditor');" /> <?php echo JText::_('htmleditor'); ?>
					</td>
					<td>
						<input type="radio" id="ftype10" name="ftype" value="date" onClick="checkType('date');" /> <?php echo JText::_('date'); ?>
					</td>
				</tr>
				<tr>
					<td>
						<input type="radio" id="ftype7" name="ftype" value="country" onClick="checkType('country');" /> <?php echo JText::_('formfield_country'); ?>
					</td>
					<td>
						<input type="radio" id="ftype8" name="ftype" value="state" onClick="checkType('state');" /> <?php echo JText::_('formfield_state'); ?>
					</td>
					<td>
						<input type="radio" id="ftype9" name="ftype" value="note" onClick="checkType('note');" /> <?php echo JText::_('formfield_note'); ?>
					</td>
					<td></td>
				</tr>
				</table>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('value').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('value'); ?>
				</span> 
				<input class="large" type="text" id="value" name="value" value="<?php echo $row->value; ?>" maxlength="100" />
				<div id="d1" style="display:none;">
					<?php echo JText::_('field_desc'); ?>
				</div>
				<div id="d3" style="display:none;">
					<?php echo JText::_('default_value'); ?>
				</div>
				<div id="d5" style="display:none;">
					<?php echo JText::_('dbselect_description'); ?>
				</div>
				<div id="d6" style="display:none;">
					<?php echo JText::_('note_description'); ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('size').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('size'); ?>
				</span> 
				<input type="text" id="size" name="size" value="<?php echo $row->size; ?>" maxlength="10" size="10" />
				<div id="d2" style="display:none;">
					<?php echo JText::_('size_dont_apply'); ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('maxlength').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('maxlength'); ?>
				</span> 
				<input type="text" id="maxlength" name="maxlength" value="<?php echo $row->maxlength; ?>" maxlength="10" size="4" />
				<div id="d2" style="display:none;">
					<?php echo JText::_('maxlength_dont_apply'); ?>
				</div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form><?php
		
		if( $row->id > 0 ) { 
			switch( $row->ftype) {
				case 'radio':		$ftype_number = '0'; break;
				case 'text':		$ftype_number = '1'; break;
				case 'textarea':	$ftype_number = '2'; break;
				case 'checkbox':	$ftype_number = '3'; break;
				case 'select':		$ftype_number = '4'; break;
				case 'htmleditor':	$ftype_number = '5'; break;
				case 'dbselect':	$ftype_number = '6'; break;
				case 'country':     $ftype_number = '7'; break;
				case 'state':       $ftype_number = '8'; break;
				case 'note':        $ftype_number = '9'; break;
				case 'date':        $ftype_number = '10'; break;
			} ?>
			<script type='text/javascript'> $jMaQma("#ftype<?php echo $ftype_number; ?>").attr("checked","checked"); checkType('<?php echo $row->ftype; ?>'); </script><?php
		} ?>
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("textarea").autoGrow();
		});
		</script><?php 
	}
}
