<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.dlcategory.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class HTML_category 
{
	static function showCategory( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="POST" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('downloads'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=dlcategory"><?php echo JText::_('categories'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
				<tr>
					<td width="20">&nbsp;</td>
					<td width="20" align="right">#</td>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows ); ?>);" /></td>
					<td align="left" nowrap><?php echo JText::_('name'); ?></td>
					<td align="left" nowrap><?php echo JText::_('description'); ?></td>
					<td align="center" nowrap><?php echo JText::_('published'); ?></td>
				</tr>
			</thead>
			<tbody><?php
			if (count( $rows )==0) { ?>
				<tr><td colspan="6"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i]; ?>
					<tr id="contentTable-row-<?php echo ($row->id);?>" class="<?php echo "row$k"; ?>">
						<td align="left" width="20" align="right" class="dragHandle"></td>
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20">
							<input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onClick="isChecked(this.checked);" />
						</td>
						<td align="left"><?php 
							if( $row->level > 1 ) { ?>
								<img src="components/com_maqmahelpdesk/js/joinbottom.gif" alt="" align="absmiddle" /><?php
								if( $row->level > 2 ) {
									for( $i=2; $i<$row->level; $i++ ) { ?>
										<img src="components/com_maqmahelpdesk/js/line2.gif" alt="" align="absmiddle" /><?php
									}
								}
							} ?>
							<a href="#edit" onclick="return listItemTask('cb<?php echo $i; ?>','dlcategory_edit')"><?php echo $row->title; ?></a>
						</td>
						<td align="left"><?php echo strip_tags($row->description);?></td><?php
						$task = $row->published ? 'dlcategory_unpublish' : 'dlcategory_publish';
						$img = $row->published ? 'tick' : 'no';?>
						<td width="10%" align="center"><a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="" /></a></td><?php
						$k = 1 - $k; ?>
					</tr><?php
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="6">
						<?php echo $pageNav->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="dlcategory" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma('#contentTable').tableDnD({
				onDrop: function(table, row) {
					window.location = 'index.php?option=com_maqmahelpdesk&task=dlcategory_saveorder&'+$jMaQma('#contentTable').tableDnDSerialize();
				},
				dragHandle: "dragHandle"
			});
			
			$jMaQma("#contentTable tr").hover(function() {
				  $jMaQma(this.cells[0]).addClass('showDragHandle');
			}, function() {
				  $jMaQma(this.cells[0]).removeClass('showDragHandle');
			});
		});
		</script><?php
	}

	static function categoryForm( &$_row, $lists ) {
		$editor = JFactory::getEditor(); ?>
		
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'dlcategory_cancel') {
				submitform( pressbutton );
				return;
			}

			if (form.cname.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'dlcategory_cancel') {
				submitform( pressbutton );
				return;
			}

			if (form.cname.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="POST" id="adminForm" name="adminForm" enctype="multipart/form-data" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('downloads'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=dlcategory"><?php echo JText::_('categories'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('parent').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('parent'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['parent']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('name'); ?>
				</span> 
				<input type="text" id="cname" name="cname" value="<?php echo $_row->cname; ?>" class="large" maxlength="100" /> 
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<div style="margin-left:170px;"><?php echo $editor->display( 'description',  $_row->description , '100%', '300', '75', '20' ); ?></div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('image').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('image'); ?>
				</span> 
				<input class="inputbox" type="file" name="image" value="" size="50" />
				<?php if( $_row->image != '' ):?>
				<br /><img src="<?php echo JURI::root();?>components/com_maqmahelpdesk/images/logos/<?php echo $_row->image;?>" alt="" width="48" height="48" />
				<?php endif;?>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('published'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['published']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $_row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
		});
		</script><?php
	}
}

function GetCategoryName( $id ) {
	$database = JFactory::getDBO();

	$database->setQuery( "SELECT cname FROM #__support_dl_category WHERE id='$id'" );
	return $database->loadResult();
}

?>