<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.forms.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class forms_html 
{
	static function show( &$rows, &$pageNav ) 
	{
		$database = JFactory::getDBO(); ?>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=forms"><?php echo JText::_('forms'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
				<tr>
					<th width="20" align="right">#</th>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
					<td class="title"><?php echo JText::_('name'); ?></td>
					<td class="title"><?php echo JText::_('description'); ?></td>
					<td width="70" align="center"><?php echo JText::_('fields'); ?></td>
					<td width="70" align="center"><?php echo JText::_('published'); ?></td>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="9"><?php echo $pageNav->getListFooter(); ?></td>
				</tr>
				</tfoot>
				<tbody><?php
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) 
				{
					$row = &$rows[$i];
					$img = $row->show ? 'tick' : 'no';
					$task = $row->show ? 'forms_unpublish' : 'forms_publish';
					$alt = $row->show ? JText::_('published') : JText::_('unpublished'); ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#forms_edit" onClick="return listItemTask('cb<?php echo $i;?>','forms_edit')"><?php echo $row->name; ?></a>
							<br /><i>{scform}<?php echo $row->id; ?>{/scform}</i>
						</td>
						<td><?php echo strip_tags($row->description); ?></td>
						<td width="50"><?php 
							$database->setQuery( "SELECT COUNT(*) FROM #__support_form_field WHERE id_form='".$row->id."'" );
							echo $database->loadResult(); ?>
						</td>
						<td width="70" align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" />
						</td>
					</tr>
					<?php	
				} // for ?>
				</tbody>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_FORMS_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_FORMS_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/101-forms.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="forms" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) 
	{
		$editor = JFactory::getEditor();
		$user = JFactory::getUser();
		$GLOBALS['form_typename'] = $row->name; ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'forms') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'forms') {
				submitform( pressbutton );
				return;
			}

			if (form.name.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=forms"><?php echo JText::_('forms'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<ul class="leftmenu">
						<li class="current"><a href="#" onclick="MaQmaJS.SelectTab(this,1);"><img src="../components/com_maqmahelpdesk/images/menu/forms.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('general');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,2);"><img src="../components/com_maqmahelpdesk/images/menu/addons.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('actions');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,3);"><img src="../components/com_maqmahelpdesk/images/menu/table.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('fields');?></a></li>
					</ul>
				</div>
			</div>
			<div class="contentbar withleft">
				<div id="tab1" class="contenttab" style="display:block;">
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('form_name_tooltip')); ?>">
							<?php echo JText::_('name'); ?>
						</span> 
						<input class="large" type="text" id="name" name="name" value="<?php echo $row->name; ?>" maxlength="100" />
					</div>
					<div class="field w100" style="height:550px;">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('form_desc_tooltip')); ?>">
							<?php echo JText::_('description'); ?>
						</span> 
						<div style="margin-left:170px;"><?php echo $editor->display( 'description', $row->description, '100%', '500', '75', '20' );?></div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('form_published_tooltip')); ?>">
							<?php echo JText::_('published'); ?>
						</span> 
						<div class="controlset-pad">
							<?php echo $lists['show']; ?>
						</div>
					</div>
					<br class="clr" />
				</div>
				<div id="tab2" class="contenttab">
					<?php if( $row->id ) : ?>
						<div id="formactions" name="formactions" align="left"></div>
					<?php else:?>
						<img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" /> <b><?php echo JText::_('actions_firsttime');?></b>
					<?php endif;?>
					<br class="clr" />
				</div>
				<div id="tab3" class="contenttab">
					<?php if( $row->id ) : ?>
						<div id="formfields" name="formfields" align="left"></div>
					<?php else:?>
						<img src="../components/com_maqmahelpdesk/images/info.png" align="absmiddle" /> <b><?php echo JText::_('fields_firsttime');?></b>
					<?php endif;?>
					<br class="clr" />
				</div>
			</div>
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		<?php if( $row->id > 0 ) { ?>
		function getActions() {
			$jMaQma("div#loading").show();
			$jMaQma("div#formactions").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=actions&tmpl=component&format=raw", 
				{
					action: 'list',
					id_form: '<?php echo $row->id; ?>'
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function showAction( ID ) {
			MaQmaJS.SelectTab(this,2);
			
			if( ID == 0 ) {
				ACTION = 'new';
			}else{
				ACTION = 'edit';
			}
			$jMaQma("div#loading").show();
			$jMaQma("div#formactions").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=actions&tmpl=component&format=raw", 
				{
					action: ACTION,
					id_form: '<?php echo $row->id; ?>',
					id: ID
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function cancelAction() {
			getActions();
		}

		function saveAction() {
			if( document.adminForm.action_published0.checked ) {
				PUBLISHED = 0;
			}else{
				PUBLISHED = 1;
			}
			
			$jMaQma("div#loading").show();
			$jMaQma("div#formactions").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=actions&tmpl=component&format=raw", 
				{
					action: 'save',
					id_form: '<?php echo $row->id; ?>',
					id: document.adminForm.action_id.value,
					type: document.adminForm.action_type.value,
					value: document.adminForm.action_value.value,
					published: PUBLISHED
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function deleteAction( ID ) {
			$jMaQma("div#loading").show();
			$jMaQma("div#formactions").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=actions&tmpl=component&format=raw", 
				{
					action: 'delete',
					id_form: '<?php echo $row->id; ?>',
					id: ID
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		getActions();

		function getFieldsTags() {
			$jMaQma("div#loading").show();
			$jMaQma("div#fieldsvars").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=fields&tmpl=component&format=raw", 
				{
					action: 'tags',
					id_form: '<?php echo $row->id; ?>',
					usertype: '<?php echo $user->usertype; ?>'
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function getFields() {
			$jMaQma("div#loading").show();
			$jMaQma("div#formfields").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=fields&tmpl=component&format=raw", 
				{
					action: 'list',
					id_form: '<?php echo $row->id; ?>'
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function showField( ID ) {
			MaQmaJS.SelectTab(this,3);
			
			if( ID == 0 ) {
				ACTION = 'new';
			}else{
				ACTION = 'edit';
			}
			
			$jMaQma("div#loading").show();
			$jMaQma("div#formfields").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=fields&tmpl=component&format=raw", 
				{
					action: ACTION,
					id_form: '<?php echo $row->id; ?>',
					id: ID
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		function cancelField() {
			getFields();
			getFieldsTags();
		}

		function saveField() {
			if( document.adminForm.field_required0.checked ) {
				REQUIRED = 0;
			}else{
				REQUIRED = 1;
			}
			
			$jMaQma("div#loading").show();
			$jMaQma("div#formfields").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=fields&tmpl=component&format=raw", 
				{
					action: 'save',
					id_form: '<?php echo $row->id; ?>',
					id: document.adminForm.field_id.value,
					caption: document.adminForm.field_caption.value,
					order: document.adminForm.field_order.value,
					type: document.adminForm.field_type.value,
					value: document.adminForm.field_value.value,
					size: document.adminForm.field_size.value,
					maxlength: document.adminForm.field_maxlength.value,
					required: REQUIRED
				},
				function() { $jMaQma("div#loading").hide(); } );
			getFieldsTags()
		}

		function deleteField( ID ) {
			$jMaQma("div#loading").show();
			$jMaQma("div#formfields").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=fields&tmpl=component&format=raw", 
				{
					action: 'delete',
					id_form: '<?php echo $row->id; ?>',
					id: ID
				},
				function() { $jMaQma("div#loading").hide(); } );
			getFieldsTags()
		}

		function saveFieldOrder() {
			$jMaQma("div#loading").show();
			
			ORDERS = '';
			for( i=0; i<document.adminForm.nr_forms.value; i++ )
			{
				ORDERS = ORDERS + document.getElementById('form'+i).value + '|' + document.getElementById('order'+i).value + ';';
			}

			$jMaQma("div#formfields").load("index.php?option=com_maqmahelpdesk&task=forms_ajax&page=fields&tmpl=component&format=raw", 
				{
					action: 'saveorder',
					id_form: '<?php echo $row->id; ?>',
					orders: ORDERS
				},
				function() { $jMaQma("div#loading").hide(); } );
		}

		getFields();
		getFieldsTags();
		<?php } ?>
		
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}

	static function showData( &$rows, &$pageNav, $id, $rowForm, $fields ) 
	{
		$database = JFactory::getDBO();?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		
		<table class="adminheading">
		<tr>
			<th class="forms"><?php echo $rowForm->name; ?></th>
		</tr>
		</table>
		
		<table class="adminlist">
		<thead>
			<tr>
				<th width="20" align="right">#</th><?php
				for( $i=0; $i<count($fields); $i++ ) {
					print '<th class="title">'.$fields[$i][2].'</th>';
				} ?>
				<th class="title"><?php echo JText::_('datetime'); ?></th>
				<th class="title"><?php echo JText::_('ipaddress'); ?></th>
			</tr>
		</thead>
		<tbody>
		<?php
		if (count( $rows )==0) {
			?><tr><td colspan="3"><?php echo JText::_('register_not_found'); ?></td></tr><?php
		} else {
			$k = 0;
			for ($i=0, $n=count( $rows ); $i < $n; $i++) { ?>
				<tr class="<?php echo "row$k"; ?>">
					<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td><?php
					for( $z=0; $z<count($fields); $z++ ) {
						$field_name = strtolower(str_replace(' ', '_', $fields[$z][2]));
						print '<td align="left">'.$rows[$i]["$field_name"].'</td>';
					}
					$k = 1 - $k; ?>
					<td align="left"><?php echo $rows[$i]['sc_recorddate']; ?></td>
					<td align="left"><?php echo $rows[$i]['sc_ipaddress']; ?></td>
				</tr><?php	
			} // for loop
		} // if ?>
		</tbody>
		<tfoot>
		<tr>
			<td colspan="3">
				<?php echo $pageNav->getListFooter(); ?>
			</td>
		</tr>
		</tfoot>
		</table>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="forms_data" />
		<input type="hidden" name="id" value="<?php echo $id; ?>" />
		</form><?php
	}
}
