<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.holidays.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package iMaQma Helpdesk
*/
class holidays_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=holidays"><?php echo JText::_('holidays'); ?></a>
			<span><?php echo JText::_('manager'); ?></span>
		</div>
		<div class="contentarea">
            <div id="contentbox" class="mqmclear">
                <table class="contenttable" cellspacing="0">
                <thead>
                    <tr>
                        <th width="10">#</th>
                        <th width="10">
                            <input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
                        </th>
                        <th class="title" width="100"><div align="center"><?php echo JText::_('date'); ?></div></th>
                        <th class="title"><?php echo JText::_('name'); ?></th>
                    </tr>
                </thead>
                <tbody><?php
                if (count( $rows )==0) {
                    ?><tr><td colspan="4"><?php echo JText::_('register_not_found'); ?></td></tr><?php
                } else {
                    $k = 0;
                    for ($i=0, $n=count( $rows ); $i < $n; $i++) {
                        $row = &$rows[$i]; ?>
                        <tr class="<?php echo "row$k"; ?>">
                            <td width="10" align="right"><?php echo $pageNav->getRowOffset( $i ); ?></td>
                            <td width="10"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
                            <td width="100">
                                <a href="#holidays_edit" onClick="return listItemTask('cb<?php echo $i;?>','holidays_edit')" >
                                    <?php echo $row->holiday_date; ?>
                                </a>
                            </td>
                            <td>
                                <a href="#holidays_edit" onClick="return listItemTask('cb<?php echo $i;?>','holidays_edit')" >
                                    <?php echo $row->name; ?>
                                </a>
                            </td><?php
                            $k = 1 - $k; ?>
                        </tr><?php
                    } // for loop
                } // if ?>
                </tbody>
                <tfoot>
                    <tr>
                        <td colspan="4"><?php echo $pageNav->getListFooter(); ?></td>
                    </tr>
                </tfoot>
                </table>
            </div>
            <div id="infobox">
                <span id="infoarrow"></span>
                <dl class="first">
                    <dd class="title"><?php echo JText::_('INFO_HOLIDAYS_TITLE');?></dd>
                    <dd class="last">
                        <?php echo JText::_('INFO_HOLIDAYS_DESC');?>
                    </dd>
                </dl>
            </div>
            <br class="clr" />
        </div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="holidays" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}
	
	static function edit( &$holidayInfo, $lists ) {	
		global $supportConfig; 
		$GLOBALS['holidays_title'] = ( (isset($holidayInfo->id)) ? JText::_('edit') : JText::_('add') ).' '.JText::_('holiday'); ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'holidays_cancel') {
				submitform( pressbutton );
				return;
			}

			var re = /(0000|2008|2009|2010|2011|2012|2013|2014|2015|2016)[-](01|02|03|04|05|06|07|08|09|10|11|12)[-](01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31)/;
			var v = form.holiday_date.value;
			if (!re.test(v)) {
				alert("<?php echo JText::_('date_required'); ?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'holidays_cancel') {
				submitform( pressbutton );
				return;
			}

			var re = /(0000|2008|2009|2010|2011|2012|2013|2014|2015|2016)[-](01|02|03|04|05|06|07|08|09|10|11|12)[-](01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31)/;
			var v = form.holiday_date.value;
			if (!re.test(v)) {
				alert("<?php echo JText::_('date_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=holidays"><?php echo JText::_('holidays'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('date').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('date'); ?>
				</span> 
				<input size="12" type="text" id="holiday_date" name="holiday_date" value="<?php echo (isset($holidayInfo->holiday_date)) ? $holidayInfo->holiday_date : ''; ?>" maxlength="10" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('name'); ?>
				</span> 
				<input class="large" type="text" id="name" name="name" value="<?php echo (isset($holidayInfo->name)) ? $holidayInfo->name : ''; ?>" maxlength="60" />
			</div>
			<br class="clr" />
		</div>
			
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="<?php echo (isset($holidayInfo->id)) ? $holidayInfo->id:'0'; ?>" />
		</form><?php 
	}
}
