<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.mail.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package iMaQma Helpdesk
*/
class mail_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('addons'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=mail"><?php echo JText::_('email_fetch'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
				<tr>
					<th width="20" align="right">#</th>
					<td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" /></td>
					<td class="title"><?php echo JText::_('workgroup'); ?></td>
					<td class="title"><?php echo JText::_('email'); ?></td>
					<td class="title"><?php echo JText::_('username'); ?></td>
					<td class="title"><?php echo JText::_('mail_server'); ?></td>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="6"><?php echo $pageNav->getListFooter(); ?></td>
				</tr>
				</tfoot>
				<tbody><?php
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) 
				{
					$row = &$rows[$i]; ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td><?php echo $row->wkdesc; ?></td>
						<td>
							<a href="#mail_edit" onClick="return listItemTask('cb<?php echo $i;?>','mail_edit')">
								<?php echo $row->email; ?>
							</a>
						</td>
						<td><?php echo $row->username; ?></td>
						<td><?php echo $row->server; ?></td>
					</tr>
					<?php	
				} // for ?>
				</tbody>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_FETCHING_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_FETCHING_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/94-e-mail-fetching.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="mail" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) 
	{
		$GLOBALS['title_edit_mail'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('fetch_account'); ?>

		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'mail') {
				submitform( pressbutton );
				return;
			}

			if (form.id_workgroup.value == "0"){
				alert("<?php echo JText::_('wk_required'); ?>");
			} else if (form.email.value == "") {
				alert("<?php echo JText::_('email_required'); ?>");
			} else if (form.server.value == "") {
				alert("<?php echo JText::_('server_required'); ?>");
			} else if (form.username.value == "") {
				alert("<?php echo JText::_('username_required'); ?>");
			} else if (form.password.value == "") {
				alert("<?php echo JText::_('password_required'); ?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'mail') {
				submitform( pressbutton );
				return;
			}

			if (form.id_workgroup.value == "0"){
				alert("<?php echo JText::_('wk_required'); ?>");
			} else if (form.email.value == "") {
				alert("<?php echo JText::_('email_required'); ?>");
			} else if (form.server.value == "") {
				alert("<?php echo JText::_('server_required'); ?>");
			} else if (form.username.value == "") {
				alert("<?php echo JText::_('username_required'); ?>");
			} else if (form.password.value == "") {
				alert("<?php echo JText::_('password_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('addons'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=mail"><?php echo JText::_('email_fetch'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('workgroup').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('workgroup'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['workgroup']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('category_queue').'::'.JText::_('category_queue_tooltip')); ?>">
					<?php echo JText::_('category_queue'); ?>
				</span> 
				<div id="categoryField" class="controlset-pad">
					<?php echo $lists['category']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('email').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('email'); ?>
				</span> 
				<input class="medium" type="text" id="email" name="email" value="<?php echo $row->email; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('mail_server').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('mail_server'); ?>
				</span> 
				<input class="medium" type="text" id="server" name="server" value="<?php echo $row->server; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('mail_port').'::'.JText::_('pop_port')); ?>">
					<?php echo JText::_('mail_port'); ?>
				</span> 
				<input class="medium" type="text" id="port" name="port" value="<?php echo $row->port; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('username').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('username'); ?>
				</span> 
				<input class="medium" type="text" id="username" name="username" value="<?php echo $row->username; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('password').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('password'); ?>
				</span> 
				<input class="medium" type="password" id="password" name="password" value="<?php echo $row->password; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('server_type').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('server_type'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['type']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('remove_mail').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('remove_mail'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['remove']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('label_fetch').'::'.JText::_('label_fetch_tooltip')); ?>">
					<?php echo JText::_('label_fetch'); ?>
				</span> 
				<input class="medium" type="text" id="label" name="label" value="<?php echo ($row->id?$row->label:'INBOX'); ?>" maxlength="25" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('FETCH_BOX_THRASH').'::'.JText::_('FETCH_BOX_THRASH_TOOLTIP')); ?>">
					<?php echo JText::_('FETCH_BOX_THRASH'); ?>
				</span> 
				<input class="medium" type="text" id="thrash" name="thrash" value="<?php echo ($row->id?$row->thrash:'THRASH'); ?>" maxlength="25" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('extra_info').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('extra_info'); ?>
				</span> 
				<input class="medium" type="text" id="extra_info" name="extra_info" value="<?php echo $row->extra_info; ?>" maxlength="100" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('fetch_queue').'::'.JText::_('fetch_queue_tooltip')); ?>">
					<?php echo JText::_('fetch_queue'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['queue']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('fetch_notls').'::'.JText::_('fetch_notls_tooltip')); ?>">
					<?php echo JText::_('fetch_notls'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['notls']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('status_queue').'::'.JText::_('status_queue_tooltip')); ?>">
					<?php echo JText::_('status_queue'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['status']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('ssl').'::'.JText::_('ssl_tooltip')); ?>">
					<?php echo JText::_('ssl'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['ssl']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('published_tooltip')); ?>">
					<?php echo JText::_('published'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['published']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		
		function GetCategories()
		{
			$jMaQma.ajax({
				url: "index.php?option=com_maqmahelpdesk&task=mail_categories&id_workgroup="+$jMaQma("#id_workgroup").val()+"&format=raw",
				success: function(data){
					$jMaQma("#categoryField").html(data);
					$jMaQma("#id_category").uniform();
				}
			});
		}
		</script><?php 
	}
}
