<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.priority.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class priority_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=priority"><?php echo JText::_('priorities'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		<div class="contentarea">
			<div id="contentbox">
			<?php if ( count( $rows ) == 0 ) : ?>
				<div class="detailmsg">
					<h1><img src="../components/com_maqmahelpdesk/images/alert.png" align="left" /> <?php echo JText::_('register_not_found'); ?></h1>
					<p><?php echo JText::_('to_add_new_record_desc'); ?></p>
				</div>
				<script type="text/javascript"> MaQmaJS.AddHelpHand('toolbar-new'); </script>
			<?php else: ?>
				<table class="contenttable" cellspacing="0">
				<thead>
					<tr>
						<th width="20" align="right">#</th>
						<td width="20">
							<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
						</td>
						<td class="title"><?php echo JText::_('description'); ?></td>
						<td class="title" width="50"><?php echo JText::_('default'); ?></td>
						<td class="title"><?php echo JText::_('time'); ?></td>
						<td width="70"><?php echo JText::_('published'); ?></td>
					</tr>
				</thead>
				<tbody><?php
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					$img = $row->show ? 'tick' : 'no';
					$task = $row->show ? 'priority_unpublish' : 'priority_publish';
					$alt = $row->show ? JText::_('published') : JText::_('unpublished');
					$default = $row->isdefault ? 'tick' : 'no'; ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#priority_edit" onClick="return listItemTask('cb<?php echo $i;?>','priority_edit')">
								<?php echo $row->description; ?>
							</a>
						</td>
						<td width="50" align="center"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $default;?>.png" border="0" /></td>
						<td><?php echo $row->timevalue." ".($row->timeunit=="D" ? JText::_('days') : JText::_('hours')); ?></td>
						<td width="70" align="center">
							<a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
								<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
							</a>
						</td><?php		
						$k = 1 - $k; ?>
					</tr><?php	
				} // for loop ?>
				</tbody>
				<tfoot>
					<tr>
						<td colspan="6"><?php echo $pageNav->getListFooter(); ?></td>
					</tr>
				</tfoot>
				</table>
			<?php endif; ?>
			</div>
			<div id="infobox">
				<span id="infoarrow"></span>
				<dl class="first">
					<dd class="title"><?php echo JText::_('INFO_PRIORITY_TITLE');?></dd>
					<dd class="last">
						<?php echo JText::_('INFO_PRIORITY_DESC');?>
						<p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/90-priorities.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
					</dd>
				</dl>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="priority" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) { 
		$GLOBALS['titulo_priority_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('priority'); ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'priority') {
				submitform( pressbutton );
				return;
			}

			if (form.description.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'priority') {
				submitform( pressbutton );
				return;
			}

			if (form.description.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=priority"><?php echo JText::_('priorities'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<input class="medium" type="text" id="description" name="description" value="<?php echo $row->description; ?>" maxlength="100" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('time_value').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('time_value'); ?>
				</span> 
				<input class="medium" type="text" id="timevalue" name="timevalue" value="<?php echo $row->timevalue; ?>" maxlength="11" />
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('time_unit').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('time_unit'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['timeunit']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('is_default').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('is_default'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['default']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('published'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['show']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}
}
