<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.product.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class HTML_product {
	static function showProduct( &$rows, &$pageNav ) {
		$database = JFactory::getDBO(); ?>
		<form action="index.php" method="POST" id="adminForm" name="adminForm">
        <div class="breadcrumbs">
            <a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
            <a href="index.php?option=com_maqmahelpdesk&task=product"><?php echo JText::_('files'); ?></a>
            <span><?php echo JText::_('manage'); ?></span>
        </div>
        <div class="contentarea">
            <table class="contenttable" cellspacing="0">
            <thead>
            <tr>
                <td width="20"></td>
                <td width="20"><input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows ); ?>);" /></td>
                <td align="left" nowrap><?php echo JText::_('name'); ?></td>
                <td align="left" nowrap><?php echo JText::_('category'); ?></td>
                <td align="left" nowrap><?php echo JText::_('version'); ?></td>
                <td align="left" nowrap><?php echo JText::_('description'); ?></td>
                <td nowrap><?php echo JText::_('published'); ?></td>
            </tr>
            </thead>
            <tbody><?php
                if (count( $rows )==0) { ?>
                    <tr><td colspan="9"><?php echo JText::_('register_not_found'); ?></td></tr><?php
                } else {
                    $k = 0;
                    $j = 0;
                    for ($i=0, $n=count( $rows ); $i < $n; $i++) {
                        $row = &$rows[$i]; ?>
                        <tr id="contentTable-row-<?php echo ($row->id);?>" class="<?php echo "row$k"; ?>">
                            <td width="20" align="center" class="dragHandle"></td>
                            <td width="20">
                                <input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->id; ?>" onClick="isChecked(this.checked);" />
                            </td>
                            <td align="left"><a href="#edit" onclick="return listItemTask('cb<?php echo $i; ?>','product_edit')"><?php echo $row->pname; ?></a></td>
                            <td align="left"><?php echo $row->cname; ?></td>
                            <td align="left"><?php
                                $database->setQuery( "SELECT version FROM #__support_dl_version WHERE id_download='".$row->id."' ORDER BY id DESC LIMIT 0, 1" );
                                echo $database->loadResult(); ?>
                            </td>
                            <td align="left"><?php echo str_replace("\'","'",$row->description);?></td><?php
                            $j++;
                            $task = $row->published ? 'product_unpublish' : 'product_publish';
                            $img = $row->published ? 'tick' : 'no'; ?>
                            <td width="10%" align="center"><a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')"><img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="" /></a></td><?php
                            $k = 1 - $k; ?>
                        </tr><?php
                    } // for loop
                } // if ?>
            </tbody>
            <tfoot>
            <tr>
                <td colspan="7"><?php echo $pageNav->getListFooter(); ?></td>
            </tr>
            </tfoot>
            </table>
            <br class="clr" />
        </div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="product" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma('#contentTable').tableDnD({
				onDrop: function(table, row) {
					window.location = 'index.php?option=com_maqmahelpdesk&task=product_saveorder&'+$jMaQma('#contentTable').tableDnDSerialize();
				},
				dragHandle: "dragHandle"
			});
			
			$jMaQma("#contentTable tr").hover(function() {
				  $jMaQma(this.cells[0]).addClass('showDragHandle');
			}, function() {
				  $jMaQma(this.cells[0]).removeClass('showDragHandle');
			});
		});
		</script><?php
	}

	static function productForm( &$_row, &$_lists, $versions, $groups ) {
		global $Itemid; 
		
		$mainframe = JFactory::getApplication();
		$editor = JFactory::getEditor(); ?>
		
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'product_cancel') {
				submitform( pressbutton );
				return;
			}

			if (form.pname.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				<?php echo $editor->save( 'features' ); ?>
				<?php echo $editor->save( 'requirements' ); ?>
				ArrangeFields();
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'product_cancel') {
				submitform( pressbutton );
				return;
			}

			if (form.pname.value == ""){
				alert("<?php echo JText::_('name_required'); ?>");
			} else {
				<?php echo $editor->save( 'description' ); ?>
				<?php echo $editor->save( 'features' ); ?>
				<?php echo $editor->save( 'requirements' ); ?>
				ArrangeFields();
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>

		function ArrangeFields() {
			NEMPS = '';
			
			for(i=0; i<document.adminForm.id_group.length; i++) {
				if(document.adminForm.id_group[i].selected == true) {
					NEMPS = NEMPS + document.adminForm.id_group[i].value + ",";
				}
			}
			
			document.adminForm.groupid.value = NEMPS.substr(0, NEMPS.length-1);
		}

		function FillValues() {
			EMPS1 = "<?php echo $_row->groupid;?>";
			
			EMPS = EMPS1.split(",");
			
			for(i=0; i<document.adminForm.id_group.length; i++) {
				for(z=0; z<EMPS.length; z++) {
					if(document.adminForm.id_group[i].value == EMPS[z]) {
						document.adminForm.id_group[i].selected = true;
					}
				}
			}
		}
		</script>

		<?php
		$GLOBALS['title_product_form'] = ( $_row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('download'); ?>

		<?php
		jimport('joomla.html.pane');
		$tabs = & JPane::getInstance('tabs');
		echo $tabs->startPane('PANEL_ID');
		echo $tabs->startPanel('<img src="../components/com_maqmahelpdesk/images/menu/files.png" align="absmiddle" /> '.JText::_('general'), 'TAB_ID1'); ?>
			<form action="index.php" method="POST" id="adminForm" name="adminForm" enctype="multipart/form-data">
			<table cellpadding="4"  class="admintable" cellspacing="1" width="100%">
			<tr>
				<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('name').'::'.JText::_('todo')); ?>"><?php echo JText::_('name'); ?></span>			
				</td>
				<td width="70%"><input class="inputbox" type="text" name="pname" value="<?php echo $_row->pname;?>" size="50" maxlength="100" /></td>
				<td width="20%" rowspan="4" valign="top">
					<table width="100%">
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('license').'::'.JText::_('todo')); ?>"><?php echo JText::_('license'); ?></span>			
						</td>
						<td width="80%"><?php echo $_lists['id_license']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('category').'::'.JText::_('todo')); ?>"><?php echo JText::_('category'); ?></span>			
						</td>
						<td width="80%"><?php echo $_lists['id_category']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('image').'::'.JText::_('todo')); ?>"><?php echo JText::_('image'); ?></span>			
						</td>
						<td align="left"><input class="inputbox" type="file" name="image2" value="" size="50" /></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('image_view').'::'.JText::_('todo')); ?>"><?php echo JText::_('image_view'); ?></span>			
						</td>
						<td align="left"><input class="inputbox" type="file" name="image_view" value="" size="50" /></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('url').'::'.JText::_('todo')); ?>"><?php echo JText::_('url'); ?></span>			
						</td>
						<td align="left"><input class="inputbox" type="text" name="url" value="<?php echo $_row->url;?>" size="50" maxlength="250" /></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('evaluation').'::'.JText::_('todo')); ?>"><?php echo JText::_('evaluation'); ?></span>			
						</td>
						<td align="left"><input class="inputbox" type="text" name="evaluation" value="<?php echo $_row->evaluation;?>" size="50" maxlength="250" /></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('template_file').'::'.JText::_('template_file_desc')); ?>"><?php echo JText::_('template_file'); ?></span>			
						</td>
						<td align="left"><input class="inputbox" type="text" name="template_file" value="<?php echo $_row->template_file;?>" size="50" maxlength="100" /></td>
					</tr>

					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('dl_plataforms').'::'.JText::_('todo')); ?>"><?php echo JText::_('dl_plataforms'); ?></span>			
						</td>
						<td align="left"><input class="inputbox" type="text" name="plataform" value="<?php echo $_row->plataform;?>" size="50" maxlength="250" /></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
						<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('date').'::'.JText::_('todo')); ?>"><?php echo JText::_('date'); ?></span>			
						</td>
						<td align="left">
							<?php echo JHTML::Calendar($_row->id > 0 ? $_row->date : date("Y-m-d"), 'date' , 'date', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'12',  'maxlength'=>'250')) .'</td></tr>';?>
						</td>

						</tr>
			<?php	if( $_row->id > 0 ) { ?>
						<input type="hidden" name="hits" value="<?php echo $_row->hits;?>">
						<tr>
							<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('dl_hits').'::'.JText::_('todo')); ?>"><?php echo JText::_('dl_hits'); ?></span>
							</td>
							<td align="left"><?php echo $_row->hits;?></td>
						</tr>
			<?php	} ?>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('dl_limitations').'::'.JText::_('todo')); ?>"><?php echo JText::_('dl_limitations'); ?></span>
						</td>
						<td align="left"><input class="inputbox" type="text" name="limitations" value="<?php echo $_row->limitations;?>" size="50" maxlength="250" /></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('download_previous').'::'.JText::_('todo')); ?>"><?php echo JText::_('download_previous'); ?></span>
						</td>
						<td width="80%"><?php echo $_lists['download_previous']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('download').'::'.JText::_('todo')); ?>"><?php echo JText::_('download'); ?></span>
						</td>
						<td width="80%"><?php echo $_lists['download_version']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('todo')); ?>"><?php echo JText::_('published'); ?></span>
						</td>
						<td width="80%"><?php echo $_lists['published']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('registered_users').'::'.JText::_('registered_users_desc')); ?>"><?php echo JText::_('registered_users'); ?></span>
						</td>
						<td width="80%"><?php echo $_lists['registered_only']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('offline').'::'.JText::_('todo')); ?>"><?php echo JText::_('offline'); ?></span>
						</td>
						<td width="80%"><?php echo $_lists['offline']; ?></td>
					</tr>
					<tr>
						<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('groups').'::'.JText::_('todo')); ?>"><?php echo JText::_('groups'); ?></span>
						</td>
						<td width="80%"><?php echo $_lists['id_group']; ?></td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>"><?php echo JText::_('description'); ?></span>
				</td>
				<td valign="top" >
					<?php
					// parameters : areaname, content, width, height, cols, rows
					echo $editor->display( 'description',  $_row->description , '100%', '500', '75', '20' ) ;
					?>
				</td>
			</tr>
			<tr>
				<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('dl_features').'::'.JText::_('todo')); ?>"><?php echo str_replace("\'","'",JText::_('dl_features')); ?></span>
				</td>
				<td valign="top">
					<?php
					// parameters : areaname, content, width, height, cols, rows
					echo $editor->display( 'features',  $_row->features , '100%', '300', '75', '20' ) ;
					?>
				</td>
			</tr>
			<tr>
				<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('dl_requirements').'::'.JText::_('todo')); ?>"><?php echo str_replace("\'","'",JText::_('dl_requirements')); ?></span>
				</td>
				<td valign="top" >
					<?php
					// parameters : areaname, content, width, height, cols, rows
					echo $editor->display( 'requirements',  $_row->requirements , '100%', '300', '75', '20' ) ;
					?>
				</td>
			</tr>
			<tr>
			</tr>
			</table>

			<input type="hidden" name="groupid" value="" />
			<input type="hidden" name="updated" value="<?php echo date("Y-m-d"); ?>" />
			<input type="hidden" name="image" value="<?php echo $_row->image; ?>" />
			<input type="hidden" name="published" value="<?php echo $_row->published; ?>" />
			<input type="hidden" name="option" value="com_maqmahelpdesk" />
			<input type="hidden" name="id" value="<?php echo $_row->id; ?>" />
			<input type="hidden" name="id_product" value="<?php echo $_row->id; ?>" />
			<input type="hidden" name="task" value="" />
			</form><?php
			if( $_row->id > 0 ) {
				print '<script type="text/javascript">FillValues();</script>';
			} 
		echo $tabs->endPanel();
		echo $tabs->startPanel('<img src="../components/com_maqmahelpdesk/images/menu/table.png" align="absmiddle" /> '.JText::_('versions'), 'TAB_ID2'); ?>
			<table class="adminlist" width="100%">
	<?php	if( $_row->id == 0 ) { ?>
				<tr>
					<td><?php echo JText::_('create_versions'); ?></td>
				</tr>
	<?php	}else{
				print '<thead>';
				print '<tr>';
				print '   <th>'.JText::_('date').'</th>';
				print '   <th>'.JText::_('version').'</th>';
				print '   <th>'.JText::_('file').'</th>';
				print '   <th>'.JText::_('description').'</th>';
				print '   <th width="20" align="center"></th>';
				print '   <th width="20" align="center"></th>';
				print '</tr>';
				print '</thead>';
				
				$k = 0;
				for($i=0; $i<count($versions); $i++) {
					$row_note = $versions[$i];

					print '<tr class="row'.$k.'">';
					print '   <td>'.$row_note->date.'</td>';
					print '   <td>'.$row_note->version.'</td>';
					print '   <td><a href="index.php?option=com_maqmahelpdesk&task=product_download&id='.$row_note->id.'">'.$row_note->filename.'</a></td>';
					print '   <td>'.$row_note->description.'</td>';
					print '   <td width="20" align="center"><a href="index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&task=product_editversion&id_product='.$row_note->id_download.'&id_version='.$row_note->id.'"><img src="../components/com_maqmahelpdesk/images/16px/edit.png" width="16" height="16" border="0" alt="'.JText::_('edit').'" /></a></td>';
					print '   <td width="20" align="center"><a href="index.php?option=com_maqmahelpdesk&task=product_delversion&id_product='.$row_note->id_download.'&id_version='.$row_note->id.'"><img src="../components/com_maqmahelpdesk/images/16px/delete.png" width="16" height="16" border="0" alt="'.JText::_('delete').'" /></a></td>';
					print '</tr>';

					$k = 1 - $k;
				}

				if( count($versions) == 0 ) {
					print '<tr class="row'.$k.'">';
					print '   <td colspan="7">'.JText::_('dl_no_versions').'</td>';
					print '</tr>';
				}
			} ?>
			</table><?php
		echo $tabs->endPanel();
		echo $tabs->endPane(); ?>
		<script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		
			if( $jMaQma.browser.msie && parseInt($jMaQma.browser.version, 10) == 7 ) {
				$jMaQma("div.current dd table.admintable").css("margin-left","-45px");
			}
		});
		</script><?php 
	}

	static function editVersion( $id_product, $id, $version ) { 
		$editor = JFactory::getEditor();
		$GLOBALS['title_version_id'] = ($version->id > 0 ? JText::_('edit') : JText::_('add') ).' '.JText::_('version'); ?>

		<script language="javascript" type="text/javascript">
		Joomla.submitbutton = function(pressbutton) {
			ShowProgress();
			<?php echo $editor->save( 'vdescription' ); ?>
			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}

		function ShowProgress() {
			middle_width = screen.width / 2;
			middle_height = screen.height / 2;
			
			$jMaQma("#Layer1").css('left',middle_width - 100);
			$jMaQma("#Layer1").css('top',middle_height - 250);
			$jMaQma("#Layer1").show('fade');
		}
		</script>

		<div id="overDiv" style="position:absolute; visibility: hidden;z-index: 1000;"></div>

		<div id="Layer1" style="position: absolute; margin-left: auto; margin-right: auto; width: 200px; height: 125px; z-index: 1; display: none; background-color: #efefef; layer-background-color: #FF0000; border: 1px solid #99989D;">
			<table width="100%">
			<tr>
				<td bgcolor="#330099" height="25">
					&nbsp;<span style="color:#FFFFFF"><?php echo JText::_('upload_msg'); ?></span>
				</td>
			</tr>
			<tr>
				<td align="center" valign="middle">
					<p><?php echo JText::_('file_uploading'); ?></p>
					<p><img src="../components/com_maqmahelpdesk/images/loading.gif"></p>
					<p><?php echo JText::_('please_wait'); ?></p>
				</td>
			</tr>
			</table>
		</div>

		<form action="index.php" method="POST" id="adminForm" name="adminForm" enctype="multipart/form-data">
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="cid" value="<?php echo $id_product;?>" />
		<input type="hidden" name="id_product" value="<?php echo $id_product;?>" />
		<input type="hidden" name="id_version" value="<?php echo (!$version ? 0 : $version->id);?>'" />
		<input type="hidden" name="task" value="product_saveversion" />
		
		<table class="admintable" cellspacing="1" width="100%">
		<tr>
			<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('date').'::'.JText::_('todo')); ?>"><?php echo JText::_('date'); ?></span>
			</td>
			<td>
				<?php echo JHTML::Calendar(($version->date=='' ? date("Y-m-d") : $version->date), 'vdate' , 'vdate', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'12',  'maxlength'=>'10')); ?>
			</td>
		</tr>
		
		<tr>
			<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('version').'::'.JText::_('todo')); ?>" /><?php echo JText::_('version'); ?></span>
			</td>
			<td>
				<input type="text" name="pversion" size="50" maxlength="100" class="inputbox" value="<?php echo (!$version ? '' : $version->version);?>">
			</td>
		</tr>
		<tr>
			<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>"><?php echo JText::_('description'); ?></span>
			</td>
			<td>
				<?php
				// parameters : areaname, content, width, height, cols, rows
				echo $editor->display( 'vdescription',  $version->description , '100%', '200', '75', '20' ) ;
				?>
			</td>
		</tr>
		<tr>
			<td nowrap valign="top" class="key">
				<span class="editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('file').'::'.JText::_('todo')); ?>"><?php echo JText::_('file'); ?></span>
			</td>
			<td>
				<?php echo JText::_('upload_file'); ?><input type="file" name="filename" size="50" class="inputbox" />
				<br /><?php echo JText::_('or'); ?><br />
				<?php echo JText::_('ftp_uploaded'); ?><input type="text" name="filename_exists" size="50" class="inputbox" />
			</td>
		</tr>
		</table>
		</form><?php
	}
}

?>
