<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.stats.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class HTML_stats 
{
	static function showStats( &$downloads, &$pageNav, $lists, $month, $year ) { 
		$database = JFactory::getDBO(); ?>
		
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('reports'); ?></a>
			<a href="javascript:;"><?php echo JText::_('download_stats'); ?></a>
			<span><?php echo JText::_('downloads'); ?></span>
		</div>
		
		<form id="adminForm" name="adminForm" method="post" action="index.php">
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> 
			<?php echo JText::_('month').': '.$lists['month'];?> 
			<?php echo JText::_('year').': '.$lists['year'];?> 
		</div>
		<input type="hidden" name="option" value="com_maqmahelpdesk">
		<input type="hidden" name="task" value="stats">
		</form>
		
		<div class="contentarea"><?php
			$sql = "select id, pname from #__support_dl order by pname";
			$database->setQuery( $sql );
			$rows = $database->loadObjectList();
			$nrwks = count($rows);
			$arrdays = array();
			$wkslabels = '';
			$days = getNumberOfDays( $year, $month );
				
			for( $x=0; $x<count($rows); $x++ )
			{
				$row = $rows[$x];
				$wkslabels .= '<graph gid="'.($x+1).'"><title>'.$row->pname."</title><line_width>3</line_width><bullet>round_outlined</bullet><bullet_size>10</bullet_size><color_hover>#000000</color_hover></graph>";
				$sql = "SELECT DATE_FORMAT( s.dldate, '%d' ) AS DAY , count(*) AS total FROM `#__support_dl_stats` AS s WHERE month(s.`dldate`)=".$database->quote($month)." and year(s.`dldate`)=".$database->quote($year)." AND s.id_download='".$row->id."' GROUP BY DATE_FORMAT( s.dldate, '%d' ) ORDER BY DATE_FORMAT( s.dldate, '%d' )";
				$database->setQuery( $sql );
				$rows_dates = $database->loadObjectList();
				$prev_day = 1;
				for( $i=1; $i<=count($rows_dates); $i++ )
				{
					$row_dates = $rows_dates[$i-1];
					$arrdays[$x][number_format($row_dates->DAY,0)] = $row_dates->total;
				}
			}
				
			$days_values = '';
			for( $i=1; $i<=$days; $i++ )
			{
				$days_values .= $i.' July'.';';
				for( $x=0; $x<$nrwks; $x++ )
				{
					$days_values .= ( isset($arrdays[$x][$i]) ? $arrdays[$x][$i].($nrwks-$x==1 ? '\n' : ';') : '0'.($nrwks-$x==1 ? '\n' : ';') );
				}
			} ?>

			<script type="text/javascript" src="<?php echo JURI::root();?>components/com_maqmahelpdesk/includes/amcharts/ampie/swfobject.js"></script>
			<div id="downloadschart"><strong><?php echo JText::_('upgrade_flash'); ?></strong></div>

			<script type="text/javascript" defer="defer">
				// <![CDATA[		
				var so = new SWFObject("<?php echo JURI::root();?>components/com_maqmahelpdesk/includes/amcharts/amline/amline.swf", "amline", "100%", "600", "8", "#FFFFFF");
				so.addVariable("path", "<?php echo JURI::root();?>components/com_maqmahelpdesk/includes/amcharts/amline/");
				so.addVariable("settings_file", encodeURIComponent("<?php echo JURI::root();?>components/com_maqmahelpdesk/includes/amcharts/amline/amline_settings.xml"));
				so.addVariable("additional_chart_settings", encodeURIComponent('<settings><graphs><?php echo $wkslabels; ?></graphs></settings>'));
				so.addVariable("chart_data", encodeURIComponent("<?php echo $days_values; ?>"));
				so.addVariable("loading_data", "<?php echo JText::_('loading_data'); ?>");
				so.addVariable("preloader_color", "#999999");
				so.addParam("wmode", "transparent");
				so.write("downloadschart");
				// ]]>
			</script>

			<br />
			
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td><div align="center">#</div></td>
				<td><b><?php echo JText::_('dl_product');?></b></td>
				<td><b><?php echo JText::_('user');?></b></td>
				<td><b><?php echo JText::_('dl_version');?></b></td>
				<td><b><?php echo JText::_('filename');?></b></td>
				<td><b><?php echo JText::_('ipaddress');?></b></td>
				<td><div align="center"><b><?php echo JText::_('date');?></b></div></td>
			</tr>
			</thead>
			<tbody><?php
			for($i=0; $i<count($downloads); $i++) {
				$download = $downloads[$i]; ?>
				<tr class="<?php echo "row$k"; ?>">
					<td><div align="center"><b><?php echo ($i+1);?></b></div></td>
					<td><?php echo $download->product;?></td>
					<td><?php echo $download->name;?></td>
					<td><?php echo $download->version;?></td>
					<td><?php echo $download->filename;?></td>
					<td><?php echo $download->ipaddress;?></td>
					<td><div align="center"><?php echo $download->dldate;?></div></td>
				</tr><?php
			} ?>
			<tr>
				<td colspan="7"><?php echo $pageNav->getListFooter(); ?></td>
			</tr>
			</tbody>
			</table><?php
	}

	static function showHits( &$hits ) { ?>
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('reports'); ?></a>
			<a href="javascript:;"><?php echo JText::_('download_stats'); ?></a>
			<span><?php echo JText::_('pagehits'); ?></span>
		</div>
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td><div align="center">#</div></td>
				<td><b><?php echo JText::_('dl_product');?></b></td>
				<td><b><?php echo JText::_('hits');?></b></td>
			</tr>
			</thead>
			<tbody><?php
			for($i=0; $i<count($hits); $i++) {
				$hit = $hits[$i]; ?>
				<tr class="<?php echo "row$k"; ?>">
					<td><div align="center"><b><?php echo ($i+1);?></b></div></td>
					<td><?php echo $hit->product;?></td>
					<td><div align="center"><?php echo $hit->hits;?></div></td>
				</tr><?php
			} ?>
			</tbody>
			</table>
			<br class="clr" />
		</div><?php
	}
}
