<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.types.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class types_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('actitivity_options'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=types"><?php echo JText::_('activity_types'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
        <div class="contentarea">
            <div class="contentarea">
                <table class="contenttable" cellspacing="0">
                <thead>
                <tr>
                    <td width="20" align="right">#</td>
                    <td width="20">
                        <input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
                    </td>
                    <td class="title"><?php echo JText::_('description'); ?></td>
                    <td width="70"><?php echo JText::_('default'); ?></td>
                    <td width="70"><?php echo JText::_('published'); ?></td>
                </tr>
                </thead>
                <tbody><?php
                if (count( $rows )==0) {
                    ?><tr><td colspan="5"><?php echo JText::_('register_not_found'); ?></td></tr><?php
                } else {
                    $k = 0;
                    for ($i=0, $n=count( $rows ); $i < $n; $i++) {
                        $row = &$rows[$i];
                        $img = $row->published ? 'tick' : 'no';
                        $img_def = $row->isdefault ? 'tick' : 'no';
                        $task = $row->published ? 'types_unpublish' : 'types_publish';
                        $alt = $row->published ? JText::_('published') : JText::_('unpublished'); ?>
                        <tr class="<?php echo "row$k"; ?>">
                            <td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
                            <td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
                            <td>
                                <a href="#types_edit" onClick="return listItemTask('cb<?php echo $i;?>','types_edit')">
                                    <?php echo $row->description; ?>
                                </a>
                            </td>
                            <td width="70" align="center">
                                <img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img_def;?>.png" border="0" />
                            </td>
                            <td width="70" align="center">
                                <a href="javascript: void(0);" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
                                    <img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
                                </a>
                            </td><?php
                            $k = 1 - $k; ?>
                        </tr><?php
                    } // for loop
                } // if ?>
                <tbody>
                <tfoot>
                    <tr>
                        <td colspan="5"><?php echo $pageNav->getListFooter(); ?></td>
                    </tr>
                </tfoot>
                </table>
            </div>
            <div id="infobox">
                <span id="infoarrow"></span>
                <dl class="first">
                    <dd class="title"><?php echo JText::_('INFO_TYPES_TITLE');?></dd>
                    <dd class="last">
                        <?php echo JText::_('INFO_TYPES_DESC');?>
                        <p align="center"><a href="http://www.imaqma.com/support/documentation/16-helpdesk-component/96-activities.html" target="_blank" class="mqmbutton gray"><img src="../components/com_maqmahelpdesk/images/16px/help.png" align="absmiddle" border="0" alt="" /> <?php echo JText::_('more_information');?></a></p>
                    </dd>
                </dl>
            </div>
            <br class="clr" />
        </div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="types" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) { 
		$GLOBALS['titulo_types_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('activity_type'); ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'types') {
				submitform( pressbutton );
				return;
			}

			if (form.description.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else {
				submitform(pressbutton);
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'types') {
				submitform( pressbutton );
				return;
			}

			if (form.description.value == ""){
				alert("<?php echo JText::_('description_required'); ?>");
			} else {
				Joomla.submitform(pressbutton, document.getElementById('adminForm'));
			}
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="javascript:;"><?php echo JText::_('actitivity_options'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=types"><?php echo JText::_('activity_types'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('description').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('description'); ?>
				</span> 
				<input class="large" type="text" id="description" name="description" value="<?php echo $row->description; ?>" maxlength="50" />
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('is_default').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('is_default'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['isdefault']; ?>
				</div>
			</div>
			<div class="field w50">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('published').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('published'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['published']; ?>
				</div>
			</div>
			<br class="clr" />
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
        <script type='text/javascript'>
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}
}
