<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.update.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class update_html {
	/**
	* Writes a list of the categories for a section
	* @param array An array of category objects
	* @param string The name of the category section
	*/
	static function showStep1( $rowsAddOns ) { 
		global $dbtables, $dbfields; 
		
		$CONFIG = new JConfig();
		include_once( JPATH_SITE.'/components/com_maqmahelpdesk/classes/folders_and_files.php' );
		
		// Frontend permissions
		$oDir = new CDir();
		$oDir->Read( JPATH_SITE.'/components/com_maqmahelpdesk/', "/\.(php|html|swf)*$/", true, false, true, "", "", true );
		$oDir->Sort( 'Fullname', true );
		$frontend = '';
		foreach( $oDir->aFiles as $aFile )
		{
			$sFullname = $oDir->FullName( $aFile );
			$bWritable = $oDir->IsWritable( $aFile );
			$frontend .= '<tr><td><img src="../components/com_maqmahelpdesk/images/16px/'.($bWritable ? 'tick' : 'no').'.png" /> '.JPATH_SITE.'/components/com_maqmahelpdesk/'.$sFullname.'</td></tr>';
		}
		unset($oDir);
		
		// Administration permissions
		$oDir = new CDir();
		$oDir->Read( JPATH_SITE.'/administrator/components/com_maqmahelpdesk/', "/\.(php|html|swf)*$/", true, false, true, "", "", true );
		$oDir->Sort( 'Fullname', true );
		$admin = '';
		foreach( $oDir->aFiles as $aFile )
		{
			$sFullname = $oDir->FullName( $aFile );
			$bWritable = $oDir->IsWritable( $aFile );
			$admin .= '<tr><td><img src="../components/com_maqmahelpdesk/images/16px/'.($bWritable ? 'tick' : 'no').'.png" /> '.JPATH_SITE.'/administrator/components/com_maqmahelpdesk/'.$sFullname.'</td></tr>';
		}
		unset($oDir); ?>
		
		
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<span><?php echo JText::_('tools'); ?></span>
		</div>
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<ul class="leftmenu">
						<li class="current"><a href="#" onclick="MaQmaJS.SelectTab(this,1);"><img src="../components/com_maqmahelpdesk/images/menu/addons.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('addons');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,2);"><img src="../components/com_maqmahelpdesk/images/16px/lock.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('permissions');?></a></li>
					</ul>
				</div>
			</div>
			<div class="contentbar withleft">
				<div id="tab1" class="contenttab" style="display:block;">
					<table class="contenttable" cellspacing="0">
					<thead>
					<tr>
						<th class="title"><?php echo JText::_('name'); ?></th>
						<th class="title" width="100" align="center"><?php echo JText::_('type'); ?></th>
						<th class="title" width="50"><div align="center"><?php echo JText::_('version'); ?></div></th>
						<th class="title" width="50"><div align="center"><?php echo JText::_('published'); ?></div></th>
					</tr>
					</thead>
					<tbody><?php
					if( count( $rowsAddOns ) == 0 ) {
						print '<tr><td colspan="5">'.JText::_('no_addons_installed').'</td></tr>';
					}
					
					$k = 0;
					for ($i=0, $n=count( $rowsAddOns ); $i < $n; $i++) {
						$row = &$rowsAddOns[$i];
						$img = $row->publish ? 'tick' : 'no';
						$alt = $row->publish ? JText::_('published') : JText::_('unpublished');
						switch( $row->execution )
						{
							case 0:
								$exec = '-';
								break;
							case 1:
								$exec = JText::_('cron_manual');
								break;
							case 2:
								$exec = JText::_('new_ticket');
								break;
							case 3:
								$exec = JText::_('new_ticket_customer');
								break;
							case 4:
								$exec = JText::_('new_ticket_staff');
								break;
							case 5:
								$exec = JText::_('new_reply');
								break;
							case 6:
								$exec = JText::_('new_reply_customer');
								break;
							case 7:
								$exec = JText::_('new_reply_staff');
								break;
						} ?>
						
						<tr class="<?php echo "row$k"; ?>">
							<td>
								<p><?php echo $row->lname; ?> <br />
								<small><a href="../index.php?option=com_maqmahelpdesk&task=addon&addon=<?php echo $row->sname; ?>&SecretWord=<?php echo $CONFIG->secret; ?>&format=raw&tmpl=component" target="_blank"><?php echo JURI::root();?>index.php?option=com_maqmahelpdesk&task=addon&addon=<?php echo $row->sname; ?>&SecretWord=<?php echo $CONFIG->secret; ?>&format=raw&tmpl=component</a></small></p>
								<p><i><?php echo $row->description; ?></i></p>
							</td>
							<td width="100" align="center"><?php echo $exec; ?></td>
							<td width="50"><div align="center"><?php echo $row->version; ?></div></td>
							<td width="50">
								<div align="center">
									<a href="index.php?option=com_maqmahelpdesk&task=update_publish&id=<?php echo $row->id; ?>&value=<?php echo ($row->publish==1 ? 0 : 1); ?>">
										<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
									</a>
								</div>
							</td>
						</tr><?php	
						$k = 1 - $k;
					} // for loop ?>
					</tbody>
					</table>
				</div>
				<div id="tab2" class="contenttab">
					<table class="contenttable" cellspacing="0">
					<thead>
					<tr>
						<th><?php echo JText::_('frontend_folders'); ?></th>
					</tr>
					</thead>
					<tbody>
					<?php echo $frontend; ?>
					</tbody>
					</table>
					
					<table class="contenttable" cellspacing="0">
					<thead>
					<tr>
						<th><?php echo JText::_('admin_folders'); ?></th>
					</tr>
					</thead>
					<tbody>
						<?php echo $admin; ?>
					</tbody>
					</table>
				</div>
			</div>
		</div><?php
	}
}
