<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: admin.users.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class users_fields_html 
{
	static function show( &$rows, &$pageNav ) { ?>
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=users"><?php echo JText::_('users_manager'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=users_fields"><?php echo JText::_('users_cfield_menu'); ?></a>
			<span><?php echo JText::_('manager'); ?></span>
		</div>
		<div class="contentarea">
			<table id="contentTable" class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" nowrap="nowrap"></td>
				<th width="20" align="right">#</th>
				<th width="20">
					<input type="checkbox" id="checkall-toggle" name="checkall-toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
				</th>
				<th class="title"><?php echo JText::_('field_name'); ?></th>
				<th class="title"><?php echo JText::_('field_type'); ?></th>
				<th width="70" align="center"><?php echo JText::_('required'); ?></th>
			</tr>
			</thead>
			<tbody>
			<?php
			if (count( $rows )==0) {
				?><tr><td colspan="6"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				$j = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row = &$rows[$i];
					$img = $row->required ? 'tick' : 'no';
					$alt = $row->required ? JText::_('required_tooltip') : JText::_('not_required_tooltip');
					?>
					<tr id="contentTable-row-<?php echo ($row->id);?>" class="<?php echo "row$k"; ?>">
						<td align="left" width="20" align="right" class="dragHandle"></td>
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
						<td>
							<a href="#users_fieldsedit" onClick="return listItemTask('cb<?php echo $i;?>','users_fieldsedit')">
								<?php echo $row->caption; ?>
							</a>
						</td>
						<td><?php echo JText::_('formfield_'.$row->ftype); ?></td>
						<td align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt;?>" />
						</td><?php		
						$k = 1 - $k;
						$j++; ?>
					</tr>
					<?php	
				} // for loop 
			} // if ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="7">
						<?php echo $pageNav->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			</table>
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="users_fields" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
			
			$jMaQma("#checkall-toggle").click(function(){ 
				if( $jMaQma("#checkall-toggle").is(":checked") ) {
					$jMaQma("#adminForm input[type=checkbox]").parent().addClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked','checked');
				}else{
					$jMaQma("#adminForm input[type=checkbox]").parent().removeClass("checked");
					$jMaQma("#adminForm input[type=checkbox]").attr('checked',false);
				}
			});
			
			$jMaQma('#contentTable').tableDnD({
				onDrop: function(table, row) {
					window.location = 'index.php?option=com_maqmahelpdesk&task=users_saveorder&'+$jMaQma('#contentTable').tableDnDSerialize();
				},
				dragHandle: "dragHandle"
			});
			
			$jMaQma("#contentTable tr").hover(function() {
				  $jMaQma(this.cells[0]).addClass('showDragHandle');
			}, function() {
				  $jMaQma(this.cells[0]).removeClass('showDragHandle');
			});
		});
		</script><?php
	}

	static function edit( &$row, $lists ) { 
		$GLOBALS['titulo_usersfield_edit'] = ( $row->id ? JText::_('edit') : JText::_('add') ).' '.JText::_('cfield'); ?>
		<script language="javascript" type="text/javascript">
		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'users_fields') {
				submitform( pressbutton );
				return;
			}

			submitform(pressbutton);
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'users_fields') {
				submitform( pressbutton );
				return;
			}

			Joomla.submitform(pressbutton, document.getElementById('adminForm'));
		}
		<?php } ?>
		</script>

		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=users"><?php echo JText::_('users_manager'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=users_fields"><?php echo JText::_('users_cfield_menu'); ?></a>
			<span><?php echo JText::_('manager'); ?></span>
		</div>
		<div class="contentarea">
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('field').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('field'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['fields']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('required').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('required'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['required']; ?>
				</div>
			</div>
			<div class="field w100">
				<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('ordering').'::'.JText::_('todo')); ?>">
					<?php echo JText::_('ordering'); ?>
				</span> 
				<div class="controlset-pad">
					<?php echo $lists['ordering']; ?>
				</div>
			</div>
		</div>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		</form>
		
		<script type="text/javascript">
		$jMaQma(document).ready(function(){
			$jMaQma("input, textarea, select").uniform();
		});
		</script><?php 
	}
}

class HTML_users 
{
	static function showUsers( &$rows, $pageNav, $search, $lists ) { ?>
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=users"><?php echo JText::_('users_manager'); ?></a>
			<span><?php echo JText::_('manage'); ?></span>
		</div>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm">
		<div id="filtersarea">
			<?php echo strtoupper(JText::_('filters'));?> <img src="components/com_maqmahelpdesk/images/separator2.png" style="padding:5px;" align="absmiddle" /> 
			<input type="text" name="search" value="<?php echo $search;?>" class="inputbox" onChange="document.adminForm.submit();" />
			<?php echo JText::_('status').': '.$lists['logged'];?>
		</div>
		
		<div class="contentarea">
			<table class="contenttable" cellspacing="0">
			<thead>
			<tr>
				<td width="20" align="right">#</td>
				<td width="3%" class="title">&nbsp;</td>
				<td class="title"><?php echo JText::_('name'); ?></td>
				<td width="20%" class="title"><?php echo JText::_('tpl_client') ?></td>
				<td width="5%" class="title" align="center" nowrap="nowrap"><?php echo JText::_('loggedin'); ?></td>
				<td width="5%" class="title" align="center"><?php echo JText::_('enabled'); ?></td>
			</tr>
			</thead>
			<tbody>
			<?php
			if (count( $rows )==0) {
				?><tr><td colspan="7"><?php echo JText::_('register_not_found'); ?></td></tr><?php
			} else {
				$k = 0;
				for ($i=0, $n=count( $rows ); $i < $n; $i++) {
					$row 	=& $rows[$i];
					$img 	= $row->block ? 'no' : 'tick';
					$task 	= $row->block ? 'users_unblock' : 'users_block';
					$alt 	= $row->block ? JText::_('blocked') : JText::_('enabled');
					$link 	= 'index.php?option=com_maqmahelpdesk&task=users_edit&cid[0]='.$row->id; ?>
					<tr class="<?php echo "row$k"; ?>">
						<td width="20" align="right"><span class="mqmnumber"><?php echo $row->id; ?></span></td>
						<td align="center"><?php echo JHTML::_('grid.id', $i, $row->id ); ?></td>
						<td>
							<div class="drop-shadow curved curved-hz-1" style="margin-right:5px;"><img src="<?php echo mqm_getavatar($row->id);?>" alt="" align="left" /></div>
							<a href="<?php echo $link; ?>"><?php echo $row->name; ?></a> <small><em>(<?php echo $row->username; ?>)</em></small><br />
							<small><em><a href="mailto:<?php echo $row->email; ?>"><?php echo $row->email; ?></a></em></small>
						</td>
						<td>
							<?php echo $row->clientname ? $row->clientname : JText::_('no_client'); ?>
						</td>
						<td align="center">
							<?php echo $row->loggedin ? '<img src="../components/com_maqmahelpdesk/images/16px/tick.png" border="0" alt="" />': ' &nbsp; '; ?>
						</td>
						<td align="center">
							<img src="../components/com_maqmahelpdesk/images/16px/<?php echo $img;?>.png" border="0" alt="<?php echo $alt; ?>" />
						</td>
					</tr><?php
					$k = 1 - $k;
				} // for loop
			} // if ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="11">
						<?php echo $pageNav->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			</table>
			<br class="clr" />
		</div>

		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="users" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="hidemainmenu" value="0" />
		</form>

        <script type="text/javascript">
        $jMaQma(document).ready(function(){
            $jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
        });
        </script><?php
	}

	static function edituser( &$row, $uid, $userInfo, $cfields ) 
	{
		global $supportConfig;
		JHTML::_('behavior.tooltip');
		$GLOBALS['titulo_usersfields_edit'] = ( (isset($row->id)) ? JText::_('edit') : JText::_('add') ).' '.JText::_('user');
		$GLOBALS['titulo_users_edit'] = ( (isset($row->id)) ? JText::_('edit') : JText::_('add') ).' '.JText::_('user'); ?>

		<script language="javascript" type="text/javascript">
		function showMore()
		{
			$jMaQma('#more').toggle()
		}

		<?php if( jversion15_check() ) { ?>
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'users') {
				submitform( pressbutton );
				return;
			}
			
			var r = new RegExp("[\<|\>|\"|\'|\%|\;|\(|\)|\&|\+|\-]", "i");<?php
			
			if( $supportConfig->rf_phone ) {
				echo 'if (form.phone.value == "") {'."\n";
				echo 'alert( "'.JText::_('phone_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_fax ) {
				echo 'if (form.fax.value == "") {'."\n";
				echo 'alert( "'.JText::_('fax_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_mobile ) {
				echo 'if (form.mobile.value == "") {'."\n";
				echo 'alert( "'.JText::_('mobile_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_address1 ) {
				echo 'if (form.address1.value == "") {'."\n";
				echo 'alert( "'.JText::_('address1_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_address2 ) {
				echo 'if (form.address2.value == "") {'."\n";
				echo 'alert( "'.JText::_('address2_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_zipcode ) {
				echo 'if (form.zipcode.value == "") {'."\n";
				echo 'alert( "'.JText::_('zip_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_location ) {
				echo 'if (form.location.value == "") {'."\n";
				echo 'alert( "'.JText::_('location_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_city ) {
				echo 'if (form.city.value == "") {'."\n";
				echo 'alert( "'.JText::_('city_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_country ) {
				echo 'if (form.country.value == "") {'."\n";
				echo 'alert( "'.JText::_('country_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			} 
		
			// Custom fields 
			for( $x=0; $x<count($cfields); $x++ )
			{ 
				$cfield = $cfields[$x];
				if( $cfield->required ) {
					echo 'if (form.custom'.$cfield->id_field.'.value == "") {'."\n";
					echo 'alert( "'.JText::_('cfield_required').' '.$cfield->caption.'." );'."\n";
					echo '}'."\n";
				}
			} ?>

			else {
				submitform( pressbutton );
			}
		}
		<?php } else { ?>
		Joomla.submitbutton = function(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'users') {
				submitform( pressbutton );
				return;
			}
			var r = new RegExp("[\<|\>|\"|\'|\%|\;|\(|\)|\&|\+|\-]", "i");<?php
			
			if( $supportConfig->rf_phone ) {
				echo 'if (form.phone.value == "") {'."\n";
				echo 'alert( "'.JText::_('phone_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_fax ) {
				echo 'if (form.fax.value == "") {'."\n";
				echo 'alert( "'.JText::_('fax_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_mobile ) {
				echo 'if (form.mobile.value == "") {'."\n";
				echo 'alert( "'.JText::_('mobile_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_address1 ) {
				echo 'if (form.address1.value == "") {'."\n";
				echo 'alert( "'.JText::_('address1_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_address2 ) {
				echo 'if (form.address2.value == "") {'."\n";
				echo 'alert( "'.JText::_('address2_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_zipcode ) {
				echo 'if (form.zipcode.value == "") {'."\n";
				echo 'alert( "'.JText::_('zip_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_location ) {
				echo 'if (form.location.value == "") {'."\n";
				echo 'alert( "'.JText::_('location_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_city ) {
				echo 'if (form.city.value == "") {'."\n";
				echo 'alert( "'.JText::_('city_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			}
			if( $supportConfig->rf_country ) {
				echo 'if (form.country.value == "") {'."\n";
				echo 'alert( "'.JText::_('country_required').'" );'."\n";
				echo 'return false;'."\n";
				echo '}'."\n";
			} 
		
			// Custom fields 
			for( $x=0; $x<count($cfields); $x++ )
			{ 
				$cfield = $cfields[$x];
				if( $cfield->required ) {
					echo 'if (form.custom'.$cfield->id_field.'.value == "") {'."\n";
					echo 'alert( "'.JText::_('cfield_required').' '.$cfield->caption.'." );'."\n";
					echo '}'."\n";
				}
			} ?>

			else {
				submitform( pressbutton );
			}
		}
		<?php } ?>
		</script>
		
		<form action="index.php" method="post" id="adminForm" name="adminForm" class="label-inline">
		<div class="breadcrumbs">
			<a href="index.php?option=com_maqmahelpdesk"><?php echo JText::_('control_panel'); ?></a>
			<a href="index.php?option=com_maqmahelpdesk&task=users"><?php echo JText::_('users_manager'); ?></a>
			<span><?php echo JText::_('edit'); ?></span>
		</div>
		<div class="contentarea withleft">
			<div class="sidebar">
				<div class="content" style="display: block;">
					<div class="avatar-bg">
						<div class="drop-shadow curved curved-hz-1" style="margin-right:5px;"><img src="<?php echo mqm_getavatar($row->id); ?>" /></div>
						<b><?php echo $row->name; ?></b>
					</div>
					<ul class="leftmenu">
						<li class="current"><a href="#" onclick="MaQmaJS.SelectTab(this,1);"><img src="../components/com_maqmahelpdesk/images/menu/users.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('general');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,2);"><img src="../components/com_maqmahelpdesk/images/menu/table.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('other');?></a></li>
						<li><a href="#" onclick="MaQmaJS.SelectTab(this,3);"><img src="../components/com_maqmahelpdesk/images/menu/forms.png" border="0" align="absmiddle" />&nbsp; <?php echo JText::_('more');?></a></li>
					</ul>
				</div>
			</div>
			<div class="contentbar withleft">
				<div id="tab1" class="contenttab" style="display:block;">
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('username').'::'.JText::_('todo')); ?>"><?php echo JText::_('username'); ?></span> 
						<div style="margin-left:170px;"><?php echo $row->username; ?></div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('email').'::'.JText::_('todo')); ?>"><?php echo JText::_('email'); ?></span> 
						<div style="margin-left:170px;"><?php echo $row->email; ?></div>
					</div><?php
					if( $uid ) {?>
						<div class="field w100">
							<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('client').'::'.JText::_('todo')); ?>"><?php echo JText::_('client'); ?></span> 
							<div style="margin-left:170px;"><?php echo $userInfo->clientname; ?></div>
						</div><?php
					} ?>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('last_visit_date').'::'.JText::_('todo')); ?>"><?php echo JText::_('last_visit_date'); ?></span> 
						<div style="margin-left:170px;"><?php echo shortdate($row->lastvisitDate);?></div>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('register_date').'::'.JText::_('todo')); ?>"><?php echo JText::_('register_date'); ?></span> 
						<div style="margin-left:170px;"><?php echo shortdate($row->registerDate);?></div>
					</div>
				</div>
				<div id="tab2" class="contenttab">
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('phone').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('phone'); ?>
						</span> 
						<input class="medium" type="text" id="phone" name="phone" value="<?php echo $userInfo->phone; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_phone ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('fax').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('fax'); ?>
						</span> 
						<input class="medium" type="text" id="fax" name="fax" value="<?php echo $userInfo->fax; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_fax ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('mobile').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('mobile'); ?>
						</span> 
						<input class="medium" type="text" id="mobile" name="mobile" value="<?php echo $userInfo->mobile; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_mobile ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('address1').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('address1'); ?>
						</span> 
						<input class="large" type="text" id="address1" name="address1" value="<?php echo $userInfo->address1; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_address1 ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w100">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('address2').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('address2'); ?>
						</span> 
						<input class="large" type="text" id="address2" name="address2" value="<?php echo $userInfo->address2; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_address2 ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('zipcode').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('zipcode'); ?>
						</span> 
						<input class="medium" type="text" id="zipcode" name="zipcode" value="<?php echo $userInfo->zipcode; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_zipcode ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('location').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('location'); ?>
						</span> 
						<input class="medium" type="text" id="location" name="location" value="<?php echo $userInfo->location; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_location ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('city').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('city'); ?>
						</span> 
						<input class="medium" type="text" id="city" name="city" value="<?php echo $userInfo->city; ?>" maxlength="100" />
						<?php echo $supportConfig->rf_city ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<div class="field w50">
						<span class="label editlinktip hasTip" title="<?php echo htmlspecialchars(JText::_('country').'::'.JText::_('todo')); ?>">
							<?php echo JText::_('country'); ?>
						</span> 
						<select id="country" name="country" class="inputbox">
						<option value=""></option>
							<?php include( JPATH_SITE.'/components/com_maqmahelpdesk/includes/countries.php' ); ?>
						</select>
						<?php echo $supportConfig->rf_country ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
					</div>
					<br class="clr" />
					<?php echo JText::_('field_required_desc_admin');?>
				</div>
				<div id="tab3" class="contenttab">
					<table class="contenttable" cellspacing="0"><?php
					if( count($cfields) == 0 ) {
						print '<tr><td>'.JText::_('no_fields').'</td></tr>';
					}
					for( $x=0; $x<count($cfields); $x++ )
					{ 
						$cfield = $cfields[$x]; ?>
						<tr>
							<td nowrap valign="top" class="key">
							<span class="editlinktip hasTip" title="<?php echo htmlspecialchars($cfield->caption.'::'.JText::_('todo')); ?>"><?php echo $cfield->caption; ?></span>			
							</td>
							<td align="left"><?php 
								echo WriteField( 0, $cfield->id_field, $cfield->ftype, $cfield->value, $cfield->size, $cfield->maxlength, $row->id ); 
								echo $cfield->required ? '<img src="../components/com_maqmahelpdesk/images/16px/link.png" border="0" alt="'.JText::_('required').'" align="absmiddle" />' : ''; ?>
							</td>
						</tr><?php
					} ?>
					</table>
					<br class="clr" />
					<?php echo JText::_('field_required_desc_admin');?>
				</div>
			</div>
		</div>
		
		<input type="hidden" name="avatar" value="<?php echo mqm_getavatar($row->id); ?>" />
		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="contact_id" value="" />
		</form>
		
		<script type='text/javascript'> 
		function SelectCountry( COUNTRY )
		{
			$jMaQma("#country").val(COUNTRY);
		}

        $jMaQma(document).ready(function(){
            $jMaQma("input[type='text'], input[type='checkbox'], input[type='radio'], textarea, select").uniform();
		    SelectCountry( '<?php echo $userInfo->country; ?>' );
        });
		</script><?php
	}
}
