<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: update_old.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

// Ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$database = JFactory::getDBO();

// Check if Daily Activities addon is installed
$sql = "SELECT COUNT(*) 
		FROM `#__support_addon` 
		WHERE `sname`='activities'";
$database->setQuery( $sql );
if( $database->loadResult() == 0 ) {
	$database->setQuery( "INSERT INTO `#__support_addon` (`sname`, `lname`, `description`, `iscore`, `version`, `execution`, `menu`, `date`, `publish`) 
						  VALUES('activities', 'Daily Activities', 'The <b>Daily Activities</b> add-on allows you to receive a daily email with all the activities that happen in the component for the previous day.', 1, '1.0', 1, '', '2011-07-05', 1);" );
	$database->query();
}

// Check if Daily Activities addon is installed
$sql = "SELECT COUNT(*) 
		FROM `#__support_addon` 
		WHERE `sname`='rating'";
$database->setQuery( $sql );
if( $database->loadResult() == 0 ) {
	$database->setQuery( "INSERT INTO `#__support_addon` (`sname`, `lname`, `description`, `iscore`, `version`, `execution`, `menu`, `date`, `publish`) 
						  VALUES('rating', 'Rating Request', 'The <b>Rating Request</b> add-on allows you to an e-mail to customers in which the tickets were closed in the previous day without rating.', 1, '1.0', 1, '', '2011-12-02', 1);" );
	$database->query();
}

// Table Updates
if( !CheckField('#__support_config','anonymous_tickets') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `anonymous_tickets` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_client','clientid') ) {
	$database->setQuery( "ALTER TABLE `#__support_client` ADD `clientid` VARCHAR( 10 ) NOT NULL;" ); $database->query();
}
if( !CheckField('#__support_client','taxnumber') ) {
	$database->setQuery( "ALTER TABLE `#__support_client` ADD `taxnumber` VARCHAR( 15 ) NOT NULL;" ); $database->query();
}
if( CheckField('#__support_custom_fields','ftype') ) {
	$database->setQuery( "ALTER TABLE `#__support_custom_fields` CHANGE  `ftype`  `ftype` ENUM(  'text',  'select',  'radio',  'checkbox',  'textarea',  'htmleditor',  'dbselect', 'date' ) NOT NULL DEFAULT  'text';" ); $database->query();
}
if( !CheckField('#__support_workgroup','id_priority') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `id_priority` INT( 11 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_ticket','master_ticket') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` ADD `master_ticket` INT( 11 ) NOT NULL DEFAULT '0'" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_workgroup_category_assign` ( `id_workgroup` INT( 11 ) NOT NULL , `id_category` INT( 11 ) NOT NULL , `id_user` INT( 11 ) NOT NULL , PRIMARY KEY (  `id_workgroup` ,  `id_category` ,  `id_user` ) );" ); $database->query();
if( !CheckField('#__support_config','post_comments_in_wall') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `post_comments_in_wall` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','use_jomsocial_avatars') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_jomsocial_avatars` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','post_kb_creation_in_wall') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `post_kb_creation_in_wall` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_dl','image_view') ) {
	$database->setQuery( "ALTER TABLE `#__support_dl` ADD `image_view` VARCHAR( 200 ) NULL DEFAULT '';" ); $database->query();
}
if( CheckField('#__support_kb','question') ) {
	$database->setQuery( 'UPDATE `#__support_kb` SET `question`=CONCAT(`question`,"\n\n",`resolution`);' ); $database->query();
	$database->setQuery( "ALTER TABLE `#__support_kb` CHANGE `question` `content` LONGTEXT NOT NULL;" ); $database->query();
}
if( CheckField('#__support_kb','resolution') ) {
	$database->setQuery( "ALTER TABLE `#__support_kb` DROP `resolution`" ); $database->query();
}
if( CheckField('#__support_config','debug_component') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` DROP `debug_component`, DROP `rating`, DROP `html_content`, DROP `kb_html`;" ); $database->query();
}
$database->setQuery( "UPDATE `#__support_config` SET `extensions`='pdf,tar,gz,bmp,gif,jpg,png,zip,txt';" ); $database->query();
if( !CheckField('#__support_log','image') ) {
	$database->setQuery( "ALTER TABLE `#__support_log` ADD `image` VARCHAR( 25 ) NULL DEFAULT NULL;" ); $database->query();
}
$database->setQuery( "UPDATE `#__support_log` SET `image`='change.gif' WHERE `image`='';" ); $database->query();
if( !CheckField('#__support_dl_category','image') ) {
	$database->setQuery( "ALTER TABLE `#__support_dl_category` ADD `image` VARCHAR( 100 ) NULL DEFAULT NULL;" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','remove') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `remove` TINYINT( 1 ) NOT NULL DEFAULT '1';" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_views` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`id_user` INT( 11 ) NOT NULL ,`name` VARCHAR( 100 ) NOT NULL ,`viewtype` VARCHAR( 10 ) NOT NULL ,`ordering` VARCHAR( 20 ) NOT NULL ,`operator` TEXT NOT NULL ,`field` TEXT NOT NULL ,`arithmetic` TEXT NOT NULL ,`value` TEXT NOT NULL, `default` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0);" ); $database->query();
if( !CheckField('#__support_ticket','id_ticket_parent') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` ADD `id_ticket_parent` INT( 11 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_ticket','sticky') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` ADD `sticky` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_mail_queue','cc') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_queue` ADD `cc` TEXT NULL , ADD `bcc` TEXT NULL;" ); $database->query();
}
if( CheckField('#__support_ticket','date_support') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` CHANGE `date_support` `date_support` DATETIME NULL DEFAULT NULL;" ); $database->query();
}
$database->setQuery( "UPDATE `#__support_ticket` set `date_support`=NULL WHERE substring(`date_support`,1,4)='0000';" ); $database->query();
if( CheckField('#__support_custom_fields','caption') ) {
	$database->setQuery( "ALTER TABLE `#__support_custom_fields` CHANGE `caption` `caption` TEXT NOT NULL DEFAULT '';" ); $database->query();
}
if( CheckField('#__support_custom_fields','ftype') ) {
	$database->setQuery( "ALTER TABLE `#__support_custom_fields` CHANGE `ftype` `ftype` ENUM( 'text', 'select', 'radio', 'checkbox', 'textarea', 'htmleditor', 'dbselect', 'date', 'country', 'state', 'note' ) NOT NULL DEFAULT 'text';" ); $database->query();
}
if( !CheckField('#__support_custom_fields','tooltip') ) {
	$database->setQuery( "ALTER TABLE `#__support_custom_fields` ADD `tooltip` TEXT NULL;" ); $database->query();
}
if( CheckField('#__support_form_field','caption') ) {
	$database->setQuery( "ALTER TABLE `#__support_form_field` CHANGE `caption` `caption` TEXT NOT NULL;" ); $database->query();
}
if( !CheckField('#__support_client','logo') ) {
	$database->setQuery( "ALTER TABLE `#__support_client` ADD `logo` varchar(250) default NULL;" ); $database->query();
}
if( !CheckField('#__support_config','google_adwords') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `google_adwords` varchar(50) default NULL;" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','extra_info') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `extra_info` varchar(20) NOT NULL default '';" ); $database->query();
}
$database->setQuery( "DELETE FROM `#__support_links` WHERE `link`='index.php?option=com_maqmahelpdesk&task=tickets'" ); $database->query();
if( !CheckField('#__support_config','integrate_mtree') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `integrate_mtree` TINYINT(1) default 0;" ); $database->query();
}
if( !CheckField('#__support_config','discussions_moderated') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `discussions_moderated` TINYINT(1) default 1;" ); $database->query();
}
if( !CheckField('#__support_config','integrate_artofuser') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `integrate_artofuser` TINYINT(1) default 0;" ); $database->query();
}
if( !CheckField('#__support_workgroup','enable_discussions') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `enable_discussions` TINYINT(1) default 0;" ); $database->query();
}
if( !CheckField('#__support_ticket','id_directory') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` ADD `id_directory` INT(11) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','integrate_sobi') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `integrate_sobi` TINYINT(1) default 0;" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_discussions` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`id_user` INT( 11 ) NOT NULL ,`id_category` INT( 11 ) NOT NULL DEFAULT '0',`date_created` DATETIME NOT NULL , `title` VARCHAR( 100 ) NOT NULL ,`content` TEXT NOT NULL ,`published` TINYINT( 1 ) NOT NULL DEFAULT '1',`status` TINYINT( 1 ) NOT NULL DEFAULT '0',`converted` INT( 11 ) NOT NULL DEFAULT '0', `tags` VARCHAR( 250 ) NULL, `views` INT( 11 ) NOT NULL DEFAULT '0', `votes` INT( 11 ) NOT NULL DEFAULT '0');" ); $database->query();
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_discussions_messages` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`id_discussion` INT( 11 ) NOT NULL ,`id_user` INT( 11 ) NOT NULL ,`is_support` TINYINT( 1 ) NOT NULL DEFAULT '0',`date_created` DATETIME NOT NULL ,`content` TEXT NOT NULL ,`published` TINYINT NOT NULL DEFAULT '0', `votes` INT( 11 ) NOT NULL DEFAULT '0');" ); $database->query();
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_discussions_subscribe` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`id_discussion` INT( 11 ) NOT NULL ,`id_user` INT( 11 ) NOT NULL);" ); $database->query();
if( !CheckField('#__support_config','use_cb_avatars') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_cb_avatars` TINYINT(1) default 0;" ); $database->query();
}
if( !CheckField('#__support_workgroup','contract_total_disable') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `contract_total_disable` TINYINT(1) default 0;" ); $database->query();
}
if( !CheckField('#__support_config','mobile_interface') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `mobile_interface` TINYINT(1) default 0;" ); $database->query();
}
if( !CheckField('#__support_config','offset') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `offset` TINYINT(3) NOT NULL DEFAULT '0';" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_activities` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`id_user` INT( 11 ) NOT NULL ,`ip_address` VARCHAR( 25 ) NOT NULL ,`client` VARCHAR( 10 ) NOT NULL ,`section` VARCHAR( 25 ) NOT NULL ,`action` VARCHAR( 25 ) NOT NULL ,`id_table` INT( 11 ) NOT NULL ,`date_created` DATETIME NOT NULL ,`link` VARCHAR( 250 ) NOT NULL, `is_support` TINYINT(1) NOT NULL default '0', `id_client` INT( 11 ) NOT NULL);" ); $database->query();
if( !CheckField('#__support_config','js_post_question_wall') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `js_post_question_wall` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','js_post_answer_wall') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `js_post_answer_wall` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','js_post_votes_wall') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `js_post_votes_wall` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','js_answer_selected_wall') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `js_answer_selected_wall` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_discussions_votes` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY, `id_discussion` INT( 11 ) NOT NULL, `id_message` INT( 11 ) NOT NULL, `id_user` INT( 11 ) NOT NULL ,`date_created` DATETIME NOT NULL ,`vote` INT( 11 ) NOT NULL DEFAULT '0');" ); $database->query();
if( !CheckField('#__support_discussions','id_workgroup') ) {
	$database->setQuery( "ALTER TABLE `#__support_discussions` ADD `id_workgroup` INT(11) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','profile_required') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `profile_required` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_kb_comment','id_workgroup') ) {
	$database->setQuery( "ALTER TABLE `#__support_kb_comment` ADD `id_workgroup` INT(11) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_kb_comment','itemid') ) {
	$database->setQuery( "ALTER TABLE `#__support_kb_comment` ADD `itemid` INT(11) NOT NULL DEFAULT '0';" ); $database->query();
}
$database->setQuery( "UPDATE `#__support_users` SET `avatar`=CONCAT('".JURI::root()."components/com_maqmahelpdesk/images/avatars/',`avatar`) WHERE SUBSTRING(`avatar`,1,4)!='http'" ); $database->query();
if( !CheckField('#__support_mail_fetch','queue') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `queue` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_ticket','queue') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` ADD `queue` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','id_status') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `id_status` INT( 11 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_mail_log','emailid') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_log` ADD `emailid` INT( 11 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','stopspam') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `stopspam` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_status','isdefault_manager') ) {
	$database->setQuery( "ALTER TABLE `#__support_status` ADD `isdefault_manager` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_client','approval') ) {
	$database->setQuery( "ALTER TABLE `#__support_client` ADD `approval` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_permission','can_delete') ) {
	$database->setQuery( "ALTER TABLE `#__support_permission` ADD `can_delete` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_ticket','approved') ) {
	$database->setQuery( "ALTER TABLE `#__support_ticket` ADD `approved` INT( 11 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','id_category') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `id_category` INT( 11 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','label') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `label` VARCHAR( 25 ) NOT NULL DEFAULT 'INBOX';" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','notls') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `notls` TINYINT( 1 ) NOT NULL DEFAULT '1';" ); $database->query();
}
$database->setQuery( "ALTER TABLE `#__support_mail_log` CHANGE `emailid` `emailid` VARCHAR( 250 ) NULL DEFAULT ''" ); $database->query();
if( !CheckField('#__support_config','hide_powered') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `hide_powered` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','common_ticket_views') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `common_ticket_views` TINYINT( 1 ) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_config','currency') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `currency` varchar(10) default '&euro;';" ); $database->query();
}
if( CheckField('#__support_users','photo') ) {
	$database->setQuery( "ALTER TABLE `#__support_users` DROP `photo`" ); $database->query();
}
if( !CheckField('#__support_config','use_merge') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_merge` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_config','use_as_reply') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_as_reply` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_config','use_parent') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_parent` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_config','use_travel') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_travel` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_config','use_type') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `use_type` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_workgroup','use_account') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `use_account` tinyint(1) default '1';" ); $database->query();
}
if( !CheckField('#__support_workgroup','use_bookmarks') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `use_bookmarks` tinyint(1) default '1';" ); $database->query();
}
if( !CheckField('#__support_status','auto_status_agents') ) {
	$database->setQuery( "ALTER TABLE `#__support_status` ADD `auto_status_agents` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_status','auto_status_users') ) {
	$database->setQuery( "ALTER TABLE `#__support_status` ADD `auto_status_users` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_workgroup','add_mail_tag') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `add_mail_tag` tinyint(1) default '0';" ); $database->query();
}
if( !CheckField('#__support_client_docs','available') ) {
	$database->setQuery( "ALTER TABLE `#__support_client_docs` ADD `available` tinyint(1) default '1';" ); $database->query();
}
if( !CheckField('#__support_views','orderby') ) {
	$database->setQuery( "ALTER TABLE `#__support_views` ADD `orderby` varchar(4) NOT NULL DEFAULT 'ASC';" ); $database->query();
}
if( !CheckField('#__support_workgroup','tkt_nfy_agent') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `tkt_nfy_agent` tinyint(1) default '1';" ); $database->query();
}
if( !CheckField('#__support_config','integrate_jbolo') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `integrate_jbolo` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','thrash') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `thrash` VARCHAR( 25 ) NOT NULL DEFAULT 'THRASH';" ); $database->query();
}
if( !CheckField('#__support_category','kb') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `kb` tinyint(1) NOT NULL default '1';" ); $database->query();
}
if( !CheckField('#__support_category','tickets') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `tickets` tinyint(1) NOT NULL default '1';" ); $database->query();
}
if( !CheckField('#__support_category','downloads') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `downloads` tinyint(1) NOT NULL default '1';" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_store_integration` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`vm_status` VARCHAR( 15 ) NOT NULL ,`vm_product` INT( 11 ) NOT NULL ,`maqma_contract` INT( 11 ) NOT NULL ,`maqma_group` INT( 11 ) NOT NULL ,`maqma_maintainer` INT( 11 ) NOT NULL ,`maqma_contract_end` INT( 3 ) NOT NULL ,`maqma_license_product` INT( 11 ) NOT NULL ,`maqma_license_create` TINYINT( 1 ) NOT NULL ,`maqma_license_chars` INT( 11 ) NOT NULL ,`maqma_license_equal` TINYINT( 1 ) NOT NULL ,`maqma_license_duration` INT( 3 ) NOT NULL ,`send_mail` TINYINT( 1 ) NOT NULL DEFAULT '0' ,`mail_content` TEXT NOT NULL);" ); $database->query();
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_store_integration_log` (`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`id_order` INT( 11 ) NOT NULL ,`id_rule` INT( 11 ) NOT NULL ,`date_created` DATETIME NOT NULL);" ); $database->query();
if( !CheckField('#__support_config','integrate_digistore') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `integrate_digistore` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_workgroup','digistore') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `digistore` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_workgroup_category_assign','city') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup_category_assign` ADD `city` VARCHAR( 100 ) NULL;" ); $database->query();
	$database->setQuery( "ALTER TABLE `#__support_workgroup_category_assign` DROP PRIMARY KEY , ADD PRIMARY KEY (  `id_workgroup` ,  `id_category` ,  `id_user` ,  `city` ( 100 ) )" ); $database->query();
}
$database->setQuery( "CREATE TABLE IF NOT EXISTS `#__support_permission_category` (`id` int(11) NOT NULL auto_increment,`id_user` int(11) NOT NULL default '0',`id_workgroup` int(11) NOT NULL default '0',`id_category` int(11) NOT NULL default '0',PRIMARY KEY (`id`));" ); $database->query();
if( !CheckField('#__support_config','growl_notifications') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `growl_notifications` TINYINT(1) NOT NULL DEFAULT '0';" ); $database->query();
}
if( !CheckField('#__support_category','discussions') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `discussions` tinyint(1) NOT NULL default '0';" ); $database->query();
}
if( !CheckField('#__support_category','bugtracker') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `bugtracker` tinyint(1) NOT NULL default '0';" ); $database->query();
}
$database->setQuery( "ALTER TABLE `#__support_dl_access` CHANGE `serialno` `serialno` VARCHAR( 200 ) NULL DEFAULT ''" ); $database->query();
if( !CheckField('#__support_config','kb_approvement') ) {
	$database->setQuery( "ALTER TABLE `#__support_config` ADD `kb_approvement` tinyint(1) NOT NULL default '0';" ); $database->query();
}
if( !CheckField('#__support_kb','approved') ) {
	$database->setQuery( "ALTER TABLE `#__support_kb` ADD `approved` tinyint(1) NOT NULL default '1';" ); $database->query();
}
if( !CheckField('#__support_permission','level') ) {
	$database->setQuery( "ALTER TABLE `#__support_permission` ADD `level` tinyint(1) NOT NULL default '0';" ); $database->query();
}
if( !CheckField('#__support_category','level') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `level` INT( 10 ) NOT NULL DEFAULT '1';" ); $database->query();
}
if( !CheckField('#__support_dl_category','level') ) {
	$database->setQuery( "ALTER TABLE `#__support_dl_category` ADD `level` INT( 10 ) NOT NULL DEFAULT '1';" ); $database->query();
}
if( !CheckField('#__support_wk_fields','section') ) {
	$database->setQuery( "ALTER TABLE `#__support_wk_fields` ADD `section` varchar( 100 ) NOT NULL default '';" ); $database->query();
}
if( !CheckField('#__support_workgroup','shortdesc') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `shortdesc` VARCHAR( 255 ) DEFAULT '' NOT NULL;" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','ssl') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `ssl` TINYINT( 1 ) NOT NULL DEFAULT '0'" ); $database->query();
}
if( !CheckField('#__support_mail_fetch','published') ) {
	$database->setQuery( "ALTER TABLE `#__support_mail_fetch` ADD `published` TINYINT( 1 ) NOT NULL DEFAULT '1';" ); $database->query();
}
if( !CheckField('#__support_announce','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_announce` ADD `slug` VARCHAR( 200 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_category','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_category` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_dl_category','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_dl_category` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_kb','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_kb` ADD `slug` VARCHAR( 150 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_client','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_client` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_workgroup','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_workgroup` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_dl','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_dl` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_discussions','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_discussions` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}
if( !CheckField('#__support_dl_license','slug') ) {
	$database->setQuery( "ALTER TABLE `#__support_dl_license` ADD `slug` VARCHAR( 100 ) NULL;" ); $database->query();
}

/*
 * Check if a table or a field already exists
 */
function CheckField( $table, $field )
{
	$db = JFactory::getDBO();
	
	if( $field != '' ) {
		$sql = "SHOW COLUMNS FROM ".$table;
		$db->setQuery( $sql );
		$rows = $db->loadObjectList();
		
		for($i=0; $i<count($rows); $i++ )
		{
			$row = $rows[$i];
			if( $row->Field == $field ) {
				return true;
			}
		}
	}else{
		$sql = "SHOW TABLES";
		$db->setQuery( $sql );
		$rows = $db->loadAssocList();
		
		for($i=0; $i<count($rows); $i++ )
		{
			$row = $rows[$i];
			if( $row[0] == $table ) {
				return true;
			}
		}
	}
	
	return false;
}