<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: toolbar.maqmahelpdesk.html.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

JHTML::_('behavior.tooltip');

/**
* @package iMaQma Helpdesk
*/

// Default
class TOOLBAR_default {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
	}
}

class TOOLBAR_holidays {
	static function _EDIT() { 
		global $holidays_title;
		JToolBarHelper::spacer();
		JToolBarHelper::title( $holidays_title, 'sc-holidays' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('holidays_save');
		//JToolBarHelper::customX( 'holidays_save', 'save', 'save', JText::_('savelink'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::customX( 'holidays_cancel', 'cancel', 'cancel', JText::_('cancel'), false );
	}

	static function _DEFAULT() {
		global $action; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('holidays_manager'), 'sc-holidays' );
		JToolBarHelper::spacer();
        JToolBarHelper::customX( 'holidays_new', 'new', 'new', JText::_('newholiday'), false );
        JToolBarHelper::spacer();
        JToolBarHelper::customX( 'holidays_edit', 'edit', 'edit', JText::_('editholiday'), false );
        JToolBarHelper::spacer();
        JToolBarHelper::customX( 'holidays_remove', 'delete', 'delete', JText::_('removeholiday'), false );
        JToolBarHelper::spacer();
	}
}

class TOOLBAR_schedule {
	static function _EDIT() { 
		global $schedule_title;
		JToolBarHelper::spacer();
		JToolBarHelper::title( $schedule_title, 'sc-schedule' );
		JToolBarHelper::spacer();
		JToolBarHelper::spacer();
		JToolBarHelper::customX( 'schedule_save', 'save', 'save', JText::_('savelink'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::customX( 'schedule_cancel', 'cancel', 'cancel', JText::_('cancel'), false );
	}

	static function _DEFAULT() {
		global $action; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('schedule_manager'), 'sc-schedule' );
		JToolBarHelper::spacer();

		/*if( $action == 'new' || $action == 'edit' ) { 
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'schedule_save', 'save_f2', 'save_f2', JText::_('savelink'), false );
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'schedule_cancel', 'cancel_f2', 'cancel_f2', JText::_('cancel'), false );
		} else {*/
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'schedule_new', 'new', 'new', JText::_('newschedule'), false );
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'schedule_edit', 'edit', 'edit', JText::_('editschedule'), false );
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'schedule_remove', 'delete', 'delete', JText::_('removeschedule'), false );
			JToolBarHelper::spacer();
		//}
	}
}


class TOOLBAR_vacances {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('vacances_manager'), 'sc-vacances' );
		JToolBarHelper::spacer();
	}
}



// CPanel
class TOOLBAR_cpanel {
	static function _DEFAULT() { 
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('control_panel'), 'sc-cpanel' );
		JToolBarHelper::spacer();
	}
}

// Configuration
class TOOLBAR_config {
	static function _DEFAULT() { 
		global $action;
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('global_config').'<br /><div id="loading" name="loading" style="display:none;"><img src="../components/com_maqmahelpdesk/images/progressbar.gif" border="0" alt="'.JText::_('loading').'" /></div>', 'sc-configuration' );

		if( $action == 'new' || $action == 'edit' ) { 
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'config_saveLink', 'save_f2', 'save_f2', JText::_('savelink'), false );
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'config_cancelLink', 'cancel_f2', 'cancel_f2', JText::_('cancel'), false );
		} else {
			JToolBarHelper::spacer();
			SC_ToolBar::sc_newlink( 'javascript:showLink(0);', 'new_f2', JText::_('newlink') );
		}
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'config_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('config_save' );
		JToolBarHelper::spacer();
        JToolBarHelper::cancel( 'cpanel' );
        JToolBarHelper::spacer();
	}
}

// Workgroups
class TOOLBAR_wk {
	static function _EDIT() { 
		global $workgroup_title;
		JToolBarHelper::spacer();
		JToolBarHelper::title( $workgroup_title.'<br /><div id="loading" name="loading" style="display:none;"><img src="../components/com_maqmahelpdesk/images/progressbar.gif" border="0" alt="'.JText::_('loading').'" /></div>', 'sc-workgroup' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'workgroup_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('workgroup_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'workgroup' );
		JToolBarHelper::spacer();

	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('workgroups'), 'sc-workgroup' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'workgroup_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'workgroup_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'workgroup_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'workgroup_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'workgroup_remove' );
	}
}

// Calendar
class TOOLBAR_cal {
	static function _EDIT() {
		global $title_edit_calendar; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_edit_calendar, 'sc-calendars' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('calendar_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('add').' '.JText::_('task'), 'sc-calendars' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'calendar_new' );
		JToolBarHelper::spacer();
	}
}

// E-Mail�s Fetching
class MAIL_wk {
	static function _EDIT() {
		global $title_edit_mail; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_edit_mail, 'sc-mail' );
		JToolBarHelper::spacer();
		JToolBarHelper::spacer();
		JToolBarHelper::save ('mail_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'mail' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('mail_fetch_manager'), 'sc-mail' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'mail_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'mail_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'mail_remove' );
		JToolBarHelper::spacer();
	}
	
	static function _LOG() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('fetch_log'), 'sc-mail' );
		JToolBarHelper::spacer();
	}
}

// Category
class TOOLBAR_category {
	static function _EDIT() {
		global $titulo_category_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_category_edit, 'sc-category' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('category_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'category' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('categories_manager'), 'sc-category' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'category_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'category_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'category_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'category_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'category_remove' );
		JToolBarHelper::spacer();
	}
}

// Priority
class TOOLBAR_priority {
	static function _EDIT() {
		global $titulo_priority_edit;
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_priority_edit, 'sc-priority' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('priority_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'priority' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('priorities_manager'), 'sc-priority' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'priority_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'priority_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'priority_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'priority_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'priority_remove' );
		JToolBarHelper::spacer();
	}
}

// Status
class TOOLBAR_status {
	static function _EDIT() {
		global $titulo_status_edit;
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_status_edit, 'sc-status' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('status_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'status' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('status_manager'), 'sc-status' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'status_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'status_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'status_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'status_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'status_remove' );
		JToolBarHelper::spacer();
	}
}

// Custom Fields
class TOOLBAR_cfield {
	static function _EDIT() {
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}
 
		JToolBarHelper::spacer();
		$title = ($cid[0] ? JText::_('edit') : JText::_('add')).' '.JText::_('cfield');
		JToolBarHelper::title( $title, 'sc-customfield' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('customfield_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'customfield' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('cfields_manager'), 'sc-customfield' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'customfield_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'customfield_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'customfield_remove' );
		JToolBarHelper::spacer();
	}
}

// Workgroup Fields
class TOOLBAR_wkfields {
	static function _EDIT() {
		global $titulo_wkfields_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_wkfields_edit, 'sc-customfield' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('wkfields_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'wkfields' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('cfield_assign'), 'sc-customfield' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'wkfields_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'wkfields_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'wkfields_remove' );
		JToolBarHelper::spacer();
	}
}

// Permission
class TOOLBAR_permission {
	static function _EDIT() {
		JToolBarHelper::spacer();
		JToolBarHelper::save ('permission_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'permission' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'permission_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'permission_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'permission_remove' );
		JToolBarHelper::spacer();
	}
}

// Tickets
class TOOLBAR_tickets {

	static function _EDIT() {
		global $ticket_title, $print_tickets_edit_id;
		
		$database = JFactory::getDBO();

		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}
		
		$rowTicket = null;
		if( $cid[0] > 0 ) {
			$database->setQuery( "SELECT t.id_export, t.id_kb, t.id_user FROM #__support_ticket t WHERE t.id='".(int)$cid[0]."'" );
			$rowTicket = $database->loadObject();
		}else{
			$rowTicket->id_kb = 0;
			$rowTicket->id_export = 0;
			$rowTicket->id_user = 0;
		}
		
		$title = ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('ticket');
		$title .= " <span style='font-size:10px'>".$ticket_title."</span>";
    
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title, 'sc-tickets' );
		JToolBarHelper::spacer();
		

		if( $print_tickets_edit_id > 0 && !JRequest::getVar( 'print', '', '', 'int' ) ) {
		    JToolBarHelper::spacer();

			$id = JRequest::getVar( 'id', '', '', 'string' );
			$is_client = 0;
			$database->setQuery( "SELECT u.id_client FROM #__support_client_users u, #__support_client c WHERE u.id_user='".$rowTicket->id_user."' AND c.id=u.id_client" );
			$is_client = ( $database->loadResult() ? $database->loadResult() : 0 );
			if( $is_client > 0 ) { 
				SC_ToolBar::sc_popup('index.php?option=com_maqmahelpdesk&task=client_edit&cid[0]='.$is_client.'&print=1&tmpl=component', 'groups_f2', JText::_('client'));
				JToolBarHelper::spacer();
			}
			SC_ToolBar::sc_preview('index.php?option=com_maqmahelpdesk&task=tickets_edit&cid[0]='.$print_tickets_edit_id.'&print=1&tmpl=component');
			JToolBarHelper::spacer();
			JToolBarHelper::customX( 'kb_ticket', 'move_f2', 'move_f2', JText::_('convert'), false );
			JToolBarHelper::spacer();
			JToolBarHelper::divider();
		}		
		
		
		if( $rowTicket->id_export == 0 ) {
			JToolBarHelper::spacer();
			if( $cid[0] > 0 ) {
				JToolBarHelper::apply( 'tickets_replyapply' );
			}else{
				JToolBarHelper::apply( 'tickets_saveapply' );
			}
			JToolBarHelper::spacer();
			if( $cid[0] > 0 ) {
				JToolBarHelper::save ('tickets_reply' );
			}else{
				JToolBarHelper::save ('tickets_save' );
			}
		}
		
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'tickets' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('tickets_manager'), 'sc-tickets' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'tickets_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'tickets_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'tickets_remove' );
		JToolBarHelper::spacer();
	}
}

// Troubleshooter
class TOOLBAR_trouble {
	static function _EDIT() {
		global $title_edit_trouble; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_edit_trouble, 'sc-trouble' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('troubleshooter_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'troubleshooter' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('trouble_manager'), 'sc-trouble' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'troubleshooter_new' );
		JToolBarHelper::spacer();
	}
}

// Contract Templates
class TOOLBAR_contracts {
	static function _EDIT() {
		global $titulo_contracts_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_contracts_edit, 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('contracts_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'contracts' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('contract_types_manager'), 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'contracts_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'contracts_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'contracts_remove' );
		JToolBarHelper::spacer();
	}

	static function _NOTIFICATION() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('contract_notification'), 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('addon-contracts_saveconfig' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
    }

	static function _ESCALATION() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('sla_escalation_config'), 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('addon-escalation_saveconfig' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
    }

	
	// 08.04.2009
	static function _FIELDS() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('contract_custom_field'), 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'contracts_fields_new' ); // filename_function_option ( admin.filename.php ; task function ; option )
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'contracts_fields_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'contracts_fields_remove' );
		JToolBarHelper::spacer();
	}
	static function _FIELDS_NEW() { 	
		global $titulo_contracts_fields_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('contracts').' - '.$titulo_contracts_fields_edit, 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('contracts_fields_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'contracts_fields' );
		JToolBarHelper::spacer();
	}
	
	static function _FIELDS_EDIT() { 	
		global $titulo_contracts_fields_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_contracts_fields_edit, 'sc-contracts' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ( 'contracts_fields_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'contracts_fields' );
		JToolBarHelper::spacer();
		
	}
	

}

// Knowledge Base
class TOOLBAR_kb {
	static function _EDIT() {
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}
		JToolBarHelper::spacer();
		JToolBarHelper::title( ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('article'), 'sc-kb' );
	
		JToolBarHelper::spacer();
		JToolBarHelper::save ('kb_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'kb_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'kb' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('kb_manager'), 'sc-kb' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'kb_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'kb_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'kb_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'kb_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'kb_remove' );
		JToolBarHelper::spacer();
	}

	static function _MODERATE() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('kb_comments_manager'), 'sc-kb' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'kb_publishcomments' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'kb_delcomments' );
		JToolBarHelper::spacer();
	}
}

// Clients
class TOOLBAR_client {
	static function _EDIT() {
		global $titulo_client_edit;

		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_client_edit, 'sc-client' );
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'client_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('client_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'client' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('clients_manager'), 'sc-client' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'client_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'client_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'client_remove' );

	}
}

// Glossary
class TOOLBAR_glossary {
	static function _EDIT() {
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}
		JToolBarHelper::spacer();
		JToolBarHelper::title( ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('glossary'), 'sc-glossary' );

		JToolBarHelper::spacer();
		JToolBarHelper::save ('glossary_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'glossary' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('glossary_manager'), 'sc-glossary' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'glossary_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'glossary_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'glossary_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'glossary_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'glossary_remove' );
		JToolBarHelper::spacer();
	}
}

// E-Mail Templates
class TMPL_mail {
	static function _EDIT() {
		JToolBarHelper::spacer();
		
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		$image = JHTML::_('image.administrator', 'preview.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle') );
		$image2 = JHTML::_('image.administrator', 'preview_f2.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle'), 0 );

		if( $cid[0] > 0 ) { ?>
			<td>
			<script language="javascript">
			function popup() {
				window.open('index.php?option=com_maqmahelpdesk&task=tmpl-mail_preview&print=1&id=<?php echo $cid[0];?>&tmpl=component', 'win1', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no');
			}
			</script>
			<a class="toolbar" href="#" onclick="popup();" onmouseout="MM_swapImgRestore();"  onmouseover="MM_swapImage('preview','','<?php echo $image2; ?>',1);">
			<?php echo $image; ?>
			<?php echo JText::_('preview'); ?>
			</a>
			</td>
<?php		JToolBarHelper::spacer();
			JToolBarHelper::divider();
		}
		
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'tmpl-mail_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('tmpl-mail_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'tmpl-mail' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'tmpl-mail_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'tmpl-mail_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'tmpl-mail_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'tmpl-mail_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'tmpl-mail_remove' );
		JToolBarHelper::spacer();
	}
}

// Ticket Templates
class TMPL_ticket {
	static function _EDIT() {
		JToolBarHelper::spacer();
		
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		$image = JHTML::_('image.administrator', 'preview.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle') );
		$image2 = JHTML::_('image.administrator', 'preview_f2.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle'), 0 );

		
		if( $cid[0] > 0 ) { ?>
			<td>
			<script language="javascript">
			function popup() {
				window.open('index.php?option=com_maqmahelpdesk&task=tmpl-mail_preview&print=1&id=<?php echo $cid[0];?>&tmpl=component', 'win1', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no');
			}
			</script>
			<a class="toolbar" href="#" onclick="popup();" onmouseout="MM_swapImgRestore();"  onmouseover="MM_swapImage('preview','','<?php echo $image2; ?>',1);">
			<?php echo $image; ?>
			<?php echo JText::_('preview'); ?>
			</a>
			</td>
<?php		JToolBarHelper::spacer();
			JToolBarHelper::divider();
			JToolBarHelper::spacer();
		}
		
		JToolBarHelper::apply( 'tmpl-ticket_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('tmpl-ticket_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'tmpl-ticket' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'tmpl-ticket_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'tmpl-ticket_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'tmpl-ticket_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'tmpl-ticket_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'tmpl-ticket_remove' );
		JToolBarHelper::spacer();
	}
}

// General Templates
class TMPL_general {
	static function _EDIT() {
		JToolBarHelper::spacer();
		
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		$image = JHTML::_('image.administrator', 'preview.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle') );
		$image2 = JHTML::_('image.administrator', 'preview_f2.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle'), 0 );

		if( $cid[0] > 0 ) { ?>
			<td>
			<script language="javascript">
			function popup() {
				window.open('index.php?option=com_maqmahelpdesk&task=tmpl-mail_preview&print=1&id=<?php echo $cid[0];?>&tmpl=component', 'win1', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no');
			}
			</script>
			<a class="toolbar" href="#" onclick="popup();" onmouseout="MM_swapImgRestore();"  onmouseover="MM_swapImage('preview','','<?php echo $image2; ?>',1);">
			<?php echo $image; ?>
			<?php echo JText::_('preview'); ?>
			</a>
			</td>
<?php		JToolBarHelper::spacer();
			JToolBarHelper::divider();
			JToolBarHelper::spacer();
		}
		
		JToolBarHelper::apply( 'tmpl-general_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('tmpl-general_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'tmpl-general' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'tmpl-general_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'tmpl-general_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'tmpl-general_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'tmpl-general_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'tmpl-general_remove' );
		JToolBarHelper::spacer();
	}
}

// KB Templates
class TMPL_kb {
	static function _EDIT() {
		JToolBarHelper::spacer();
		
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		$image = JHTML::_('image.administrator', 'preview.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle') );
		$image2 = JHTML::_('image.administrator', 'preview_f2.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle'), 0 );

		if( $cid[0] > 0 ) { ?>
			<td>
			<script language="javascript">
			function popup() {
				window.open('index.php?option=com_maqmahelpdesk&task=tmpl-mail_preview&print=1&id=<?php echo $cid[0];?>&tmpl=component', 'win1', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no');
			}
			</script>
			<a class="toolbar" href="#" onclick="popup();" onmouseout="MM_swapImgRestore();"  onmouseover="MM_swapImage('preview','','<?php echo $image2; ?>',1);">
			<?php echo $image; ?>
			<?php echo JText::_('preview'); ?>
			</a>
			</td>
<?php		JToolBarHelper::spacer();
			JToolBarHelper::divider();
			JToolBarHelper::spacer();
		}
		
		JToolBarHelper::apply( 'tmpl-kb_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('tmpl-kb_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'tmpl-kb' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'tmpl-kb_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'tmpl-kb_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'tmpl-kb_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'tmpl-kb_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'tmpl-kb_remove' );
		JToolBarHelper::spacer();
	}
}

// Activity Types
class TOOLBAR_types {
	static function _EDIT() {
		global $titulo_types_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_types_edit, 'sc-types' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('types_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'types' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('act_types_manager'), 'sc-types' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'types_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'types_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'types_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'types_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'types_remove' );
		JToolBarHelper::spacer();
	}
}

// Activity Rates
class TOOLBAR_rates {
	static function _EDIT() {
		global $titulo_rates_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_rates_edit, 'sc-rates' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('rates_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'rates' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('actrates_manager'), 'sc-rates' );
		JToolBarHelper::spacer();
		JToolBarHelper::publishList( 'rates_publish' );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList( 'rates_unpublish' );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'rates_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'rates_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'rates_remove' );
		JToolBarHelper::spacer();
	}
}

// Export Options
class TOOLBAR_export {
	static function _EDIT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('export_options'), 'sc-export' );
		JToolBarHelper::spacer();
		JToolBarHelper::spacer();
		JToolBarHelper::save ('export_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'export' );
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('export_options'), 'sc-export' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'export_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'export_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'export_remove' );
		JToolBarHelper::spacer();
	}
}

// Report
class TOOLBAR_report {
	static function _DEFAULT() {
		global $report, $id_workgroup, $month, $year, $f_status, $id_client, $f_customfields;
		
		JToolBarHelper::spacer();
	if( $report == 'wkanalysis' ) { 
		JToolBarHelper::title( JText::_('wk_analysis'), 'sc-reports' );
	} elseif( $report == 'clientanalysis' ) {
		JToolBarHelper::title( JText::_('client_analysis'), 'sc-reports' );
	} elseif( $report == 'supportanalysis' ) {
		JToolBarHelper::title( JText::_('support_analysis'), 'sc-reports' );
	} elseif( $report == 'timesheets' ) {
		JToolBarHelper::title( JText::_('timesheet'), 'sc-reports' );
	} elseif( $report == 'timesheetd' ) {
		JToolBarHelper::title( JText::_('timesheetd'), 'sc-reports' );
	} elseif( $report == 'clientm' ) {
		JToolBarHelper::title( JText::_('client_report_t'), 'sc-reports' );
		SC_ToolBar::sc_preview('index.php?task=reports&option=com_maqmahelpdesk&report=clientm&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status.'&f_customfields='.$f_customfields.'&print=1&tmpl=component');
		SC_ToolBar::sc_export_csv(JURI::root().'administrator/index.php?option=com_maqmahelpdesk&task=ajax_csvclientm&format=raw&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status.'&f_customfields='.$f_customfields);
		SC_ToolBar::sc_export_pdf(JURI::root().'index.php?option=com_maqmahelpdesk&task=pdf_reportclient&format=raw&report=clientm&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status.'&f_customfields='.$f_customfields);
	} else if( $report == 'duedate' ) { 
		JToolBarHelper::title( JText::_('duedate_report'), 'sc-reports' );
	} else if( $report == 'ticketsexport' ) { 
		JToolBarHelper::title( JText::_('export_data'), 'sc-reports' );
	
	// 2009.02.25 - Detail Client Month Report
	} else if( $report == 'clientmdetail' ) { 
		JToolBarHelper::title( JText::_('client_report_detail'), 'sc-reports' );
		// 2009.03.10 Export PDF
		SC_ToolBar::sc_preview('index.php?task=reports&option=com_maqmahelpdesk&report=clientmdetail&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status.'&f_customfields='.$f_customfields.'&detail=1&print=1&component=tmpl');
		SC_ToolBar::sc_export_pdf(JURI::root().'index.php?option=com_maqmahelpdesk&task=pdf_reportclient&format=raw&report=clientmdetail&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status.'&f_customfields='.$f_customfields.'&detail=1');
	// (6) 2009.03.13
	} else if( $report == 'status' ) { 
		JToolBarHelper::title( JText::_('status_report2'), 'sc-reports' );
		SC_ToolBar::sc_preview('index.php?task=reports&option=com_maqmahelpdesk&report=status&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status.'&print=1&tmpl=component');
		SC_ToolBar::sc_export_pdf(JURI::root().'index.php?option=com_maqmahelpdesk&task=pdf_reportstatus&format=raw&report=status&id_workgroup='.$id_workgroup.'&month='.$month.'&year='.$year.'&id_client='.$id_client.'&f_status='.$f_status);

    } else {
		JToolBarHelper::title( JText::_('wk_analysis'), 'sc-reports' );
    }		  
	
	
	

		if( $report == 'ticketsexport' ) {
			$imgpath = JURI::root().'components/com_maqmahelpdesk/images';
			JToolBarHelper::customX( '', 'save_f2', 'save_f2', JText::_('export'), false );
		}
		
		if( $report == 'wkanalysis' || $report == 'clientanalysis' || $report == 'supportanalysis' || $report == 'timesheets' || $report == 'timesheetd' || $report == 'duedate' ) { 
  			$month  = JRequest::getVar( 'month', date("m"), '', 'int' ); 
  			$year   = JRequest::getVar( 'year', date("Y") , '', 'int' );
  			$id_user = JRequest::getVar( 'id_user', 0, '', 'int' );
  			$client = JRequest::getVar( 'client', 0, '', 'int' );
  			$wk     = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
    		JToolBarHelper::spacer();
  			SC_ToolBar::sc_preview('index.php?option=com_maqmahelpdesk&task=reports&report='.$report.'&id_workgroup='.$wk.'&year='.$year.'&month='.$month.'&id_user='.$id_user.'&client='.$client.'&print=1&tmpl=component');
    		JToolBarHelper::spacer();
		}
		JToolBarHelper::spacer();
	}

	static function _EDITBUILDER() {
		global $report; 
		JToolBarHelper::spacer();
		if( $report == 'wkanalysis' ) { 
		  JToolBarHelper::title( JText::_('wk_analysis'), 'sc-reports' );
	  } else if( $report == 'clientanalysis' ) {
		  JToolBarHelper::title( JText::_('client_analysis'), 'sc-reports' );
	  } else if( $report == 'supportanalysis' ) {
		  JToolBarHelper::title( JText::_('support_analysis'), 'sc-reports' );
	  } else if( $report == 'timesheets' ) {
		  JToolBarHelper::title( JText::_('timesheet'), 'sc-reports' );
	  } else if( $report == 'clientm' ) {
		  JToolBarHelper::title( JText::_('timesheetd'), 'sc-reports' );
    } else {
		  JToolBarHelper::title( JText::_('wk_analysis'), 'sc-reports' );
    }		  
		JToolBarHelper::spacer();
		JToolBarHelper::save ('reports_buildersave' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'reports_builder' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULTBUILDER() {
		global $report; 
		JToolBarHelper::spacer();
		if( $report == 'wkanalysis' ) { 
		  JToolBarHelper::title( JText::_('wk_analysis'), 'sc-reports' );
		} else if( $report == 'clientanalysis' ) {
		  JToolBarHelper::title( JText::_('client_analysis'), 'sc-reports' );
		} else if( $report == 'supportanalysis' ) {
		  JToolBarHelper::title( JText::_('support_analysis'), 'sc-reports' );
		} else if( $report == 'timesheets' ) {
		  JToolBarHelper::title( JText::_('timesheet'), 'sc-reports' );
		} else if( $report == 'clientm' ) {
		  JToolBarHelper::title( JText::_('timesheetd'), 'sc-reports' );
		} else if( $report == 'builder' ) {
		  JToolBarHelper::title( JText::_('reports_manager'), 'sc-reports' );
		} else {
		  JToolBarHelper::title( JText::_('wk_analysis'), 'sc-reports' );
		}		  
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'reports_buildernew' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'reports_builderedit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'reports_builderremove' );
		JToolBarHelper::spacer();
	}

	static function _BUILDERREPORTS() {
		global $title_showReport; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_showReport, 'sc-reports' );
		JToolBarHelper::spacer();
		// Get Params
		$id = JRequest::getVar( 'id', 0, '', 'int' );
		$year = JRequest::getVar( 'year', dateOffset("Y"), '', 'int' );
		$month = JRequest::getVar( 'month', dateOffset("m"), '', 'int' );
		$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
		$client = JRequest::getVar( 'client', 0, '', 'int' );
		$id_user = JRequest::getVar( 'id_user', 0, '', 'int' );
		$f_year = JRequest::getVar( 'f_year', '', '', 'string' );
		$f_month = JRequest::getVar( 'f_month', '', '', 'string' );
		$f_status = JRequest::getVar( 'f_status', 0, '', 'int' );
		$f_priority = JRequest::getVar( 'f_priority', 0, '', 'int' );
		$f_category = JRequest::getVar( 'f_category', 0, '', 'int' );
		$f_workgroup = JRequest::getVar( 'f_workgroup', 0, '', 'int' );
		$f_client = JRequest::getVar( 'f_client', 0, '', 'int' );
		$f_user = JRequest::getVar( 'f_user', 0, '', 'int' );
		$f_staff = JRequest::getVar( 'f_staff', 0, '', 'int' );
		$f_source = JRequest::getVar( 'f_source', '', '', 'string' );
		SC_ToolBar::sc_preview('index.php?option=com_maqmahelpdesk&task=reports_builderreport&id='.$id.'&year='.$year.'&month='.$month.'&id_workgroup='.$id_workgroup.'&client='.$client.'&id_user='.$id_user.'&f_year='.$f_year.'&f_month='.$f_month.'&f_status='.$f_status.'&f_priority='.$f_priority.'&f_category='.$f_category.'&f_workgroup='.$f_workgroup.'&f_client='.$f_client.'&f_user='.$f_user.'&f_staff='.$f_staff.'&f_source='.$f_source.'&print=1&tmpl=component');
		JToolBarHelper::spacer();
	}
	
	
	
}

// Announcements
class TOOLBAR_announce {
	static function _EDIT() {
		global $title_edit_announce; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_edit_announce, 'sc-announces' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('announce_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'announce' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('announcements_manager'), 'sc-announces' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'announce_preparesend', 'move.png', 'move_f2.png', JText::_('send'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'announce_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'announce_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'announce_remove' );
		JToolBarHelper::spacer();
	}

	static function _PREPARE() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('prepare_send'), 'sc-send' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'announce_send', 'move.png', 'move_f2.png', JText::_('send'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'announce' );
	}
}

// Support Staff
class TOOLBAR_staff {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('support_staff_manager'), 'sc-staff' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'staff_new' );
		JToolBarHelper::spacer();
		//JToolBarHelper::editList( 'staff_edit2' );
		//JToolBarHelper::spacer();
	}

	static function _EDIT() {
	    $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	    if (!is_array( $cid )) {
	    	$cid = array(0);
	    }
		JToolBarHelper::spacer();
		JToolBarHelper::title( ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('support_staff_permission'), 'sc-staff' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('staff_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'staff' );
		JToolBarHelper::spacer();
	}

	static function _EDIT2() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('support_staff_view'), 'sc-staff' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'staff_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'staff_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'staff_remove' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'staff', 'restore.png', 'restore_f2.png', JText::_('back'), false );
		JToolBarHelper::spacer();
	}
}

// Components
class TOOLBAR_comp {
	static function _EDIT() {
		global $titulo_components_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_components_edit, 'sc-components' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('components_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'components' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('components_manager'), 'sc-components' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'components_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'components_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'components_remove' );
		JToolBarHelper::spacer();
	}
}

// Pre-defined replies
class TOOLBAR_reply {
	static function _EDIT() {
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}
		JToolBarHelper::spacer();
		JToolBarHelper::title( ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('reply'), 'sc-replies' );
		JToolBarHelper::spacer();

		JToolBarHelper::save ('replies_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'replies' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('replies_manager'), 'sc-replies' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'replies_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'replies_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'replies_remove' );
		JToolBarHelper::spacer();
	}
}

// Installer
class TOOLBAR_update {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('update_component'), 'sc-update' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
		$ref = 'http://www.imaqma.com/index.php?option=com_content&task=findkey&pop=1&keyref=' . urlencode( 'sc2.installer' );
		JToolBarHelper::help($ref);
		//echo sc_help( 'sc2.installer' );
		JToolBarHelper::spacer();
	}
}

// Database Cleanup
class TOOLBAR_db {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('database_cleanup'), 'sc-db' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'tools_db2', 'move.png', 'move_f2.png', JText::_('execute'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
	}
}

/**
* Writes a preview button for a given option (opens a popup window)
* @param string The name of the popup file (excluding the file extension for an xml file)
* @param boolean Use the help file in the component directory
*/
function sc_help( $ref ) {
	$image2 = JHTML::_('image.administrator', 'preview_f2.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle'), 1 );

	// Online help site as defined in GC
	$url = 'http://www.imaqma.com/index.php?option=com_content&task=findkey&pop=1&keyref=' . urlencode( $ref ); ?>
	<td>
		<a class="toolbar" href="#" onclick="window.open('<?php echo $url;?>', 'mambo_help_win', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no');">
			<?php echo $image2; ?>
			<br /><?php echo JText::_('help'); ?></a>
	</td>
	<?php
}

function sc_helpinpage() {
	$image2 = JHTML::_('image.administrator', 'preview_f2.png', '/administrator/images/', NULL, NULL, JText::_('preview'), array('align' => 'middle'), 1 );?>

	<td>
		<a href="#" class="toolbar" onclick="$jMaQma('#d1').toggle(); return false;">
		<?php echo $image2; ?>
		<br /><?php echo JText::_('help'); ?></a>
	</td>
	<?php
}

function sc2_submit( $image1, $image2, $question, $label ) { ?>
	<script type="text/JavaScript">
	<!--
	function MM_swapImgRestore() { //v3.0
	  var i,x,a=document.MM_sr; for(i=0;a&&i<a.length&&(x=a[i])&&x.oSrc;i++) x.src=x.oSrc;
	}
	//-->
	</script>
	<script type="text/JavaScript">
	<!--
	function MM_swapImgRestore() { //v3.0
	  var i,x,a=document.MM_sr; for(i=0;a&&i<a.length&&(x=a[i])&&x.oSrc;i++) x.src=x.oSrc;
	}
	//-->
	</script>
	
	<td>
		<a class="toolbar" href="javascript:if (confirm('<?php echo $question; ?>')){ submitbutton(); }" onMouseOut="MM_swapImgRestore();"  onmouseover="MM_swapImage('','','<?php echo $image1; ?>',1);"> <img name="remove" src="<?php echo $image2; ?>" alt="<?php echo $label; ?>" border="0" align="absmiddle" width="32" /><br /><?php echo $label; ?></a>
	</td><?php
}

class menuDLCategory {
	static function EDIT_MENU() {
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}
		JToolBarHelper::spacer();
		JToolBarHelper::title( ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('category'), 'sc-dl_category' );
		JToolBarHelper::spacer();

		JToolBarHelper::save ('dlcategory_save', 'Save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'dlcategory_cancel', 'Cancel' );
		JToolBarHelper::spacer();
	}

	static function DEFAULT_MENU() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('categories_manager'), 'sc-dl_category' );
		JToolBarHelper::spacer();
		JToolBarHelper::publish( 'dlcategory_publish', JText::_('publish') );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublish( 'dlcategory_unpublish', JText::_('unpublish') );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'dlcategory_new', JText::_('add') );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'dlcategory_edit', JText::_('edit') );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( 'dlcategory_remove', 'dlcategory_remove' );
		JToolBarHelper::spacer();
	}
}


class menuGroup {
	static function EDIT_MENU() {
		global $title_group_form; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_group_form, 'sc-dl_groups' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('group_save', 'Save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'group_cancel', 'Cancel' );
		JToolBarHelper::spacer();
	}

	static function DEFAULT_MENU() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('usergroups_manager'), 'sc-dl_groups' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'group_new', JText::_('add') );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'group_edit', JText::_('edit') );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( 'group_remove', 'group_remove' );
		JToolBarHelper::spacer();
	}
}


class menuAccess {
	static function EDIT_MENU() {
		global $title_customer_form; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_customer_form, 'sc-dl_customers' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('customer_save', 'Save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'customer_cancel', 'Cancel' );
		JToolBarHelper::spacer();
	}

	static function DEFAULT_MENU() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('clients_access_manager'), 'sc-dl_customers' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'customer_new', JText::_('add') );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'customer_edit', JText::_('edit') );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( 'customer_remove', 'customer_remove' );
		JToolBarHelper::spacer();
	}
}


class menuProduct {
	static function EDIT_MENU() {
		global $title_product_form; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_product_form, 'sc-dl_products' );
		if( JRequest::getVar( 'cid', array(0), 'request', 'array' ) ) {
		  JToolBarHelper::spacer();
		  JToolBarHelper::customX('product_editversion', 'upload_f2.png', 'upload_f2.png', JText::_('new_version'), false);
		  JToolBarHelper::spacer();
		  JToolBarHelper::divider();
		}
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'product_apply', 'Apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('product_save', 'Save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'product_cancel', 'Cancel' );
		JToolBarHelper::spacer();
	}

	static function VERSIONEDIT_MENU() {
		global $title_version_id; 
		JToolBarHelper::spacer();
		JToolBarHelper::title($title_version_id, 'sc-dl_products' );
		JToolBarHelper::spacer();
		JToolBarHelper::customX('product_edit', 'back_f2.png', 'back_f2.png', JText::_('back'), false);
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::save ('product_saveversion', 'Save' );
		JToolBarHelper::spacer();
	}                         

	static function DEFAULT_MENU() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('downloads'), 'sc-dl_products' );
		JToolBarHelper::spacer();
		JToolBarHelper::publish( 'product_publish', JText::_('publish') );
		JToolBarHelper::spacer();
		JToolBarHelper::unpublish( 'product_unpublish', JText::_('unpublish') );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'product_new', JText::_('add') );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'product_edit', JText::_('edit') );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( 'product_remove', 'product_remove' );
		JToolBarHelper::spacer();

	}
}

// Licenses
class TOOLBAR_licenses {
	static function _EDIT() {
		global $title_edit_licenses; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $title_edit_licenses, 'sc-dl_licenses' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('licenses_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'licenses' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('licenses_manager'), 'sc-dl_licenses' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'licenses_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'licenses_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'licenses_remove' );
		JToolBarHelper::spacer();
	}
}

// Forms
class TOOLBAR_forms {
	static function _EDIT() { 
		global $form_typename; 

		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		if (!is_array( $cid )) {
			$cid = array(0);
		}

		JToolBarHelper::spacer();
		JToolBarHelper::title( ( $cid[0] ? JText::_('edit') : JText::_('add') ).' '.JText::_('form').( $cid[0] ? '('.$form_typename.')' : '' ).' <div id="loading" name="loading" style="display:none;"><img src="../components/com_maqmahelpdesk/images/progressbar.gif" border="0" alt="Loading..." /></div>', 'sc-forms' );
		JToolBarHelper::spacer();
		SC_ToolBar::sc_newlink( 'javascript:showAction(0);', 'new_f2', JText::_('newaction') );
		JToolBarHelper::spacer();
		SC_ToolBar::sc_newlink( 'javascript:showField(0);', 'new_f2', JText::_('newfield') );
		JToolBarHelper::spacer();
		JToolBarHelper::divider();
		JToolBarHelper::spacer();
		JToolBarHelper::apply( 'forms_apply' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('forms_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'forms' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('forms_manager'), 'sc-forms' );
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'forms_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'forms_edit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'forms_remove' );
		JToolBarHelper::spacer();
	}
}

// Users
class TOOLBAR_users {
	static function _EDIT() {
		global $titulo_users_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_users_edit, 'sc-users' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('users_save' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'users' );
		JToolBarHelper::spacer();
	}

	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('user_manager'), 'sc-users' );
		JToolBarHelper::spacer();
		//JToolBarHelper::addNew( 'users_new' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'users_edit' );
		JToolBarHelper::spacer();
		//ToolBarHelper::deleteList( '', 'users_remove' );
		JToolBarHelper::spacer();
	}

	static function _FIELDS_EDIT() {
		global $titulo_usersfields_edit; 
		JToolBarHelper::spacer();
		JToolBarHelper::title( $titulo_usersfields_edit, 'sc-users' );
		JToolBarHelper::spacer();
		JToolBarHelper::save ('users_fieldssave' );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( 'users_fields' );
		JToolBarHelper::spacer();
	}

	static function _FIELDS_DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('users_cfield'), 'sc-customfield' );
		JToolBarHelper::spacer();
		JToolBarHelper::spacer();
		JToolBarHelper::addNew( 'users_fieldsnew' );
		JToolBarHelper::spacer();
		JToolBarHelper::editList( 'users_fieldsedit' );
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList( '', 'users_fieldsremove' );
		JToolBarHelper::spacer();
	}
}

// Download Stats
class TOOLBAR_stats {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('download_statistics').' - '.JText::_('downloads'), 'sc-dl_stats' );
		JToolBarHelper::spacer();
		SC_ToolBar::sc_preview('index.php?option=com_maqmahelpdesk&task=stats&print=1&tmpl=component');
		JToolBarHelper::spacer();
	}
	static function _DEFAULTHITS() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('download_statistics').' - '.JText::_('pagehits'), 'sc-dl_stats' );
		JToolBarHelper::spacer();
		SC_ToolBar::sc_preview('index.php?option=com_maqmahelpdesk&task=stats_hits&print=1&tmpl=component');
		JToolBarHelper::spacer();
	}
}

// RS Tickets import
class TOOLBAR_rstickets {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('import_rstickets'), 'sc-db' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'tools_rstickets2', 'move.png', 'move_f2.png', JText::_('execute'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
	}
}

// Billets import
class TOOLBAR_billets {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('import_billets'), 'sc-db' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'tools_billets2', 'move.png', 'move_f2.png', JText::_('execute'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
	}
}

// Ambrasubs import
class TOOLBAR_ambrasubs {
	static function _DEFAULT() {
		JToolBarHelper::spacer();
		JToolBarHelper::title( JText::_('import_ambrasubs'), 'sc-db' );
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'tools_ambrasubs2', 'move.png', 'move_f2.png', JText::_('execute'), false );
		JToolBarHelper::spacer();
		JToolBarHelper::cancel( '' );
		JToolBarHelper::spacer();
	}
}