<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: toolbar.maqmahelpdesk.php 342 2012-01-23 15:13:41Z pdaniel $
 * $LastChangedDate: 2012-01-23 15:13:41 +0000 (seg, 23 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

require_once( JPATH_SITE.'/administrator/components/com_maqmahelpdesk/toolbar.maqmahelpdesk.html.php' );


class SC_ToolBar extends JToolbarHelper {
    static function sc_preview ($url='',$updateEditors = false) {
		$bar = JToolBar::getInstance('toolbar');
		$bar->appendButton( 'Popup', 'print_f2', JText::_('print'), $url);
    }

    static function sc_popup ($url='',$class='', $label, $updateEditors = false) {
      $bar = JToolBar::getInstance('toolbar');
      $bar->appendButton( 'Popup', $class, $label, $url);
    }

    static function sc_newlink ($url='', $class='', $label, $updateEditors = false) {
      $bar = JToolBar::getInstance('toolbar');
      $bar->appendButton( 'Link', $class, $label, $url);
    }

	static function sc_export_pdf ($url='') {
		$bar = JToolBar::getInstance('toolbar');
		$bar->appendButton( 'Popup', 'pdf_link', JText::_('pdf_export'), $url);
    }

	static function sc_export_csv ($url='') {
		$bar = JToolBar::getInstance('toolbar');
		$bar->appendButton( 'Popup', 'save_f2', 'CSV', $url);
    }
}


switch ( JRequest::getVar( 'task', '', '', 'string' ) ) {
// CPanel
	default:
	case "cpanel":
		TOOLBAR_cpanel::_DEFAULT();
		break;

	case "holidays":
	case "holidays_cancel":
	case "holidays_save":
		TOOLBAR_holidays::_DEFAULT();
		break;
	case "holidays_new":
	case "holidays_edit":
		TOOLBAR_holidays::_EDIT();
		break;

	case "schedule":
	case "schedule_cancel":
	case "schedule_save":
		TOOLBAR_schedule::_DEFAULT();
		break;
	case "schedule_new":
	case "schedule_edit":
		TOOLBAR_schedule::_EDIT();
		break;

		case "vacances":
		TOOLBAR_vacances::_DEFAULT();
		break;

// Configuration
	case "config":
		TOOLBAR_config::_DEFAULT();
		break;

// E-Mails Fetching
	case "mail_new":
	case "mail_edit":
		MAIL_wk::_EDIT();
		break;

	case "mail":
		MAIL_wk::_DEFAULT();
		break;
		
	case "mails":
		MAIL_wk::_LOG();
		break;

// Calendar
	case "calendar_new":
	case "calendar_edit":
		TOOLBAR_cal::_EDIT();
		break;

// Workgroups
	case "workgroup_new":
	case "workgroup_edit":
		TOOLBAR_wk::_EDIT();
		break;

	case "workgroup":
		TOOLBAR_wk::_DEFAULT();
		break;

// Categories
	case "category_new":
	case "category_edit":
		TOOLBAR_category::_EDIT();
		break;

	case "category":
		TOOLBAR_category::_DEFAULT();
		break;

// Priority
	case "priority_new":
	case "priority_edit":
		TOOLBAR_priority::_EDIT();
		break;

	case "priority":
		TOOLBAR_priority::_DEFAULT();
		break;

// Status
	case "status_new":
	case "status_edit":
		TOOLBAR_status::_EDIT();
		break;

	case "status":
		TOOLBAR_status::_DEFAULT();
		break;

// Custom Fields
	case "customfield_new":
	case "customfield_edit":
		TOOLBAR_cfield::_EDIT();
		break;

	case "customfield":
		TOOLBAR_cfield::_DEFAULT();
		break;

// Workgroup Fields
	case "wkfields_new":
	case "wkfields_edit":
		TOOLBAR_wkfields::_EDIT();
		break;

	case "wkfields":
		TOOLBAR_wkfields::_DEFAULT();
		break;

// Permissions
	case "permission_new":
	case "permission_edit":
		TOOLBAR_permission::_EDIT();
		break;

	case "permission":
		TOOLBAR_permission::_DEFAULT();
		break;

// Tickets
	case "tickets_new":
	case "tickets_edit":
	case "tickets_note":
	case "tickets_task":
	case "tickets_attach":
	case "tickets_cnote":
	case "tickets_cattach":
	case "tickets_ctask":
		TOOLBAR_tickets::_EDIT();
		break;

	case "tickets":
		TOOLBAR_tickets::_DEFAULT();
		break;

// Knowledge Base
	case "kb_new":
	case "kb_edit":
	case "kb_attach":
	case "kb_delcomment":
	case "kb_delattach":
	case "kb_ticket":
		TOOLBAR_kb::_EDIT();
		break;

	case "kb":
	case "kb_search":
		TOOLBAR_kb::_DEFAULT();
		break;

	case "kb_moderate":
		TOOLBAR_kb::_MODERATE();
		break;

// Troubleshooter
	case "troubleshooter_new":
	case "troubleshooter_edit":
		TOOLBAR_trouble::_EDIT();
		break;

	case "troubleshooter":
		TOOLBAR_trouble::_DEFAULT();
		break;

// Contract Template
	case "contracts_new":
	case "contracts_edit":
		TOOLBAR_contracts::_EDIT();
		break;

	case "contracts":
		TOOLBAR_contracts::_DEFAULT();
		break;

	case "addon-contracts_config":
		TOOLBAR_contracts::_NOTIFICATION();
		break;

	case "addon-escalation_config":
		TOOLBAR_contracts::_ESCALATION();
		break;

	// 08.04.2009
	case "contracts_fields":
		TOOLBAR_contracts::_FIELDS();
		break;
	case "contracts_fields_new":
		TOOLBAR_contracts::_FIELDS_NEW();
		break;
	case "contracts_fields_edit":
		TOOLBAR_contracts::_FIELDS_EDIT();
		break;
		

// Clients
	case "client_new":
	case "client_edit":
	case "client_saveuser":
	case "client_deluser":
	case "client_savecontract":
	case "client_delcontract":
	case "client_publishcontract":
	case "client_savefile":
	case "client_delfile":
	case "client_saveinfo":
	case "client_delinfo":
	case "client_publishinfo":
	case "client_manager":
	case "client_edituser":
		TOOLBAR_client::_EDIT();
		break;

	case "client":
		TOOLBAR_client::_DEFAULT();
		break;

// Glossary
	case "glossary_new":
	case "glossary_edit":
		TOOLBAR_glossary::_EDIT();
		break;

	case "glossary":
		TOOLBAR_glossary::_DEFAULT();
		break;

// E-Mail Templates
	case "tmpl-mail_new":
	case "tmpl-mail_edit":
		TMPL_mail::_EDIT();
		break;

	case "tmpl-mail":
		TMPL_mail::_DEFAULT();
		break;

// Ticket Templates
	case "tmpl-ticket_new":
	case "tmpl-ticket_edit":
		TMPL_ticket::_EDIT();
		break;

	case "tmpl-ticket":
		TMPL_ticket::_DEFAULT();
		break;

// General Templates
	case "tmpl-general_new":
	case "tmpl-general_edit":
		TMPL_general::_EDIT();
		break;

	case "tmpl-general":
		TMPL_general::_DEFAULT();
		break;

// KB Templates
	case "tmpl-kb_new":
	case "tmpl-kb_edit":
		TMPL_kb::_EDIT();
		break;

	case "tmpl-kb":
		TMPL_kb::_DEFAULT();
		break;

// Activity Types
	case "types_new":
	case "types_edit":
		TOOLBAR_types::_EDIT();
		break;

	case "types":
		TOOLBAR_types::_DEFAULT();
		break;

// Activity Rates
	case "rates_new":
	case "rates_edit":
		TOOLBAR_rates::_EDIT();
		break;

	case "rates":
		TOOLBAR_rates::_DEFAULT();
		break;

// Export Options
	case "export_new":
	case "export_edit":
		TOOLBAR_export::_EDIT();
		break;

	case "export":
		TOOLBAR_export::_DEFAULT();
		break;

// Report :: Tickets Export
	case "reports":
		TOOLBAR_report::_DEFAULT(); 
		break;
	
	case "reports_buildernew":
	case "reports_builderedit":
		TOOLBAR_report::_EDITBUILDER();
		break;

	case "reports_builder":
		TOOLBAR_report::_DEFAULTBUILDER();
		break;

	case "reports_builderreport":
		TOOLBAR_report::_BUILDERREPORTS();
		break;

// Announcements
	case "announce_new":
	case "announce_edit":
		TOOLBAR_announce::_EDIT();
		break;

	case "announce":
		TOOLBAR_announce::_DEFAULT();
		break;

	case "announce_preparesend":
		TOOLBAR_announce::_PREPARE();
		break;

// Support Staff
	case "staff_edit2":
		TOOLBAR_staff::_EDIT2();
		break;
	
	case "staff_new":
	case "staff_edit":
		TOOLBAR_staff::_EDIT();
		break;

	case "staff":
		TOOLBAR_staff::_DEFAULT();
		break;

// Components
	case "components_new":
	case "components_edit":
		TOOLBAR_comp::_EDIT();
		break;

	case "components":
		TOOLBAR_comp::_DEFAULT();
		break;

// Pre-defined replies
	case "replies_new":
	case "replies_edit":
		TOOLBAR_reply::_EDIT();
		break;

	case "replies":
		TOOLBAR_reply::_DEFAULT();
		break;

// Database Cleanup
	case "tools_db1":
		TOOLBAR_db::_DEFAULT();
		break;

// Import from Billets
	case "tools_billets1":
		TOOLBAR_billets::_DEFAULT();
		break;

// Import from RS Tickets
	case "tools_rstickets1":
		TOOLBAR_rstickets::_DEFAULT();
		break;

// Import from Ambrasubs
	case "tools_ambrasubs1":
		TOOLBAR_ambrasubs::_DEFAULT();
		break;

// Installer
	case "update":
		TOOLBAR_update::_DEFAULT();
		break;

//CUSTOMER ACCESS EVENTS
	case "customer_new":
		menuAccess::EDIT_MENU();
		break;

	case "customer_edit":
		menuAccess::EDIT_MENU();
		break;

	case "customer_cancel":
	case "customer":
		menuAccess::DEFAULT_MENU();
		break;

//USER GROUPS EVENTS
	case "group_new":
		menuGroup::EDIT_MENU();
		break;

	case "group_edit":
		menuGroup::EDIT_MENU();
		break;

	case "group_cancel":
	case "group":
		menuGroup::DEFAULT_MENU();
		break;

//CATEGORY EVENTS
	case "dlcategory_new":
		menuDLCategory::EDIT_MENU();
		break;

	case "dlcategory_edit":
		menuDLCategory::EDIT_MENU();
		break;

	case "dlcategory_cancel":
	case "dlcategory":
		menuDLCategory::DEFAULT_MENU();
		break;

//PRODUCT EVENTS
	case "product_new":
		menuProduct::EDIT_MENU();
		break;

	case "product_edit":
		menuProduct::EDIT_MENU();
		break;

	case "product_editversion":
		menuProduct::VERSIONEDIT_MENU();
		break;

	case "product_cancel":
	case "product":
		menuProduct::DEFAULT_MENU();
		break;

// Licenses
	case "licenses_new":
	case "licenses_edit":
		TOOLBAR_licenses::_EDIT();
		break;

	case "licenses":
		TOOLBAR_licenses::_DEFAULT();
		break;
	
// Forms
	case "forms_new":
	case "forms_edit":
		TOOLBAR_forms::_EDIT();
		break;

	case "forms":
		TOOLBAR_forms::_DEFAULT();
		break;

// Users
	case "users_new":
	case "users_edit":
		TOOLBAR_users::_EDIT();
		break;

	case "users_fieldsnew":
	case "users_fieldsedit":
		TOOLBAR_users::_FIELDS_EDIT();
		break;

	case "users_fields":
		TOOLBAR_users::_FIELDS_DEFAULT();
		break;
	
	case "users":
		TOOLBAR_users::_DEFAULT();
		break;

// Download Stats
	case "stats":
		TOOLBAR_stats::_DEFAULT();
		break;
	case "stats_hits":
		TOOLBAR_stats::_DEFAULTHITS();
		break;
}
