<?php

class PpinstallerHelperInstall {
	
	/*
	 * Return html for Installer Steps bar
	 */
	public static function stepbar()
 	{
		$task = JString::strtolower(JRequest::getWord('task','display'));
		switch ($task) {
			case 'backup':
			case 'revert':
				$on = 2;
				break;
			case 'migrate':
				$on = 3;
				break;
			case 'install':
				$on = 4;
				break;
			case 'patch':
				$on = 5;
				break;
			case 'complete':
				$on = 6;
				break;
			case 'display':
			default:
				$on = 1;
		}

 		$html =

	 			'<div class="pp-steps">'.
					'<div class="pp-step '.($on == 1 ? ' pp-active' : '').'" id="payplans_version">'.JText::_('COM_PPINSTALLER_STEP_1_LABEL').'</div>' .
					'<div class="pp-step '.($on == 2 ? ' pp-active' : '').'" id="payplans_backup">'.JText::_('COM_PPINSTALLER_STEP_2_LABEL').'</div>' .
					'<div class="pp-step '.($on == 3 ? ' pp-active' : '').'" id="payplans_migration">'.JText::_('COM_PPINSTALLER_STEP_3_LABEL').'</div>' .
 					'<div class="pp-step '.($on == 4 ? ' pp-active' : '').'" id="payplans_install">'.JText::_('COM_PPINSTALLER_STEP_4_LABEL').'</div>' .
					'<div class="pp-step '.($on == 5 ? ' pp-active' : '').'" id="payplans_patch">'.JText::_('COM_PPINSTALLER_STEP_5_LABEL').'</div>' .
					'<div class="pp-step '.($on == 6 ? ' pp-active' : '').'" id="payplans_complete">'.JText::_('COM_PPINSTALLER_STEP_6_LABEL').'</div>'.
 				'</div>';
			return $html;
	}
	
	public static function powered_by() {
		
		ob_start();
			echo JText::_('COM_PPINSTALLER_POWERED_BY');?>
		 	<a id="payplans-powered-by" href="http://www.jpayplans.com" target="_blank" >PayPlans</a><sup>TM</sup> <?php echo '<strong>'. PPINSTALLER_VERSION .'</strong>'?>	        		
	    <?php 
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
		     
	}
	
	
	
	public static function task_description($next_task) 
	{
		$append_msg = '';
		
		$task =JString::strtolower(JRequest::getWord('task','display'));
		
		switch($next_task){
			case 'backup':
				$msg = 'BACKUP_DESC';
				break;
			case 'migrate':
				$msg = 'MIGRATION_DESC';
				break;
			case 'install':
						$msg = 'INSTALLATION_DESC';
						$append_msg = JText::sprintf('COM_PPINSTALLER_LATEST_PAYPLANS_VERSION',PpinstallerHelperMigrate::requiredVersion());
						
						//If new version is already installed 
						$isPayPlansExist = PpinstallerHelperBackup::getTables();			
						// if tables exist then create backup
						if(!empty($isPayPlansExist) && $task != 'migrate')
						{
							$migration_status = PpinstallerHelperMigrate::getKeyValue();
							$bk_table_prefix  = PpinstallerHelperBackup::get_backup_table_prefix();
							$is_backup_exist  = PpinstallerHelperBackup::getTables($bk_table_prefix.'payplans%');
							// Say about how can revert payPlans Back up because currently,migration staus is "in progress".
							// if back up doesn't exist then skip this stage 
							if($migration_status >= PPINSTALLER_MIGRATION_START)
							{ // XiTODO:: clean code
								if(empty($is_backup_exist)) {
									$msg = 'DELETED_PREVIOUS_BACKUP';
									break;
								}
								$msg = 'INSTALLATION_WITH_REVERT_LINK_DESC';
								// dont use hard coded prefix
								$privious_version = PpinstallerHelperUtils::version_level(PpinstallerHelperMigrate::payplans_version($bk_table_prefix));
								$append_msg = JText::sprintf('COM_PPINSTALLER_PREVIOUS_PAYPLANS_VERSION',$privious_version);	
							}
						}
						break;
			case 'patch':
				$msg = 'PATCH_DESC';
				break;
			case 'complete':
				$msg = 'COMPLETE_DESC';
				break;
			default:
				$msg = 'DONT_HAVE_ANY_TASK';
		}
		
		if($task  == 'complete'){
			$msg = 'GO_TO_PAYPLANS_PAGE';
		}
		return JTEXT::_('COM_PPINSTALLER_'.$msg).$append_msg;

	}
	
	public static function addStyle($file ='core.css') {
		
		JFactory::getDocument()->addStyleSheet(PPINSTALLER_STYLE.$file);
	}
	public static function addScript($file='template.js')
	{
		JFactory::getDocument()->addScript(PPINSTALLER_JS.$file);
	}
	
	static function zip_from_url($kit_name, $url=null)
	{
		if(empty($url)){
			$url = PPINSTALLER_DEFINED_URL.$kit_name;
		}
		$kit_name = JString::strtolower($kit_name);
		
		$fh = fopen(PPINSTALLER_EXTENSION_PATH.DS.$kit_name, 'w');
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url); 
		curl_setopt($ch, CURLOPT_FILE, $fh); 
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // this will follow redirects
		$result = curl_exec($ch);
		curl_close($ch);
		fclose($fh);

		return $result;
	}
	
	// XiTODO:: move it into utils file
	static function extract($archive_name,$extract_dir)
	{
		$is_success = JArchive::extract($archive_name, $extract_dir);
		PpinstallerHelperLogger::log(JText::_('COM_PPINSTALLER_FILE_EXTRACT_'.(bool)$is_success).' Extract-Dir:'.$extract_dir);
	}
	

	static function set_extension($status = 0)
	{
		$query = "UPDATE `#__components` SET `enabled` = '$status' WHERE `link`='option=com_ppinstaller' AND `parent`=0";
		if (!defined('PPINSTALLER_15')){
			$query = "UPDATE `#__extensions` SET `enabled` = '$status' WHERE `type`='component' AND `element` ='com_ppinstaller'";
		}
		$db = JFactory::getDbo();
		$db->setQuery($query);

		$msg ='Issue on change extension-status';
		if($db->query()){
			$msg ='Successfully changed extension-status.';	
		}
		PpinstallerHelperLogger::log($msg);
	}

	static function uninstall($uninstall_items=Array())
	{
		// Get an installer object for the extension type
		$installer  =  JInstaller::getInstance();
		$is_success = true;
		
		foreach($uninstall_items as $item=>$item_type){								
			$ext_id = self::extension_id($item_type,$item);
	
			if(empty($ext_id)){	continue;}
			
			$result	   =  $installer->uninstall($item_type, $ext_id );

			if ($result === false) {
				$is_success &= false;
				$msg = JText::sprintf('COM_PPINSTALLER_UNINSTALLATION_ISSUE', $item.' '.$item_type);
			}else{
				$msg = JText::sprintf('COM_PPINSTALLER_SUCCESSFULLY_UNINSTALLED', $item.' '.$item_type);
			}
			PpinstallerHelperLogger::log($msg);
		}	
		
		return $is_success;
	}
	
	static function remove_plugins() 
	{
		$plugins = array( 
						array('system',	  			'payplans'),
					 	array('system',   			'payplanslogincontroller'),
					 	array('system',   			'mtreepayplans'),
					 	array('payplansmigration',  'acctexp'),
					 	array('payplansmigration',  'ambrasubs'),
					 	array('payplansmigration',  'amember')	
					  );
		
		$is_success = true;
					  
		foreach($plugins as $plugin){
			$folder = $plugin[0];
			$name 	= $plugin[1];
			$plugin_id = self::plugin_id($name, $folder);
			
			if(empty($plugin_id)){
				continue;
			}
			
			$is_success &= self::uninstall_extension('plugin',$plugin_id);
		}
		return $is_success;
	}
	
	static function remove_modules() 
	{
		$modules = array( 
							'mod_payplans_subscription'
					  	);
		$is_success = true;
		foreach($modules as $module_name){
			$module_id = self::module_id($module_name);
			
			if(empty($module_id)){
				continue;
			}
			
			$is_success &= self::uninstall_extension('module',$module_id);
		}
		return $is_success;
	}
	
	static function remove_component() 
	{
		$component_id = self::component_id();
		
		if(empty($component_id)){
				return true;
		}
					
		return self::uninstall_extension('component',$component_id);
	}
	
	
	static function plugin_id($name, $folder)
	{
		$db		= JFactory::getDBO();
		
		if(!defined('PPINSTALLER_15')){
			$query	= ' SELECT  `extension_id` FROM  '. $db->nameQuote( '#__extensions' )
					. ' WHERE '. $db->nameQuote('element')."='$name' "
					. ' AND ' . $db->nameQuote('folder')."='$folder'" 
					. " AND `type`='plugin' ";
		}
		else {
			$query	= 'SELECT  `id` FROM ' . $db->nameQuote('#__plugins' )
		        	. ' WHERE ' . $db->nameQuote('element')."= '$name' "
		        	. ' AND ' . $db->nameQuote('folder')."='$folder' "
					;
		}
				
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	static function module_id($name)
	{	
		$db		= JFactory::getDBO();
				
		$query	= ' SELECT `id` FROM ' . $db->nameQuote( '#__modules' )
		        . ' WHERE '  . $db->nameQuote('module')."='$name'";
		
		
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	static function component_id($name='PayPlans')
	{	
		$db		= JFactory::getDBO();
				
		$query = " SELECT `id` 
				   FROM #__components
				   WHERE name='PayPlans' AND `parent` = 0 
				 ";
		// for Joomla 1.7 or later version
		if(!defined('PPINSTALLER_15')){
			$query = "  SELECT `extension_id` 
				   		FROM #__extensions
				   		WHERE `type`    = 'component' 
				   		AND `element` = 'com_payplans'
				 	";
		}
		$db->setQuery($query);
		return $db->loadResult();
	}

	static function uninstall_extension($ext_type,$ext_id,$c_id=0)
	{
		// Get an installer object for the extension type
		$installer  =  JInstaller::getInstance();
		
		$result = $installer->uninstall($ext_type, $ext_id);
		
		if (false === $result){
			$msg = JText::sprintf('COM_PPINSTALLER_UNINSTALLATION_ISSUE', $ext_id.' '.$ext_type);
		}
		else{
			$msg = JText::sprintf('COM_PPINSTALLER_SUCCESSFULLY_UNINSTALLED', $ext_id.' '.$ext_type);
		}
		
		PpinstallerHelperLogger::log($msg);
		return $result;
	}
		
}