<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: log.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

switch ($task) {
	default:
		showMail();
		break;
}

/**
* Compiles a list of workgroups
* @param string The component name
*/
function showMail() {
	$database = JFactory::getDBO();
	$mainframe = JFactory::getApplication();
	$limit = $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__support_mail_log" );
	$total = $database->loadResult();
	echo $database->getErrorMsg();

		jimport('joomla.html.pagination');;
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$query = "SELECT l.id, l.date, l.email, l.log, m.email as mailaccount FROM #__support_mail_fetch m, #__support_mail_log l WHERE l.id_mail_fetch=m.id ORDER BY l.date DESC";
	$database->setQuery( $query );
	$rows = $database->loadObjectList();

	smslog_html::show( $rows, $pageNav);
}

/**
* @package iMaQma Helpdesk
*/
class smslog_html {
	/**
	* Writes a list of the categories
	* @param array An array of category objects
	* @param string The name of the category section
	*/
	function show( &$rows, &$pageNav) { ?>
		<form action="index.php" method="post" name="adminForm">
		
		<table class="adminheading">
		<tr>
			<th class="mail">
			<?php echo JText::_('sms_log'); ?>
			</th>
		</tr>
		</table>
		
		<table class="adminlist">
		<thead>
		<tr>
			<th width="20">#</th>
			<th width="20">
				<input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count( $rows );?>);" />
			</th>
			<th class="title"><?php echo JText::_('e_mail'); ?></th>
			<th class="title"><?php echo JText::_('dl_date'); ?></th>
			<th class="title"><?php echo JText::_('sender'); ?></th>
			<th class="title"><?php echo JText::_('log'); ?></th>
		</tr>
		</thead>
		<tbody>
		<?php
		if (count( $rows )==0) {
			?><tr><td colspan="6"><?php echo JText::_('register_not_found'); ?></td></tr><?php
		} else {
			$k = 0;
			for ($i=0, $n=count( $rows ); $i < $n; $i++) {
				$row = &$rows[$i];
				?>
				<tr class="<?php echo "row$k"; ?>">
					<td width="20" align="right"><?php echo $pageNav->getRowOffset( $i ); ?></td>
					<td width="20"><?php echo JHTML::_('grid.id', $i, $row->id, 0 ); ?></td>
					<td><?php echo $row->mailaccount; ?></td>
					<td><?php echo $row->date; ?></td>
					<td><?php echo $row->email; ?></td>
					<td><?php echo $row->log; ?></td>
					<?php		
					$k = 1 - $k; 
					?>
				</tr>
				<?php	
			} // for loop
		} // if ?>
		</tbody>
		<tfoot>
			<tr>
				<td colspan="6">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tr>
		</tfoot>
		</table>
		
		<input type="hidden" name="option" value="com_maqmahelpdesk" />
		<input type="hidden" name="task" value="mails" />
		<input type="hidden" name="boxchecked" value="0" />
		</form>
		<?php
	}
}
?>