<?php
/**
* iMaQma Helpdesk Component
* www.imaqma.com
*
* @package iMaQma Helpdesk
* @copyright (C) 2000-2011 Components Lab, Lda.
* @license GNU/GPL
* 
* $Id: forms.class.php 337 2012-01-22 17:24:30Z pdaniel $
* $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
*
**/

/*
	Class for the Forms feature
 */
class scForms
{
	// Variables that can output information for debug
	var $file  = 'forms.class.php';
	var $class = 'scForms';
	var $debug = '';

	/*
		Will check if the form table already exists in the system. 
		If the table don't exist it will create it or not depending on the $action parameter.
		@param int The Form ID.
		@param tinyint The action ID (0 don't create, 1 create).
    */
    function checkForm( $id, $action )
	{
		$database = JFactory::getDBO();

		$database->setQuery( "SHOW COLUMNS FROM #__support_form_".$id );
		if( !is_array($database->loadObjectList()) && $action==1 ) {
			$sql_create = '';
			$sql = "SELECT * FROM #__support_form_field WHERE id_form='".$id."'";
			$database->setQuery( $sql );
			$rows = $database->loadObjectList();

			for( $i=0; $i<count($rows); $i++ ) 
			{
				$row = $rows[$i];
				$field = strtolower(str_replace(' ', '_', $row->caption));
				$sql_create .= '`'.$field.'` VARCHAR( 250 ) NOT NULL ,';
			}
			
			$sql_create = 'CREATE TABLE `#__support_form_'.$id.'` (
								`id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
								'.$sql_create.'
								`sc_ipaddress` VARCHAR( 25 ) NOT NULL ,
								`sc_recorddate` datetime NOT NULL default \'0000-00-00\' ,
								`sc_userid` INT NOT NULL default \'0\' ,
								PRIMARY KEY ( `id` ) 
							);';
			$database->setQuery( $sql_create );
			$database->query();

			return true;
		}elseif( !is_array($database->loadObjectList()) && $action==0 ) {
			return false;
		}
	}

	/*
		Will add new field into a form table.
		@param int The Form ID.
		@param int The Field ID.
    */
    function alterForm( $id_form, $id_field )
	{
		$database = JFactory::getDBO();

		$sql = "SELECT caption FROM #__support_form_field WHERE id='".$id_field."'";
		$database->setQuery( $sql );
		$row  = $database->loadObject();
		$field = strtolower(str_replace(' ', '_', $row->caption));
		
		$sql_create = 'ALTER TABLE `#__support_form_'.$id_form.'` ADD `'.$field.'` VARCHAR( 250 ) NOT NULL;';
		$database->setQuery( $sql_create );
		$database->query();
	}

	/*
		Saves the results of a form post into the database
		@param int The Form ID.
		@param boolean Indicates if it saves the records in DB.
		@param boolean Indicates if outputs the results of the form in the page.
		@param string Indicates the e-mail addresses where to send the result.
		@param string Indicates the files to be included.
		@param string Indicates the fields that have e-mail addresses to send the results.
    */
    function saveForm( $id_form, $row, $save_db, $output, $emails, $includes, $user )
	{
		$database = JFactory::getDBO();
		$CONFIG = new JConfig();
		$luser	= JFactory::getUser();
		
		/*print "<p>save_db: $save_db";
		print "<br>output: $output";
		print "<br>emails: $emails";
		print "<br>includes: $includes";
		print "<br>user: $user";*/
		
		// Get the form fields
		$sql = "SELECT * FROM `#__support_form_field` WHERE `id_form`='".$id_form."' ORDER BY `order`";
		$database->setQuery( $sql );
		$rowFields = $database->loadObjectList();
		
		$insert_sql_label = '';
		$insert_sql_value = '';
		$output_html      = '';

		for ($x=0; $x < count($rowFields); $x++) {
			$rowField = $rowFields[$x];

			$insert_sql_label .= '`'.strtolower(str_replace(' ', '_', $rowField->caption)).'`,';
			$insert_sql_value .= "'".$_POST['custom'.$rowField->id]."',";
			$form_result[strtolower(str_replace(' ', '_', $rowField->caption))] = $rowField->id;
			$output_html .= "<tr><td valign='top'><b>".$rowField->caption."</b></td><td>".nl2br($_POST['custom'.$rowField->id])."</td></tr>";
		}
		
		// Save the form result into DB
		if( $save_db ) {
			$insert_sql_label = $insert_sql_label.'`sc_ipaddress`,`sc_recorddate`,`sc_userid`';
			$insert_sql_value = $insert_sql_value."'".GetUserIPAddress()."','".date("Y-m-d H:i:s")."',".$luser->id;
			$sql = "INSERT INTO `#__support_form_".$id_form."` (".$insert_sql_label.") VALUES (".$insert_sql_value.");";
			$database->setQuery( $sql );
			$database->query();
		}
		
		$output_html = JText::_('form_thankyou').'<table width="100%">'.$output_html.'</table>';

		// Outputs the results to the screen
		if( $output ) {
			print $output_html;
		}
		
		// Sends the e-mail's
		if( $emails != '' ) {
			$emails = explode( ',', $emails );

			for( $i=0; $i<count($emails); $i++ )
			{
				JUtility::sendMail( $CONFIG->mailfrom, $CONFIG->fromname, $emails[$i], $row->name, $output_html, 1 );
			}
		}
		
		// Sends the e-mail's to specified fields
		if( $user != '' ) {
			$user = explode( ',', $user );

			for( $i=0; $i<count($user); $i++ )
			{
				$send_user = $_POST['custom'.$form_result[strtolower(str_replace(' ', '_', $user[$i]))]];
				JUtility::sendMail( $CONFIG->mailfrom, $CONFIG->fromname, $send_user, $row->name, $output_html, 1 );
			}
		}
		
		// Includes external files
		if( $includes != '' ) {
			$includes = explode( ',', $includes );

			for( $i=0; $i<count($includes); $i++ )
			{
				if( file_exists($includes[$i]) ) {
					include( $includes[$i] );
				}
			}
		}
	}
}

?>