<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: announce.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$id = JRequest::getVar( 'id', 0, '', 'int' );
$limit = intval( JRequest::getVar( 'limit', '', '', 'string' ) );
$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

// Activities logger
mqm_activitylog('site', 'announce', $task, $id);

switch( $task ) 
{
	case "list":
		isValidPermissions($task, 'A') ? showAnnounces( $limit, $limitstart ) : noAccessQuit();
		break;
	
	case "view":
		isValidPermissions($task, 'A') ? showAnnounce( $id, 0 ) : noAccessQuit();
		break;

	case "print":
		isValidPermissions($task, 'A') ? showAnnounce( $id, 1 ) : noAccessQuit();
		break;
}

function showAnnounces( $limit, $limitstart ) 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions;
	
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$CONFIG = new JConfig();
	$database = JFactory::getDBO();
	
	// Sets the title
	PageTitle('showAnnounces');

	// Get knowledge base articles
	$limit = $limit ? $limit : $CONFIG->list_limit ;
	$database->setQuery( "SELECT id, `date`, introtext AS intro, bodytext AS body, frontpage, urgent as `type`, sent, id_workgroup FROM #__support_announce WHERE (id_workgroup='".$id_workgroup."' OR id_workgroup='0') ".($is_support ? "" : "AND (id_client='0' OR id_client='".$is_client."')")." ORDER BY date DESC LIMIT ". $limitstart .", ". $limit );
	$rows = $database->loadObjectList();
	
	$database->setQuery( "SELECT COUNT(*) FROM #__support_announce WHERE (id_workgroup='".$id_workgroup."' OR id_workgroup='0') ".($is_support ? "" : "AND (id_client='0' OR id_client='".$is_client."')") );
	$total = $database->loadResult();

	if ( $total <= $limit ) $limitstart = 0;
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	$i = 1;
	foreach( $rows as $key2 => $value2 )
	{
		if( is_object($value2) ) {
			foreach( $value2 as $key3 => $value3 )
			{
				$announcements[$i][$key3] = $value3;

				if( $key3 == 'id' ) {
					$announcements[$i]['link'] = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=announce_view&id='.$value3);
				}
				if( $key3 == 'date' ) {
					$announcements[$i]['date_year']  = substr( $value3, 0, 4 );
					$announcements[$i]['date_month'] = substr( $value3, 5, 2 );
					$announcements[$i]['date_day']   = substr( $value3, 8, 2 );
					$announcements[$i]['date_day_desc']            = substr( $value3, 8, 2 ).ordinalNumber( substr( $value3, 8, 2 ) );
					$announcements[$i]['date_month_desc_complete'] = returnMonthDesc( substr( $value3, 5, 2 ) );
					$announcements[$i]['date_month_desc_small']    = substr( returnMonthDesc( substr( $value3, 5, 2 ) ), 0, 3 );
				}
				if( $key3 == 'body' ) {
					$announcements[$i]['body_resume']  = substr( strip_tags($value3), 0, 50 ).'...';
				}
				if( $key3 == 'type' ) {
					if( $value3 == 1 ) {
						$announcements[$i]['urgent'] = '<img src="components/com_maqmahelpdesk/images/16px/tick.png" border="0" align="absmiddle" />';
					}else{
						$announcements[$i]['urgent'] = '<img src="components/com_maqmahelpdesk/images/16px/no.png" border="0" align="absmiddle" />';
					}
				}
			}
		}

		$i++;
	}
	
	// Takes care of pagination
	$link = JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=announce_list');
	$pagelinks   = $pageNav->getPagesLinks( $link );
	$pagecounter = $pageNav->getPagesCounter();
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/general/announcements_list.php' );
}

function showAnnounce( $id, $print ) 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions;

	$mainframe = JFactory::getApplication();
	$document = JFactory::getDocument();
	$database = JFactory::getDBO();
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	
	// If it's the print version shows icon to print and to close
	if( $print ) {
		$img_src = JURI::root().'components/com_maqmahelpdesk/images/';
		echo '<style type="text/css" media="'.JText::_('print').'">';
		echo '.exclude {';
		echo '	visibility: hidden;';
		echo '  display: none;';
		echo '}';
		echo '</style>';
		echo '<div align="right" class="exclude">';
		echo '<img src="'.$img_src.'16px/print.png" border="0" onClick="javascript:window.print();" style="cursor: pointer;" title="'.JText::_('print').'" />';
		echo '&nbsp;';
		echo '<img src="'.$img_src.'16px/close.png" border="0" onClick="javascript:window.close();" style="cursor: pointer;" title="'.JText::_('close').'" />';
		echo '</div>';
	}

	// Get announcements
	$database->setQuery( "SELECT id, `date`, introtext, bodytext, frontpage, urgent, sent, id_workgroup FROM #__support_announce WHERE id='".$id."'");
	$announce = null;
	$announce = $database->loadObject();
	$announce->bodytext = str_replace('\"', '"', $announce->bodytext);

	// Set title
	pageTitle('viewAnnouncements',$announce->introtext);

	// Set the page title, keywords and metadata
	$document->title = $announce->introtext.' - '.JText::_('ANNOUNCEMENTS');
	$document->description = substr(strip_tags($announce->bodytext), 0, 75);
	
	$ok_img = '<img src="components/com_maqmahelpdesk/images/16px/tick.png" border="0" align="absmiddle" />';
	$no_img = '<img src="components/com_maqmahelpdesk/images/16px/no.png" border="0" align="absmiddle" />';
	$link = JRoute::_( JURI::root().'index2.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=announce_print&id='.$announce->id.'&tmpl=component' );
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/general/announcements_'.($print == 1 ? 'print' : 'record').'.php' );
}
