<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: discussions.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$id	= JRequest::getVar( 'id', 0, '', 'int' );

// Activities logger
mqm_activitylog('site', 'discussions', $task, $id);

switch( $task ) 
{
	case "save":
		isValidPermissions($task, 'DI') ? saveQA() : noAccessQuit();
		break;
	case "view":
		isValidPermissions($task, 'DI') ? viewQA() : noAccessQuit();
		break;
	case "search":
		isValidPermissions($task, 'DI') ? searchQA() : noAccessQuit();
		break;
	case "question":
		isValidPermissions($task, 'DI') ? questionQA() : noAccessQuit();
		break;
	case "answer":
		isValidPermissions($task, 'DI') ? answerQA() : noAccessQuit();
		break;
	case "accept":
		isValidPermissions($task, 'DI') ? acceptQA() : noAccessQuit();
		break;
	case "vote":
		isValidPermissions($task, 'DI') ? voteQA() : noAccessQuit();
		break;
	case "publish":
		isValidPermissions($task, 'DI') ? publishQA() : noAccessQuit();
		break;
	case "delete":
		isValidPermissions($task, 'DI') ? deleteQA() : noAccessQuit();
		break;
	default:
		showQA();
		break;
}

function showQA() 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions;
	
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$CONFIG = new JConfig();
	$database = JFactory::getDBO();
	$limit = intval( JRequest::getVar( 'limit', '', '', 'string' ) );
	$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
	$searchinput = JRequest::getVar( 'searchinput', '', '', 'string' );
	
	// Sets the title
	PageTitle('showDiscussions');
	
	// Build WHERE clause
	$where = '';
	if( !$is_support ) {
		$where.= 'WHERE d.`published`=1';
	}
	if( $searchinput != '' ) {
		$where.= ( $where=='' ? 'WHERE ' : ' AND ' );
		$where.= "(";
		$where.= "d.`title` LIKE '%".$database->getEscaped($searchinput)."%' OR d.`content` LIKE '%".$database->getEscaped($searchinput)."%' OR d.`tags` LIKE '%".$database->getEscaped($searchinput)."%'";
		$where.= ")";
	}
	
	// Get knowledge base articles
	$limit = $limit ? $limit : $CONFIG->list_limit ;
	$sql = "SELECT d.`id`, u.`name`, d.`date_created`, d.`title`, d.`content`, d.`published`, d.`status`, d.`converted`, d.`votes`, d.`views`, d.`tags`, d.`id_user`, su.`avatar`, COUNT(m.`id`) AS messages
			FROM `#__support_discussions` AS d
				 INNER JOIN `#__users` AS u ON u.`id` = d.`id_user`
				 LEFT JOIN `#__support_users` AS su ON su.`id_user` = u.`id`
				 LEFT JOIN `#__support_discussions_messages` AS m ON m.`id_discussion` = d.`id`
			".$where."
			GROUP BY d.`id`, u.`name`, d.`date_created`, d.`title`, d.`content`, d.`published`, d.`status`, d.`converted`
			ORDER BY d.`id` DESC 
			LIMIT ". $limitstart .", ". $limit;
	$database->setQuery( $sql );
	$rows = $database->loadObjectList();
	
	$sql = "SELECT COUNT(*)
			FROM `#__support_discussions` AS d
				 INNER JOIN `#__users` AS u ON u.`id` = d.`id_user`
				 LEFT JOIN `#__support_users` AS su ON su.`id_user` = u.`id`
			".$where;
	$database->setQuery( $sql );
	$total = $database->loadResult();

	if ( $total <= $limit ) $limitstart = 0;
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	// Takes care of pagination
	$link = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions';
	$pagelinks   = $pageNav->getPagesLinks( $link );
	$pagecounter = $pageNav->getPagesCounter();
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/discussions/list.php' );
}

function viewQA() 
{
	global $supportConfig, $workgroupSettings, $is_support;

	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	$document = JFactory::getDocument();
	$user = JFactory::getUser();
	$id	= JRequest::getVar( 'id', 0, '', 'int' );
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	
	// Get question details
	$sql = "SELECT d.`id`, d.`tags`, d.`date_created`, d.`title`, d.`content`, d.`published`, d.`status`, d.`converted`, d.`views`, d.`votes`, u.`name`, su.`avatar`, d.`id_user`
			FROM `#__support_discussions` AS d
				 INNER JOIN `#__users` AS u ON u.`id` = d.`id_user`
				 LEFT JOIN `#__support_users` AS su ON su.`id_user` = u.`id`
			WHERE d.`id`=".$id.(!$is_support?" AND d.published = 1":"");
	$database->setQuery( $sql );
	$row = $database->loadObject();
	
	// Get messages
	$sql = "SELECT m.`id`, m.`id_user`, m.`is_support`, m.`date_created`, m.`content`, m.`votes`, su.`avatar`, u.`name`, m.`published`
			FROM `#__support_discussions_messages` AS m
				 INNER JOIN `#__users` AS u ON u.`id` = m.`id_user`
				 LEFT JOIN `#__support_users` AS su ON su.`id_user` = m.`id_user`
			WHERE m.`id_discussion` = ".$row->id.(!$is_support?" AND m.published = 1":"")."
			ORDER BY m.`id` ASC";
	$database->setQuery( $sql );
	$messages = $database->loadObjectList();
	
	// Increment views (only if not the author)
	if( $row->id_user != $user->id ) {
		$sql = "UPDATE `#__support_discussions`
				SET `views`=(`views`+1)
				WHERE `id`=".$id;
		$database->setQuery( $sql );
		$database->query();
	}
	
	// Avatar
	$avatar = mqm_getavatar($row->id_user);
	
	// Set title
	pageTitle('viewDiscussion',$row->title);

	// Set the page title, keywords and metadata
	$document->title = $row->title.' - '.JText::_('DISCUSSIONS');
	$document->description = substr(strip_tags($row->content), 0, 75);
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/discussions/view.php' );
}

function acceptQA()
{
	global $is_support, $supportConfig;
	
	$database = JFactory::getDBO();
	$user = JFactory::getUser();
	$id_discussion = intval( JRequest::getVar( 'id_discussion', 0, '', 'int' ) );
	$id_message = intval( JRequest::getVar( 'id_message', 0, '', 'int' ) );
	
	if( $user->id ) {
		// Post in JomSocial wall
		if( $supportConfig->js_post_question_wall ) {
			$sql = "SELECT `title`
					FROM `#__support_discussions`
					WHERE `id` = $id_discussion";
			$database->setQuery( $sql );
			$title = $database->loadResult();
			
			$sql = "SELECT u.`name`
					FROM `#__users` AS u
						 INNER JOIN `#__discussions_messages` AS m ON m.`id_user`=u.`id`
					WHERE m.`id`=";
			
			$comment = sprintf(JText::_("js_answer_selected"), JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$id_workgroup."&task=discussion_view&id=".$id_discussion), $title, $title);
			mqm_jomsocial_post($user->id, $comment, $title);
		}
		// Updates the database
		$sql = "UPDATE `#__support_discussions`
				SET `status`=$id_message
				WHERE `id` = $id_discussion
				  AND `id_user` = ".$user->id;
		$database->setQuery( $sql );
		echo $database->query().'|'.JText::_('answer_was_selected');
	}else{
		echo '0|';
	}
}

function voteQA()
{
	global $is_support;
	
	$database = JFactory::getDBO();
	$user = JFactory::getUser();
	$updown = JRequest::getVar( 'updown', '', '', 'string' );
	$id_discussion = intval( JRequest::getVar( 'id_discussion', 0, '', 'int' ) );
	$id_message = intval( JRequest::getVar( 'id_message', 0, '', 'int' ) );
	
	// Check if already voted
	$sql = "SELECT `id`
			FROM `#__support_discussions_votes`
			WHERE `id_discussion`=$id_discussion AND `id_user`=".$user->id;
	$database->setQuery( $sql );
	$vote_id = (int)$database->loadResult();
	
	if( $vote_id ) {
		echo '0|'.JText::_('already_voted_discussion');
		return;
	}
	
	if( $user->id ) {
		// Post in JomSocial wall
		if( $supportConfig->js_post_votes_wall ) {
			$sql = "SELECT `title`
					FROM `#__support_discussions`
					WHERE `id` = $id_discussion";
			$database->setQuery( $sql );
			$title = $database->loadResult();
			
			$comment = sprintf(JText::_("js_question_vote"), JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$id_workgroup."&task=discussion_view&id=".$id_discussion), $title, $title);
			mqm_jomsocial_post($user->id, $comment, $title);
		}
		
		// Record vote for user in this discussion
		$sql = "INSERT INTO `#__support_discussions_votes`(`id_user`, `id_discussion`, `id_message`, `date_created`, `vote`)
				VALUES(".$user->id.", $id_discussion, $id_message, '".dateOffset("Y-m-d H:i:s")."', ".($updown=='+'?1:-1).")";
		$database->setQuery( $sql );
		$database->query();
		
		// Update votes
		if( $id_message ) {
			$sql = "UPDATE `#__support_discussions_messages`
					SET `votes`=(`votes`".($updown=='up'?'+':'-')."1)
					WHERE `id` = $id_message";
		}else{
			$sql = "UPDATE `#__support_discussions`
					SET `votes`=(`votes`".($updown=='up'?'+':'-')."1)
					WHERE `id` = $id_discussion";
		}
		$database->setQuery( $sql );
		echo $database->query().'|'.JText::_('voted_answer');
	}else{
		echo '0|';
	}
}

function saveQA()
{
	global $is_support, $supportConfig;
	
	$CONFIG = new JConfig();
	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	$user = JFactory::getUser();
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$title = JRequest::getVar( 'title', '', '', 'string' );
	$content = JRequest::getVar( 'question_content', '', '', 'string' );
	$tags = JRequest::getVar( 'tags', '', '', 'string' );
	
	// Get Workgroup Options
	$database->setQuery( "SELECT * FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
	$wkoptions = $database->loadObject();
	
	// Duplication check
	$sql = "SELECT COUNT(*)
			FROM `#__support_discussions`
			WHERE `id_user`=".$user->id."
			  AND `id_workgroup`=".$id_workgroup."
			  AND `title`=".$database->quote($title)."
			  AND `content`=".$database->quote(nl2br($content));
	$database->setQuery( $sql );
	
	if( $database->loadResult() == 0 ) {
		// Insert into database
		$sql = "INSERT INTO `#__support_discussions`(`tags`, `id_user`, `id_workgroup`, `date_created`, `title`, `content`, `published`)
				VALUES(".$database->quote(str_replace(' ',',',$tags)).",".$user->id.", $id_workgroup, '".date("Y-m-d H:i:s")."', ".$database->quote($title).", ".$database->quote(nl2br($content)).",".($supportConfig->discussions_moderated?0:1).")";
		$database->setQuery( $sql );
		$database->query();
		$id = $database->insertid();
		
		// Post in JomSocial wall
		if( $supportConfig->js_post_question_wall ) {
			$comment = sprintf(JText::_("js_created_question"), JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$id_workgroup."&task=discussion_view&id=".$id), $title, $title);
			mqm_jomsocial_post($user->id, $comment, $title);
		}
		
		// Send notification
		$vars = array(
					'[title]'    => $title,
					'[question]' => nl2br($content),
					'[author]'   => $user->name,
					'[url]'      => JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions_view&id='.$id)
				);
		$body = parseTpl( $vars, 'discussion_new' );
		$mailer = JFactory::getMailer();
		$mailer->setSender( array($CONFIG->fromname, $CONFIG->mailfrom) );
		$mailer->addRecipient( $wkoptions->wkmail_address );
		$mailer->setSubject( JText::_('mail_subject')  );
		$mailer->setBody( $body );
		$mailer->IsHTML( true );
		$sendmail = $mailer->Send();
		
		// Redirect to discussions page
		$mainframe->redirect(JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions&msgtype=i&msg='.urlencode($supportConfig->discussions_moderated?JText::_('saved_pending'):JText::_('saved_available'))));
	}else{
		// Redirect to discussions page
		$mainframe->redirect(JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions'));
	}
}

function answerQA()
{
	global $is_support, $supportConfig;
	
	$CONFIG = new JConfig();
	$database = JFactory::getDBO();
	$user = JFactory::getUser();
	$id_discussion = intval( JRequest::getVar( 'id_discussion', 0, '', 'int' ) );
	$answer = JRequest::getVar( 'answer', '', '', 'string' );
	$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
	$Itemid = JRequest::getInt( 'Itemid', 0 );
	
	if( $user->id ) {
		// Get Workgroup Options
		$database->setQuery( "SELECT * FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
		$wkoptions = $database->loadObject();
		
		// Insert the answer
		$sql = "INSERT INTO `#__support_discussions_messages`(`id_discussion`, `id_user`, `is_support`, `date_created`, `content`, `published`)
				VALUES(".$id_discussion.", ".$user->id.", ".$is_support.", '".date("Y-m-d H:i:s")."', ".$database->quote(nl2br($answer)).", ".($supportConfig->discussions_moderated?0:1).")";
		$database->setQuery( $sql );
		echo $database->query().'|'.JText::_('answer_saved');
		
		// Get question details
		$sql = "SELECT `id`, `title`, `content`
				FROM #__support_discussions 
				WHERE id='".$id_discussion."'";
		$database->setQuery( $sql );
		$discussion = $database->loadObject();
		
		// Post in JomSocial wall
		if( $supportConfig->js_post_answer_wall ) {
			$comment = sprintf(JText::_("js_created_answer"), JRoute::_("index.php?option=com_maqmahelpdesk&Itemid=".$Itemid."&id_workgroup=".$id_workgroup."&task=discussion_view&id=".$id), $discussion->title, $discussion->title);
			mqm_jomsocial_post($user->id, $comment, $answer);
		}
		
		// Send notification
		$vars = array(
					'[title]'    => $discussion->title,
					'[question]' => nl2br($discussion->content),
					'[answer]'   => nl2br($answer),
					'[author]'   => $user->name,
					'[url]'      => JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions_view&id='.$id_discussion.'#answer'.$database->insertid())
				);
		$body = parseTpl( $vars, 'discussion_answer' );
		$mailer = JFactory::getMailer();
		$mailer->setSender( array($CONFIG->fromname, $CONFIG->mailfrom) );
		$mailer->addRecipient( $wkoptions->wkmail_address );
		$mailer->setSubject( JText::_('mail_subject_answer').($supportConfig->discussions_moderated?' - '.JText::_('unpublished'):'') );
		$mailer->setBody( $body );
		$mailer->IsHTML( true );
		$mailer->Send();
	}else{
		echo '0|';
	}
}

function questionQA()
{
	global $workgroupSettings, $supportConfig;
	
	$mainframe = JFactory::getApplication();
	$document = JFactory::getDocument();
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	$Itemid = JRequest::getVar( 'Itemid', 0, '', 'int' );
	
	// Set title
	pageTitle('newDiscussion');

	// Set the page title, keywords and metadata
	$document->title = JText::_('ask_question').' - '.JText::_('DISCUSSIONS');
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/discussions/form.php' );
}

function publishQA()
{
	global $is_support;
	
	$database = JFactory::getDBO();
	$id_discussion = intval( JRequest::getVar( 'id_discussion', 0, '', 'int' ) );
	$id_message = intval( JRequest::getVar( 'id_message', 0, '', 'int' ) );
	
	if( $is_support ) {
		if( $id_message ) {
			$sql = "UPDATE `#__support_discussions_messages`
					SET `published`=1
					WHERE `id` = $id_message";
		}else{
			$sql = "UPDATE `#__support_discussions`
					SET `published`=1
					WHERE `id` = $id_discussion";
		}
		$database->setQuery( $sql );
		echo $database->query().'|'.JText::_('question_published');
	}else{
		echo '0|';
	}
}

function deleteQA()
{
	global $is_support;
	
	$database = JFactory::getDBO();
	$Itemid	= JRequest::getInt( 'Itemid', 0 );
	$id_workgroup = JRequest::getInt( 'id_workgroup', 0 );
	$id = JRequest::getInt( 'id', 0 );
	
	$sql = "DELETE FROM `#__support_discussions`
			WHERE `id` = $id";
	$database->setQuery( $sql );
	$database->query();
	
	$sql = "DELETE FROM `#__support_discussions_messages`
			WHERE `id_discussion` = $id";
	$database->setQuery( $sql );
	$database->query();
	
	// Redirect to discussions page
	$mainframe->redirect(JRoute::_('index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=discussions&msgtype=i&msg='.urlencode(JText::_('discussion_delete'))));
}