<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: my.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$id = JRequest::getVar( 'id', 0, '', 'int' );
$limit = intval( JRequest::getVar( 'limit', '', '', 'string' ) );
$limitstart = intval( JRequest::getVar( 'limitstart', 0, '', 'int' ) );

// Activities logger
mqm_activitylog('site', 'my', $task, $id);

switch( $task ) 
{
	case "kb":
		showKB( $limit, $limitstart );
		break;
	
	case "delbookmark":
		delBookmark( $id );
		break;

	case "bookmark":
		showBookmark();
		break;
}

function showKB( $limit, $limitstart ) 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions;

	$CONFIG = new JConfig();
	$database = JFactory::getDBO();
	$user	= JFactory::getUser();
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	
	// Set title
	PageTitle('showMyKB');
	
	$limit = $limit ? $limit : $CONFIG->list_limit ;

	// Get knowledge base articles
	$database->setQuery( "SELECT DISTINCT k.id, k.kbcode as code, k.kbtitle as title, k.views, u.name as author, k.date_created, k.date_updated FROM #__support_category as c, #__support_kb as k, #__support_kb_category as kc, #__users as u WHERE c.`show`='1' AND c.id_workgroup='".$id_workgroup."' AND c.id=kc.id_category AND kc.id_kb=k.id AND k.publish='1' AND k.id_user='".$user->id."' AND u.id=k.id_user GROUP BY k.id, k.kbcode, k.kbtitle, k.views ORDER BY k.date_updated DESC LIMIT ". $limitstart .", ". $limit );
	$articles = $database->loadObjectList();
	
	$i = 1;
	foreach( $articles as $key2 => $value2 )
	{
		if( is_object($value2) ) {
			foreach( $value2 as $key3 => $value3 )
			{
				$articles_rows[$i][$key3] = $value3;
				
				if( $key3 == 'id' ) {
					$articles_rows[$i]['link']         = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_view&id='.$value3;
					$articles_rows[$i]['link_edit']    = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_edit&id='.$value3;
					$articles_rows[$i]['rate_image']   = (getRate($value3, 'K', 0)?getRate($value3, 'K', 1):JText::_('unrated'));
					$articles_rows[$i]['rate']         = (getRate($value3, 'K', 0)?getRate($value3, 'K', 0):JText::_('unrated'));
				}

				if( $key3 == 'date_created' )
					$articles_rows[$i]['date_created'] = date($supportConfig->date_short,strtotime($value3));

				if( $key3 == 'date_updated' )
					$articles_rows[$i]['date_updated'] = date($supportConfig->date_short,strtotime($value3));
			}
		}

		$i++;
	}

	$database->setQuery( "SELECT COUNT(DISTINCT k.id) FROM #__support_category as c, #__support_kb as k, #__support_kb_category as kc, #__users as u WHERE c.`show`='1' AND c.id_workgroup='".$id_workgroup."' AND c.id=kc.id_category AND kc.id_kb=k.id AND k.publish='1' AND k.id_user='".$user->id."' AND u.id=k.id_user" );
	$total = $database->loadResult();

	if ( $total <= $limit ) $limitstart = 0;
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );

	// Set if user can edit article
	$edit = 0;
	if( $is_support ) {
		$edit = 1;
	}
	
	// Takes care of pagination
	$link = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=my_kb';
	$pagelinks = $pageNav->getPagesLinks( $link );
	$pagecounter = $pageNav->getPagesCounter();
	
	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/kb/my_articles.php' );
}

function showBookmark() 
{
	global $supportConfig, $is_support, $is_client, $workgroupSettings, $supportOptions;

	$database = JFactory::getDBO();
	$user	= JFactory::getUser();
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	
	// Set title
	pageTitle('showMyBookmarks');
	
	// Set if user can edit article
	$edit = 0;
	if( $is_support ) {
		$edit = 1;
	}

	// Get knowledge base articles
	$database->setQuery( "SELECT DISTINCT(k.id), k.kbcode as code, k.kbtitle as title, k.views, k.id_user, k.date_created, k.date_updated, b.id AS id_bookmark FROM #__support_category as c, #__support_kb as k, #__support_kb_category as kc, #__support_bookmark as b WHERE b.id_user='".$user->id."' AND b.source='K' AND k.id=b.id_bookmark AND c.`show`='1' AND c.id_workgroup='".$id_workgroup."' AND c.id=kc.id_category AND kc.id_kb=k.id AND k.publish='1' ORDER BY k.date_updated DESC" );
	$articles = $database->loadObjectList();
	
	$i = 1;
	foreach( $articles as $key2 => $value2 )
	{
		if( is_object($value2) ) {
			foreach( $value2 as $key3 => $value3 )
			{
				$articles_rows[$i][$key3] = $value3;
				
				if( $key3 == 'id' ) {
					$articles_rows[$i]['link']            = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_view&id='.$value3;
					$articles_rows[$i]['link_edit']       = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=kb_edit&id='.$value3;
					$articles_rows[$i]['workgroup']       = getWorkgroup($id_workgroup);
					$articles_rows[$i]['rate_image']      = (getRate($value3, 'T', 0)?getRate($value3, 'T', 1): JText::_('unrated'));
					$articles_rows[$i]['rate']            = (getRate($value3, 'T', 0)?getRate($value3, 'T', 0): JText::_('unrated'));
				}

				if( $key3 == 'id_user' ) {
					$articles_rows[$i]['author'] = getUser($value3);
				}
				
				if( $key3 == 'id_bookmark' ) {
					$articles_rows[$i]['delete_bookmark'] = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=my_delbookmark&id='.$value3;
				}
			}
		}

		$i++;
	}
	
	// Get tickets
	$database->setQuery( "SELECT t.id as dbid, t.ticketmask as ticketid, t.subject, t.id_status, t.assign_to, t.id_priority, t.date, t.duedate, t.id_user, t.last_update, t.id_workgroup, b.id AS id_bookmark FROM #__support_ticket as t, #__support_bookmark as b WHERE b.id_user='".$user->id."' AND b.source='T' AND t.id=b.id_bookmark AND t.id_workgroup='".$id_workgroup."'  ORDER BY t.duedate DESC" );
	$tickets = $database->loadObjectList();
	
	$i = 1;
	foreach( $tickets as $key2 => $value2 )
	{
		$duedate = '';
		$priority = '';
		$status = '';
		$assign = '';

		if( is_object($value2) ) {
			foreach( $value2 as $key3 => $value3 )
			{
				$tickets_rows[$i][$key3] = $value3;
				
				if( $key3 == 'dbid' ) {
					$tickets_rows[$i]['messages'] = getMessages($value3);
					$tickets_rows[$i]['link']      = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=ticket_view&id='.$value3;
				}

				if( $key3 == 'id_status' ) {
					$status = $value3;
					$tickets_rows[$i]['status'] = getStatus($value3);
				}

				if( $key3 == 'assign_to' )
					$assign = $value3;
					$tickets_rows[$i]['assigned'] = getUser($value3);

				if( $key3 == 'id_user' )
					$tickets_rows[$i]['user'] = getUser($value3);

				if( $key3 == 'id_priority' )
					$priority = $value3;
					$tickets_rows[$i]['priority'] = getPriority($value3);

				if( $key3 == 'id_user' )
					$tickets_rows[$i]['client'] = getClient($value3);

				if( $key3 == 'date' )
					$tickets_rows[$i]['date_created'] = date($supportConfig->date_short,strtotime($value3));

				if( $key3 == 'last_update' )
					$tickets_rows[$i]['date_updated'] = date($supportConfig->date_short,strtotime($value3));
				
				if( $key3 == 'duedate' ) {
					$duedate = $value3;
					$tickets_rows[$i]['elapsed_time'] = elapsedTime( substr($value3, 0, 4), substr($value3, 5, 2), substr($value3, 8, 2), substr($value3, 11, 2), substr($value3, 14, 2), dateOffset("Y"), dateOffset("m"), dateOffset("d"), dateOffset("H"), dateOffset("i") );
				}

				if( $key3 == 'id_bookmark' )
					$tickets_rows[$i]['delete_bookmark'] = 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=my_delbookmark&id='.$value3;
			}
		}

		$tickets_rows[$i]['icon_duedate']    = isDueDateValid( $duedate, $priority, $status, 0, $assign, 0 );
		$tickets_rows[$i]['icontxt_duedate'] = isDueDateValid( $duedate, $priority, $status, 0, $assign, 1 );
		
		$i++;
	}

	include( JPATH_SITE.'/components/com_maqmahelpdesk/templates/'.$workgroupSettings->theme.'/general/bookmarks.php' );
}

function delBookmark( $id ) 
{
	$mainframe = JFactory::getApplication();
	$database = JFactory::getDBO();
	$user	= JFactory::getUser();
	$Itemid	= JRequest::getVar( 'Itemid', 0, '', 'int' );
	$id_workgroup = JRequest::getVar( 'id_workgroup', 0, '', 'int' );
	
	$database->setQuery( "DELETE FROM #__support_bookmark WHERE id='".$id."'" );
	$database->query();
	$msg = JText::_('item_removed_from_bookmarks');
	
	$mainframe->redirect( 'index.php?option=com_maqmahelpdesk&Itemid='.$Itemid.'&id_workgroup='.$id_workgroup.'&task=my_bookmark&msg='.$msg );
}
