<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: maqmahelpdesk.class.php 342 2012-01-23 15:13:41Z pdaniel $
 * $LastChangedDate: 2012-01-23 15:13:41 +0000 (seg, 23 Jan 2012) $
 *
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );


class mosSupportHolidays extends JTable {
	var $id=null;
	var $holiday_date='0000-00-00';
	var $name=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_holidays', 'id', $_db );
	}
}

class mosSupportSchedule extends JTable {
	var $id=null;
	var $profile=null;
	var $description=null;
	var $work_on_holidays=0;

	function __construct( &$_db ) {
		parent::__construct( '#__support_schedule', 'id', $_db );
	}
}

class mosSupportScheduleWeekday extends JTable {
	var $id=null;
	var $id_schedule=null;
	var $weekday=null;
	var $work_start='00:00:00';
	var $work_end='00:00:00';
	var $break_start='00:00:00';
	var $break_end='00:00:00';

	function __construct( &$_db ) {
		parent::__construct( '#__support_schedule_weekday', 'id', $_db );
	}
}

/**
* #__support_config table
* @package SupportCenter
*/
//class mosSupportConfig extends JTable {
class mosSupportConfig extends JTable {
	var $id=null;
	var $update_version=null;
	var $support_version=null;
	var $field_width=null;
	var $mail_assign=null;
	var $docspath=null;
	var $extensions=null;
	var $maxAllowed=null;
	var $public_attach=null;
	var $attachs_num=null;
	var $receive_mail=null;
	var $ac_active=null;
	var $ac_days=null;
	var $rating=null;
	var $kb_popinfo=0;
	var $kb_rating=null;
	var $notify_rate=0;
	var $less_rate=2;
	var $unregister=0;
	var $date_short=null;
	var $date_long=null;
	var $week_start=1;
	var $kb_moderate=0;
	var $faq_kb_hits=0;
	var $faq_kb_nhits=100;
	var $faq_kb_manual=0;
	var $readmail_create_user=0;
	var $license_agreement=0;
	var $company_info=0;
	var $create_client=0;
	var $rf_phone=0;
	var $rf_fax=0;
	var $rf_mobile=0;
	var $rf_address1=0;
	var $rf_address2=0;
	var $rf_zipcode=0;
	var $rf_location=0;
	var $rf_country=0;
	var $rf_city=0;
	var $users_registration=0;
	var $default_source=null;
	var $rss=0;
	var $minutes=15;
	var $users_login=0;
	var $use_uncategorized=0;
	var $client_change_status=0;
	var $support_change_status=0;
	var $register_user_change_status=0;
	var $support_only_show_assign=0;
	var $support_workgroup_only=0;
	var $duedate_algoritm=0;
	var $duedate_holidays=0;
	var $duedate_vacations=0;
	var $duedate_firstday=0;
	var $duedate_schedule=0;
	var $duedate_firstday_minimum=0;
	var $duedate_hoursday=8;
	var $id_schedule_default=0;
	var $mail_queue=0;
	var $extra_email_notification=0;
	var $show_dashboard_support = 0;
	var $show_dashboard_customer = 0;
	var $anonymous_tickets = 0;
    var $post_comments_in_wall = 0;
    var $use_jomsocial_avatars = 0;
    var $post_kb_creation_in_wall = 0;
    var $google_adwords = null;
    var $integrate_mtree = 0;
    var $integrate_sobi = 0;
    var $discussions_moderated = 0;
    var $integrate_artofuser = 0;
    var $use_cb_avatars = 0;
    var $mobile_interface = 0;
    var $offset = 0;
    var $js_post_question_wall = 0;
    var $js_post_answer_wall = 0;
    var $js_post_votes_wall = 0;
    var $js_answer_selected_wall = 0;
    var $profile_required = 0;
    var $stopspam = 0;
    var $hide_powered = 0;
    var $common_ticket_views = 0;
    var $currency = '&euro;';
    var $use_merge = 1;
    var $use_as_reply = 1;
    var $use_parent = 1;
    var $use_travel = 1;
    var $use_type = 1;
    var $integrate_jbolo = 0;
    var $integrate_digistore = 0;
    var $growl_notifications = 0;
    var $kb_approvement = 0;
	
	/**
	* @param database A database connector object
	*/
	//function mosSupportConfig( &$_db ) {
	function __construct( &$_db ) {
		parent::__construct( '#__support_config', 'id', $_db);
	}
}

/**
* #__support_workgroup table
* @package SupportCenter
*/
class mosSupportWK extends JTable {
	var $id=null;
	var $wkdesc=null;
	var $logo=null;
	var $wkabout=null;
	var $wkkb=0;
	var $wkemail=0;
	var $wkticket=0;
	var $show=0;
	var $wkmail_address=null;
	var $wkmail_address_name=null;
	var $wkadmin_email=null;
	var $auto_assign=0;
	var $trouble=0;
	var $contract=0;
	var $ordering=null;
	var $use_activity=0;
	var $lim_actmsgs=0;
	var $lim_actmsgs_chars=300;
	var $lim_actmsgs_lines=10;
	var $lim_actwords=0;
	var $lim_actwords_chars=0;
	var $hyper_links=0;
	var $theme='default';
	var $tkt_crt_nfy_mgr=0;
	var $tkt_crt_nfy_admin=0;
	var $tkt_asgn_old_asgn=0;
	var $tkt_asgn_new_asgn=0;
	var $tkt_asgn_nfy_usr_one=0;
	var $wkfaq=0;
	var $wkdownloads=0;
	var $wkglossary=0;
	var $wkannounces=0;
	var $id_priority=0;
	var $enable_discussions=0;
	var $contract_total_disable=0;
    var $use_account = 1;
    var $use_bookmarks = 1;
    var $add_mail_tag = 1;
    var $digistore = 0;
    var $shortdesc = null;
	var $slug=null;
	
	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_workgroup', 'id', $_db );
	}
}

/**
* #__support_custom_field table
* @package SupportCenter
*/
class mosSupportCField extends JTable {
	var $id=null;
	var $caption=null;
	var $ftype=null;
	var $value=null;
	var $size=null;
	var $maxlength=null;
	var $cftype=null;
	var $tooltip=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_custom_fields', 'id', $_db );
	}
}

/**
* #__support_category table
* @package SupportCenter
*/
class mosSupportCategory extends JTable {
	var $id=null;
	var $name=null;
	var $show=1;
	var $id_workgroup=0;
	var $parent=0;
	var $kb=0;
	var $tickets=0;
	var $downloads=0;
	var $discussions=0;
	var $bugtracker=0;
	var $level=1;
	var $slug=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_category', 'id', $_db );
	}
}

/**
* #__support_license table
* @package SupportCenter
*/
class mosSupportLicense extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $clientid=null;
	/** @var string */
	var $company=null;
	/** @var string */
	var $person=null;
	/** @var string */
	var $email=null;
	/** @var string */
	var $domains=null;
	/** @var string */
	var $ipaddress=null;
	/** @var string */
	var $license=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_license', 'id', $_db );
	}
}

/**
* #__support_priority table
* @package SupportCenter
*/
class mosSupportPriority extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $description=null;
	/** @var tinyint */
	var $show=1;
	/** @var int */
	var $timevalue=0;
	/** @var timeunit */
	var $timeunit=null;
	/** @var tinyint */
	var $isdefault=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_priority', 'id', $_db );
	}
}

/**
* #__support_status table
* @package SupportCenter
*/
class mosSupportStatus extends JTable {
	var $id=null;
	var $description=null;
	var $show=1;
	var $status_group=null;
	var $isdefault=0;
	var $user_access=1;
	var $status_workflow=null;
	var $allow_old_status_back=1;
	var $ticket_side = 0;
	var $isdefault_manager=0;
    var $auto_status_agents = 0;
    var $auto_status_users = 0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_status', 'id', $_db );
	}
}

class mosSupportWKFields extends JTable {
	var $id=null;
	var $id_workgroup=null;
	var $id_field=null;
	var $required=0;
	var $support_only=0;
	var $ordering=0;
	var $new_only=0;
	var $section=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_wk_fields', 'id', $_db );
	}
}

class mosSupportContractFields extends JTable {
	var $id=null;
	var $id_field=null;
	var $ordering=0;
	var $required=0;
	
	function __construct( &$_db ) {
		parent::__construct( '#__support_contract_fields', 'id', $_db );
	}
}

class mosSupportPermission extends JTable {
	var $id=null;
	var $id_user=null;
	var $id_workgroup=null;
	var $manager=0;
	var $id_schedule=0;
	var $vacances=null;
	var $assign_report_users=null;
	var $can_delete=0;
	var $level=0;
	
	function __construct( &$_db ) {
		parent::__construct( '#__support_permission', 'id', $_db );
	}
}

class mosSupportTicket extends JTable {
	var $id=null;
	var $id_workgroup=null;
	var $id_status=null;
	var $id_user=null;
	var $id_client=null;
	var $id_category=null;
	var $date=null;
	var $subject=null;
	var $message=null;
	var $last_update=null;
	var $assign_to=0;
	var $id_priority=null;
	var $id_kb=null;
	var $source=null;
	var $ticketmask=null;
	var $an_name=null;
	var $an_mail=null;
	var $duedate=null;
	var $id_export=0;
	var $ipaddress=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_ticket', 'id', $_db );
	}
}

class mosSupportMailLog extends JTable {
	var $id=null;
	var $id_mail_fetch=null;
	var $date=null;
	var $email=null;
	var $log=null;
	var $emailid=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_mail_log', 'id', $_db );
	}
}

class mosSupportMailFetch extends JTable {
	var $id=null;
	var $id_workgroup=null;
	var $email=null;
	var $server=null;
	var $username=null;
	var $password=null;
	var $type=null;
	var $port=null;
	var $remove=1;
	var $extra_info=null;
	var $queue=0;
	var $id_status=0;
	var $id_category=0;
	var $label='INBOX';
	var $notls=0;
	var $thrash='THRASH';
	var $ssl=0;
	var $published=1;

	function __construct( &$_db ) {
		parent::__construct( '#__support_mail_fetch', 'id', $_db );
	}
}

/**
* #__support_task table
* @package SupportCenter
*/
class mosSupportTask extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_ticket=0;
	/** @var int */
	var $id_creator=0;
	/** @var int */
	var $id_user=0;
	/** @var date */
	var $date_time=null;
	/** @var string */
	var $task=null;
	/** @var string */
	var $status=null;
	/** @var double */
	var $timeused=0;
	/** @var tinyint */
	var $travel=1;
	/** @var double */
	var $traveltime=0;
	/** @var int */
	var $rate=0;
	/** @var int */
	var $id_activity_rate=0;
	/** @var int */
	var $id_activity_type=0;
	/** @var string */
	var $start_time=null;
	/** @var string */
	var $end_time=null;	
	/** @var string */
	var $break_time=null;
	/** @var date */
	var $end_date=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_task', 'id', $_db );
	}
}

/**
* #__support_custom_field table
* @package SupportCenter
*/
class mosSupportTroubleshooter extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var id */
	var $parent=0;
	/** @var string */
	var $title=null;
	/** @var string */
	var $description=null;
	/** @var tinyint */
	var $show=1;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_troubleshooter', 'id', $_db );
	}
}

/**
* #__support_contract_template table
* @package SupportCenter
*/
class mosSupportContractTemplate extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_priority=0;
	/** @var string */
	var $name=null;
	/** @var string */
	var $description=null;
	/** @var enum */
	var $unit=null;
	/** @var int */
	var $val=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_contract_template', 'id', $_db );
	}
}

/**
* #__support_kb table
* @package SupportCenter
*/
class mosSupportKB extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $kbcode=null;
	/** @var int */
	var $id_user=null;
	/** @var string */
	var $content=null;
	/** @var string */
	var $keywords=null;
	/** @var tinyint */
	var $publish=1;
	/** @var int */
	var $views=0;
	/** @var string */
	var $kbtitle=null;
	/** @var date */
	var $date_created=null;
	/** @var date */
	var $date_updated=null;
	/** @var tinyint */
	var $anonymous_access=0;
	/** @var tinyint */
	var $faq=0;
	var $approved=1;
	var $slug=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_kb', 'id', $_db );
	}
}

/**
* #__support_client table
* @package SupportCenter
*/
class mosSupportClient extends JTable {
	var $id=null;
	var $date_created=null;
	var $clientname=null;
	var $address=null;
	var $zipcode=null;
	var $city=null;
	var $state=null;
	var $country=null;
	var $phone=null;
	var $fax=null;
	var $mobile=null;
	var $email=null;
	var $contactname=null;
	var $website=null;
	var $description=null;
	var $client_mail_notify=null;
	var $travel_time=0;
	var $rate=0.00;
	var $manager=0;
	var $block=0;
	var $logo=null;
	var $clientid=null;
	var $taxnumber=null;
	var $approval=null;
	var $slug=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_client', 'id', $_db );
	}
}

/**
* #__support_client table
* @package SupportCenter
*/
class mosSupportClientUser extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_client=0;
	/** @var int */
	var $id_user=0;
	/** @var int */
	var $manager=0;
	/** @var int */
	var $default=0;
	/** @var int */
	var $create_ticket=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_client_users', 'id', $_db );
	}
}

/**
* #__support_contract table
* @package SupportCenter
*/
class mosSupportClientContract extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_contract=0;
	/** @var int */
	var $id_client=0;
	/** @var string */
	var $contract_number=0;
	/** @var date */
	var $creation_date=null;
	/** @var date */
	var $date_start=null;
	/** @var date */
	var $date_end=null;
	/** @var enum */
	var $unit=null;
	/** @var int */
	var $value=0;
	/** @var int */
	var $actual_value=0;
	/** @var enum */
	var $status=null;
	/** @var string */
	var $remarks=null;
	/** @var int */
	var $id_user=0;
	/** @var decimal */
	var $overdue=0;
	/** @var date */
	var $overdue_update=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_contract', 'id', $_db );
	}
}

/**
* #__support_contract table
* @package SupportCenter
*/
class mosSupportClientInfo extends JTable {
	var $id=null;
	var $id_client=0;
	var $date=null;
	var $subject=null;
	var $message=null;
	var $published=1;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_client_info', 'id', $_db );
	}
}

/**
* #__support_glossary table
* @package SupportCenter
*/
class mosSupportGlossary extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $term=null;
	/** @var string */
	var $description=null;
	/** @var int */
	var $published=0;
	/** @var tinyint */
	var $anonymous_access=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_glossary', 'id', $_db );
	}
}

/**
* #__support_activity_rate table
* @package SupportCenter
*/
class mosSupportRates extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $description=null;
	/** @var double */
	var $multiplier=1.0;
	/** @var tinyint */
	var $isdefault=0;
	/** @var tinyint */
	var $published=1;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_activity_rate', 'id', $_db );
	}
}

/**
* #__support_activity_type table
* @package SupportCenter
*/
class mosSupportTypes extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $description=null;
	/** @var tinyint */
	var $isdefault=0;
	/** @var tinyint */
	var $published=1;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_activity_type', 'id', $_db );
	}
}

/**
* #__support_export_profile table
* @package SupportCenter
*/
class mosSupportExport extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $name=null;
	/** @var string */
	var $description=null;
	/** @var tinyint */
	var $isdefault=0;
	/** @var largetext */
	var $export_tmpl=null;
	/** @var tinyint */
	var $billableonly=0;
	/** @var varchar */
	var $export_type=null;
	/** @var tinyint */
	var $auto_save=1;
	/** @var varchar */
	var $filter_statusid=0;
	/** @var varchar */
	var $filter_wkid=0;
	/** @var varchar */
	var $filter_clientid=0;
	/** @var varchar */
	var $filter_userid=0;
	/** @var tinyint */
	var $update_exported=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_export_profile', 'id', $_db );
	}
}

/**
* #__support_announce table
* @package SupportCenter
*/
class mosSupportAnnounce extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_workgroup=0;
	/** @var int */
	var $id_client=0;
	/** @var date */
	var $date=null;
	/** @var string */
	var $introtext=null;
	/** @var string */
	var $bodytext=null;
	/** @var tinyint */
	var $frontpage=0;
	/** @var tinyint */
	var $urgent=0;
	/** @var tinyint */
	var $sent=0;
	var $slug=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_announce', 'id', $_db );
	}
}

/**
* #__support_component table
* @package SupportCenter
*/
class mosSupportComponent extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $name=null;
	/** @var string */
	var $description=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_components', 'id', $_db );
	}
}

/**
* #__support_reply table
* @package SupportCenter
*/
class mosSupportReply extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $subject=null;
	/** @var string */
	var $answer=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_reply', 'id', $_db );
	}
}

/**
* #__support_reports table
* @package SupportCenter
*/
class mosSupportReports extends JTable {
	var $id=null;
	var $title=null;
	var $description=null;
	var $f_workgroup=0;
	var $f_category=0;
	var $f_client=0;
	var $f_user=0;
	var $f_year=null;
	var $f_month=null;
	var $f_priority=0;
	var $f_status=0;
	var $f_source=null;
	var $f_staff=0;
	var $groupby=null;
	var $report_type=null;
	var $chart_type=null;
	var $sf_workgroup=0;
	var $sf_category=0;
	var $sf_client=0;
	var $sf_user=0;
	var $sf_year=0;
	var $sf_month=0;
	var $sf_priority=0;
	var $sf_status=0;
	var $sf_source=0;
	var $sf_staff=0;
	var $chart_width=300;
	var $chart_height=300;
	var $layout=1;
	var $type=1;
	var $chart_percentage=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_reports', 'id', $_db );
	}
}

class mosDownloadCategory extends JTable
{
	var $id				= null;
	var $cname			= "";
	var $description	= "";
	var $ordering		= 0;
	var $published		= 1;
	var $parent 		= 0;
	var $image			= null;
	var $level			= 1;
	var $slug=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_dl_category', 'id', $_db );
	}
}


class mosDownload extends JTable
{
	var $id				  = null;
	var $id_category	  = "";
	var $pname			  = "";
	var $description	  = "";
	var $url			  = "";
	var $ordering		  = 0;
	var $published		  = 1;
	var $plataform        = "";
	var $date			  = "";
	var $hits			  = 0;
	var $id_license		  = 0;
	var $groupid		  = "";
	var $features		  = "";
	var $requirements	  = "";
	var $limitations	  = "";
	var $expired		  = "";
	var $updated		  = "";
	var $offline		  = 0;
	var $image   		  = "";
	var $evaluation		  = "";
	var $download_version = 0;
	var $download_previous = 0;
	var $template_file    = "";
	var $registered_only  = 0;
	var $image_view = "";
	var $slug=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_dl', 'id', $_db );
	}
}

class mosDownloadVersion extends JTable
{
	var $id				= null;
	var $id_download	= 0;
	var $version		= "";
	var $date			= "";
	var $description	= "";
	var $filename 		= "";
	var $filename_original = null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_dl_version', 'id', $_db );
	}
}

class mosDownloadGroup extends JTable
{
	var $id				= 0;
	var $gname 			= "";
	var $description	= "";
	var $unregister		= 0;
	var $isdefault		= 0;

	function __construct( &$_db ) {
		parent::__construct( '#__support_dl_group', 'id', $_db );
	}
}

class mosDownloadAccess extends JTable
{
	var $id				= 0;
	var $id_download 	= 0;
	var $id_user		= 0;
	var $isactive	    = 0;
	var $serialno	    = null;
	var $servicefrom	= null;
	var $serviceuntil	= null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_dl_access', 'id', $_db );
	}
}

class mosSupportLicenses extends JTable {
	var $id=null;
	var $title=null;
	var $description=null;
	var $slug=null;

	function __construct( &$_db ) {
		parent::__construct( '#__support_dl_license', 'id', $_db );
	}
}

/**
* #__support_form table
* @package SupportCenter
*/
class mosSupportForm extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var string */
	var $name=null;
	/** @var string */
	var $description=null;
	/** @var string */
	var $redirect=null;
	/** @var string */
	var $layout=null;
	/** @var tinyint */
	var $show=1;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_form', 'id', $_db );
	}
}

/**
* #__support_form_action table
* @package SupportCenter
*/
class mosSupportFormActions extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_form=null;
	/** @var string */
	var $type='email';
	/** @var string */
	var $value=null;
	/** @var tinyint */
	var $published=1;
	/** @var string */
	var $layout=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_form_action', 'id', $_db );
	}
}

/**
* #__support_form_field table
* @package SupportCenter
*/
class mosSupportFormFields extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_form=null;
	/** @var string */
	var $caption=null;
	/** @var string */
	var $type=null;
	/** @var string */
	var $value=null;
	/** @var int */
	var $order=0;
	/** @var int */
	var $size=0;
	/** @var int */
	var $maxlength=0;
	/** @var tinyint */
	var $required=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_form_field', 'id', $_db );
	}
}

/**
* #__support_user_fields table
* @package SupportCenter
*/
class mosSupportUserFields extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_field=null;
	/** @var tinyint */
	var $required=0;
	/** @var int */
	var $ordering=0;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_user_fields', 'id', $_db );
	}
}

class mosUsers extends JTable {
	/** @var int Unique id*/
	var $id				= null;
	/** @var string The users real name (or nickname)*/
	var $name			= null;
	/** @var string The login name*/
	var $username		= null;
	/** @var string email*/
	var $email			= null;
	/** @var string MD5 encrypted password*/
	var $password		= null;
	/** @var string */
	var $usertype		= null;
	/** @var int */
	var $block			= null;
	/** @var int */
	var $sendEmail		= null;
	/** @var int The group id number */
	var $gid			= null;
	/** @var datetime */
	var $registerDate	= null;
	/** @var datetime */
	var $lastvisitDate	= null;
	/** @var string activation hash*/
	var $activation		= null;
	/** @var string */
	var $params			= null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__users', 'id', $_db );
	}

	/**
	 * Validation and filtering
	 * @return boolean True is satisfactory
	 */
	function check() {
		global $mosConfig_uniquemail;

		// Validate user information
		if (trim( $this->name ) == '') {
			// TODO: vai originar erro, estas constantes j� n�o existem em Joomla 1.5.x
			$this->_error = _REGWARN_NAME;
			return false;
		}

		if (trim( $this->username ) == '') {
			// TODO: vai originar erro, estas constantes j� n�o existem em Joomla 1.5.x
			$this->_error = _REGWARN_UNAME;
			return false;
		}

		// check that username is not greater than 25 characters
		$username = $this->username;
		if ( strlen($username) > 25 ) {
			$this->username = substr( $username, 0, 25 ); 
		}
		
		// check that password is not greater than 50 characters
		$password = $this->password;
		if ( strlen($password) > 50 ) {
			$this->password = substr( $password, 0, 50 ); 
		}
		
		if (eregi( "[\<|\>|\"|\'|\%|\;|\(|\)|\&|\+|\-]", $this->username) || strlen( $this->username ) < 3) {
			// TODO: vai originar erro, estas constantes j� n�o existem em Joomla 1.5.x
			$this->_error = sprintf( _VALID_AZ09, _PROMPT_UNAME, 2 );
			return false;
		}

		if ((trim($this->email == "")) || (preg_match("/[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}/", $this->email )==false)) {
			// TODO: vai originar erro, estas constantes j� n�o existem em Joomla 1.5.x
			$this->_error = _REGWARN_MAIL;
			return false;
		}

		// check for existing username
		$query = "SELECT id"
		. "\n FROM #__users "
		. "\n WHERE username = '$this->username'"
		. "\n AND id != " . (int)$this->id
		;
		$this->_db->setQuery( $query );
		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			// TODO: vai originar erro, estas constantes j� n�o existem em Joomla 1.5.x
			$this->_error = _REGWARN_INUSE;
			return false;
		}

		if ($mosConfig_uniquemail) {
			// check for existing email
			$query = "SELECT id"
			. "\n FROM #__users "
			. "\n WHERE email = '$this->email'"
			. "\n AND id != " . (int)$this->id
			;
			$this->_db->setQuery( $query );
			$xid = intval( $this->_db->loadResult() );
			if ($xid && $xid != intval( $this->id )) {
				// TODO: vai originar erro, estas constantes j� n�o existem em Joomla 1.5.x
				$this->_error = _REGWARN_EMAIL_INUSE;
				return false;
			}
		}

		return true;
	}

	function store( $updateNulls=false ) {
		global $acl, $migrate;
		$section_value = 'users';

		$k = $this->_tbl_key;
		$key =  $this->$k;
		if( $key && !$migrate) {
			// existing record
			$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );
			// syncronise ACL

			// single group handled at the moment
			// trivial to expand to multiple groups
			$groups = $acl->get_object_groups( $section_value, $this->$k, 'ARO' );
			$acl->del_group_object( $groups[0], $section_value, $this->$k, 'ARO' );
			$acl->add_group_object( $this->gid, $section_value, $this->$k, 'ARO' );

			$object_id = $acl->get_object_id( $section_value, $this->$k, 'ARO' );
			$acl->edit_object( $object_id, $section_value, $this->_db->getEscaped( $this->name ), $this->$k, 0, 0, 'ARO' );
		} else {
			// new record
			$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );
			// syncronise ACL
			$acl->add_object( $section_value, $this->_db->getEscaped( $this->name ), $this->$k, null, null, 'ARO' );
			$acl->add_group_object( $this->gid, $section_value, $this->$k, 'ARO' );
		}
		if( !$ret ) {
			$this->_error = strtolower(get_class( $this ))."::store failed <br />" . $this->_db->getErrorMsg();
			return false;
		} else {
			return true;
		}
	}

	function delete( $oid=null ) {
		global $acl;

		$k = $this->_tbl_key;
		if ($oid) {
			$this->$k = intval( $oid );
		}
		$aro_id = $acl->get_object_id( 'users', $this->$k, 'ARO' );
//		$acl->del_object( $aro_id, 'ARO', true );

		$query = "DELETE FROM $this->_tbl"
		. "\n WHERE $this->_tbl_key = '". $this->$k ."'"
		;
		$this->_db->setQuery( $query );

		if ($this->_db->query()) {
			// cleanup related data

			// :: private messaging
			$query = "DELETE FROM #__messages_cfg"
			. "\n WHERE user_id = ". $this->$k .""
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->_error = $this->_db->getErrorMsg();
				return false;
			}
			$query = "DELETE FROM #__messages"
			. "\n WHERE user_id_to = ". $this->$k .""
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->_error = $this->_db->getErrorMsg();
				return false;
			}

			return true;
		} else {
			$this->_error = $this->_db->getErrorMsg();
			return false;
		}
	}

	/**
	 * Gets the users from a group
	 * @param string The value for the group (not used 1.0)
	 * @param string The name for the group
	 * @param string If RECURSE, will drill into child groups
	 * @param string Ordering for the list
	 * @return array
	 */
	function getUserListFromGroup( $value, $name, $recurse='NO_RECURSE', $order='name' ) {
		global $acl;

		// Change back in
		//$group_id = $acl->get_group_id( $value, $name, $group_type = 'ARO');
		$group_id = $acl->get_group_id( $name, $group_type = 'ARO');
		$objects = $acl->get_group_objects( $group_id, 'ARO', 'RECURSE');

		if (isset( $objects['users'] )) {
			$gWhere = '(id =' . implode( ' OR id =', $objects['users'] ) . ')';

			$query = "SELECT id AS value, name AS text"
			. "\n FROM #__users"
			. "\n WHERE block = '0'"
			. "\n AND " . $gWhere
			. "\n ORDER BY ". $order
			;
			$this->_db->setQuery( $query );
			$options = $this->_db->loadObjectList();
			return $options;
		} else {
			return array();
		}
	}
}

/**
* #__support_links table
* @package SupportCenter
*/
class mosSupportLinks extends JTable {
	/** @var int Primary key */
	var $id=null;
	/** @var int */
	var $id_workgroup=null;
	/** @var string */
	var $name=null;
	/** @var string */
	var $description=null;
	/** @var string */
	var $image=null;
	/** @var string */
	var $link=null;
	/** @var tinyint */
	var $public=1;
	/** @var tinyint */
	var $published=null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$_db ) {
		parent::__construct( '#__support_links', 'id', $_db );
	}
}
?>
