<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: kb.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$id = JRequest::getVar( 'id', 0, '', 'int' );

// Get Support Center Configuration
$supportConfig = null;
$database->setQuery( "SELECT * FROM #__support_config WHERE id='1'" );
$supportConfig = $database->loadObject();

// Get article
$database->setQuery( "SELECT k.id, k.kbcode, k.kbtitle, k.content, k.keywords, k.views, k.date_created, k.date_updated, u.name FROM #__support_kb as k, #__users as u WHERE u.id=k.id_user AND k.publish='1' AND k.id='".$id."'" );
$article = null;
$article = $database->loadObject();

// Get article attachments
$database->setQuery( "SELECT filename, description FROM #__support_file WHERE id='".$article->id."' AND source='K' AND public='1'" );
$attachs = $database->loadObjectList();

// Get article comments
$database->setQuery( "SELECT c.`date`, u.name, c.comment FROM #__support_kb_comment as c, #__users as u WHERE u.id=c.id_user AND c.id_kb='".$article->id."'" );
$comments = $database->loadObjectList();

$pdf=new PDF();
$font1 = "Helvetica";
$font2 = "Arial";

$pdf->SetLeftMargin(10);
$pdf->SetFont($font2,'',10);

$pdf->SetFillColor(240,240,240);
$lineheight = 8;
// Article Page
$pdf->AddPage();
$pdf->SetFont($font2,'B',10);
$pdf->Cell(40,6,prepare_txt(JText::_('code')).':','LRBT',0,'L',1);
$pdf->SetFont($font2,'',10);
$pdf->Cell(40,6,$article->kbcode);
//$pdf->Ln($lineheight);
$pdf->SetFont($font2,'B',10);
$pdf->Cell(40,6,prepare_txt(JText::_('author')).':','LRBT',0,'L',1);
$pdf->SetFont($font2,'',10);
$pdf->Cell(90,6,($article->name));
$pdf->Ln($lineheight);

$pdf->SetFont($font2,'B',10);
$pdf->Cell(40,6,prepare_txt(JText::_('created_date')).':','LRBT',0,'L',1);
$pdf->SetFont($font2,'',10);
$pdf->Cell(40,6,$article->date_created);
//$pdf->Ln($lineheight);
$pdf->SetFont($font2,'B',10);
$pdf->Cell(40,6,prepare_txt(JText::_('last_update')).':','LRBT',0,'L',1);
$pdf->SetFont($font2,'',10);
$pdf->Cell(40,6,$article->date_updated);
$pdf->Ln($lineheight);

$pdf->SetFont($font2,'B',10);
$pdf->Cell(40,6,prepare_txt(JText::_('rating')).':','LRBT',0,'L',1);
$pdf->SetFont($font2,'',10);
$pdf->Cell(40,6,'');
$pdf->Image('components/com_maqmahelpdesk/images/rating/'.getRate($article->id, 'K', 2).'star_pdf.png', 52, 54);
//$pdf->Ln($lineheight);
$pdf->SetFont($font2,'B',10);
$pdf->Cell(40,6,prepare_txt(JText::_('votes')).':','LRBT',0,'L',1);
$pdf->SetFont($font2,'',10);
$pdf->Cell(60,6,getVotes($article->id, 'K'));

$lineheight = 10;
$pdf->Ln($lineheight);
$pdf->SetFont($font2,'B',10);
$pdf->Cell(190,10,prepare_txt(JText::_('content')).':','LRBT',0,'L',1);
$pdf->Ln();
$pdf->SetFont($font2,'',10);
$pdf->MultiCell(190, 6, strip_tags(utf8_decode($article->content)), 0, 'L');
$pdf->Ln($lineheight);

// Attachments Page
if( count($attachs) > 0 ) {
	$pdf->AddPage();
	//Colors, line width and bold font
	$pdf->SetFillColor(0,80,180);
	$pdf->SetTextColor(250,250,250);
	$pdf->SetDrawColor(0,0,0);
	$pdf->SetLineWidth(.3);
	$pdf->SetFont('','B',10);
	
	$pdf->Cell(40,7,prepare_txt(JText::_('filename')),1,0,'C',1);
	$pdf->Cell(150,7,prepare_txt(JText::_('description')),1,0,'C',1);
	$pdf->Ln();
	
	$pdf->SetFillColor(224,235,255);
	$pdf->SetTextColor(0);
	$pdf->SetFont('');
	
	$fill=0;
	for($i=0; $i<count($attachs); $i++) {
		$attach = $attachs[$i];
		$pdf->Cell(40,6,$attach->filename,'LR',0,'L',$fill);
		//$pdf->Cell(150,6,$attach->description,'LR',0,'L',$fill);
		$pdf->MultiCell(150, 6, utf8_decode($attach->description), 0, 'J', $fill);
		$pdf->Ln();
		$fill=!$fill;
	}
}

// Comments Page
if( count($comments) > 0 ) {
	$pdf->AddPage();
	//Colors, line width and bold font
	$pdf->SetFillColor(0,80,180);
	$pdf->SetTextColor(254,254,254);
	$pdf->SetDrawColor(0,0,0);
	$pdf->SetLineWidth(.3);
	$pdf->SetFont('','B',10);
	
	$pdf->Cell(40,7,prepare_txt(JText::_('date')),1,0,'C',1);
	$pdf->Cell(40,7,prepare_txt(JText::_('user')),1,0,'C',1);
	$pdf->Cell(110,7,prepare_txt(JText::_('comment')),1,0,'C',1);
	$pdf->Ln();
	
	$pdf->SetFillColor(224,235,255);
	$pdf->SetTextColor(0);
	$pdf->SetFont('');
	
	$fill=0;
	for($i=0; $i<count($comments); $i++) {
		$comment = $comments[$i];
		$pdf->Cell(40,6,$comment->date,'LR',0,'L',$fill);
		$pdf->Cell(40,6,($comment->name),'LR',0,'L',$fill);
		$pdf->MultiCell(110, 6, utf8_decode($comment->comment), 0, 'L', $fill);
		//$pdf->Ln();
		$fill=!$fill;
	}
}

@ob_end_clean();
if(ob_get_contents()) {
	// debug				
	$what = ob_get_contents();
	die("<b>Registo de Erro</b>: O que se encontra na header:<br /> <hr /> ".htmlentities($what));
}

// clean the output buffer
$pdf->Output('kb_article.pdf','D');
ini_set('zlib.output_compression', $ob); 
