<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: reportclient.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$ob = @ini_get("zlib.output_compression") && extension_loaded("zlib");
@ob_end_clean();
@ini_set('zlib.output_compression', 'Off'); 

require_once ( JPATH_SITE . '/components/com_maqmahelpdesk/pdf/fpdf_extention.php' );

$year = JRequest::getVar( 'year', 0, 'GET', 'int' );
$month = JRequest::getVar( 'month', 0, 'GET', 'int' );
$id_workgroup = JRequest::getVar( 'id_workgroup', 0, 'GET', 'int' );
$id_client = JRequest::getVar( 'id_client', 0, 'GET', 'int' );
$f_status = JRequest::getVar( 'f_status', 0, 'GET', 'int' );
$custom_fields = JRequest::getVar( 'custom_fields', 0, 'GET', 'int' );
$detail = JRequest::getVar( 'detail', 0, 'GET', 'int' );
$f_customfields = JRequest::getVar( 'f_customfields', 1, 'GET', 'int' );
$report = JRequest::getVar( 'report', 'clientm', 'GET', 'string' );

$supportConfig = GetConfig();
$database = JFactory::getDBO();

$sql = "SELECT t.id, t.ticketmask, t.subject, t.date, t.last_update, u.name, sum(r.timeused) AS time_spent, count(r.id) as num_msg, s.description as status, c.name AS category, t.duedate, p.description AS priority  FROM #__support_ticket t INNER JOIN #__support_status s ON s.id=t.id_status LEFT JOIN #__support_ticket_resp r ON r.id_ticket=t.id LEFT JOIN #__support_category AS c ON c.id=t.id_category LEFT JOIN #__support_priority AS p ON p.id=t.id_priority INNER JOIN #__users u ON u.id=t.id_user WHERE YEAR(t.`date`)='".$year."' AND MONTH(t.`date`)='".$month."' ".($id_workgroup>0 ? "AND t.id_workgroup='".$id_workgroup."'" : "")." ".($id_client>0 ? "AND t.id_client='".$id_client."'" : "")." ".($f_status>0 ? "AND t.id_status='".$f_status."'" : "")."  GROUP BY t.id, t.ticketmask, t.subject, t.date, t.last_update, u.name, c.name , t.duedate, p.description ORDER BY t.`date`";
$database->setQuery( $sql );
$rows = $database->loadObjectList();

// Get workgroup name
if( $id_workgroup > 0 ) {
	$database->setQuery( "SELECT wkdesc FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
	$wk_desc = utf8_encode($database->loadResult());
}else{
	$wk_desc = JText::_('all_workgroups');
}

// Get clients name
if( $id_client > 0 ) {
	$database->setQuery( "SELECT clientname FROM #__support_client WHERE id='".$id_client."'" );
	$client_desc = $database->loadResult();
}else{
	$client_desc = JText::_('all_clients');
}

// get status id
if( $f_status > 0 ) {
	$sql = "SELECT `description` AS text FROM #__support_status WHERE id='".$f_status."'";
	$database->setQuery($sql);
	$status_desc = utf8_encode($database->loadResult());
} else {
	$status_desc = JText::_('all_status');
}

// Get custom fields
$sql = "SELECT `id`, `caption` FROM #__support_custom_fields WHERE cftype='W' ORDER BY `caption`";
$database->setQuery( $sql );
$custom_fields = $database->loadObjectList(); 
		
		
$pdf_orientation = "L"; 	// (L)andscape 	(P)ortrait
$pdf_unit = "mm";			// mm		pt		cm		in
$pdf_page_format = "A4";	// a3			a4		a5		letter		legal

$pdf=new PDF($pdf_orientation, $pdf_unit, $pdf_page_format);
$font1 = "Helvetica";

$pdf->AliasNbPages();
$pdf->SetFont($font1,'',10);


$colwidth=array(20,55,25,30,30,30,25,10,10);
$colheight = 8;

// Page 1 - Ticket Header
$pdf->AddPage();

if ($report == 'clientmdetail') {
	$pdf->Bookmark(JText::_('client_report_detail'));
} else {
	$pdf->Bookmark(JText::_('client_report_t'));
}
// $pdf->Bookmark(JText::_('status_report_detail'));
$pdf->SetFillColor(254);

# TITLE
$pagetitle = returnMonthDesc($month)." ".$year." / ".utf8_encode($wk_desc)." / ".utf8_encode($client_desc)." / ".utf8_encode($status_desc);
$pdf->SetFont($font1,'B',12);
$pdf->Cell(array_sum($colwidth),$colheight,$pagetitle,0,'C');
$pdf->Ln($colheight);


# TABLE HEADER
$pdf->SetFillColor(120);
$pdf->SetFont($font1,'B',9);
$pdf->Cell($colwidth[0],$colheight,JText::_('id'),'B',0,'C',1);
$pdf->Cell($colwidth[1],$colheight,JText::_('subject'),'B',0,'C',1);
$pdf->Cell($colwidth[2],$colheight,JText::_('user'),'B',0,'C',1);
if ($f_customfields == 1) 
{
	for( $i=0; $i<count($custom_fields); $i++ ) {
		$custom_field = $custom_fields[$i];
		$pdf->Cell($colwidth[3],$colheight,$custom_field->caption,'B',0,'C',1);
	}
} 
$pdf->Cell($colwidth[4],$colheight,JText::_('created_date'),'B',0,'C',1);
$pdf->Cell($colwidth[5],$colheight,JText::_('last_update'),'B',0,'C',1);
$pdf->Cell($colwidth[6],$colheight,JText::_('status'),'B',0,'C',1);
$pdf->Cell($colwidth[7],$colheight,JText::_('messages'),'B',0,'C',1);
$pdf->Cell($colwidth[8],$colheight,JText::_('time'),'B',0,'C',1);
$pdf->Ln($colheight);

# TABLE BODY	
if (count($rows) == 0) {
	$pdf->Cell(array_sum($colwidth),$colheight,JText::_('no_results'));
} else {
	$k = 0;
	$total = 0;
	$total_msg = 0;
	for( $x=0; $x<count($rows); $x++ ) {
	
		if (fmod($x,2) == 0)
			$pdf->SetFillColor(235);
		else 
			$pdf->SetFillColor(225);
		
		$row = $rows[$x];
		$pdf->Cell($colwidth[0],$colheight,$row->ticketmask,'R',0,'R',1);
		$pdf->Cell($colwidth[1],$colheight,utf8_encode($row->subject),'R',0,'L',1);
		$pdf->Cell($colwidth[2],$colheight,utf8_encode($row->name),'R',0,'L',1);

			if ($f_customfields == 1) 
			{
				for( $i=0; $i<count($custom_fields); $i++ )
				{
					$custom_field = $custom_fields[$i];
					$sql = "SELECT `newfield` AS `value` FROM #__support_field_value WHERE id_field='".$custom_field->id."' AND id_ticket='".$row->id."'";
					$database->setQuery( $sql );
					$custom_field_value = $database->loadObject();
					if( !isset($custom_field_value) ) {
						$pdf->Cell($colwidth[3],$colheight,'','R',0,'L',1);
					}else{
						$v = (trim($custom_field_value->value)!='')?utf8_encode($custom_field_value->value): '';
						$pdf->Cell($colwidth[3],$colheight,$v,'R',0,'L',1);
					}
				}
			}

		$pdf->Cell($colwidth[4],$colheight,$row->date,'R',0,'L',1);
		$pdf->Cell($colwidth[5],$colheight,$row->last_update,'R',0,'L',1);
		$pdf->Cell($colwidth[6],$colheight,utf8_encode($row->status),'R',0,'L',1);
		$pdf->Cell($colwidth[7],$colheight,$row->num_msg,'R',0,'R',1);

		$value = str_replace( '.', ':', ( $row->time_spent == '' ? '0:00' : $row->time_spent ) );
		$total = $total + convHHMMtoDEC( sc_checkTime($value) );	
		$pdf->Cell($colwidth[8],$colheight,sc_checkTime($value),'',0,'R',1);
		$total_msg = $total_msg + $row->num_msg;
		$pdf->Ln($colheight);
		if ($detail == 1) {

			// voltar ao topo desta linha
			$pdf->SetXY ($pdf->GetX(),$pdf->GetY() - $colheight);
			// need for last calculation
			$nowtime = mktime(date("H") , date("i") , date("s") , date("n") , date("j") , date("Y") );

			// changed status
			$database->setQuery( "SELECT l.id, UNIX_TIMESTAMP(l.date_time) AS DT, l.log, u.name, l.id_status AS status, l.id_user AS id_user FROM #__support_log l, #__users u WHERE l.id_user=u.id AND l.id_ticket='".$row->id."' ORDER BY DT ASC" );
			$ticketLogs = $database->loadObjectList();
			$status_report = $database->getErrorMsg();
			$numb_status = sizeof($ticketLogs);

			unset($status_detail);
			unset($user_detail);

			$pdf->SetFillColor(245);
			//$colspan = count($colwidth) + count($custom_fields) - 1; // um dos campos do $colwidth (4) conta com o tamanho único para os campos $custom_fields
			// $detail_width = array_sum($colwidth) + ((count($custom_fields) - 1) * $colwidth[3]);
			if ($f_custom_fields == 1) {
				$detail_width = array_sum($colwidth) + ((count($custom_fields) - 1) * $colwidth[3]);
			} else {
				$detail_width = array_sum($colwidth)- $colwidth[3];
			}
			$detail_height = ( $numb_status > 0 )? $colheight * 5: $colheight;	// titulo,status,date,lenght, user
			$detail_posx = $pdf->GetX();
			$detail_posy = $pdf->GetY() + $colheight;
			$separator = 5;
			$pdf->SetXY ($detail_posx+$separator,$detail_posy+$separator);
			$detail_width = $detail_width - (2*$separator);
			$detail_height = $detail_height - (2*$separator);
			
			
			if( $numb_status > 0 ) {
				$temp_status = 0;
				foreach ($ticketLogs as $ticketlog) {
					//if ($ticketlog->status != $temp_status) {
					if (($ticketlog->status != $temp_status) && ($ticketlog->status > 0) ){ // correct BUG older system doesnt have status id logged, some logs doesnt keep status!!! (i.e.: rate system)
						$temp_status = ($ticketlog->status > 0)? $ticketlog->status: JText::_('no_last_status_logged');
						$status_detail[getStatus($temp_status)] = $ticketlog->DT;
						$user_detail[] = $ticketlog->id_user;
					}
				}
				$count_status = (isset($status_detail))? count($status_detail) : 0;
				
				$detail_start_x = $pdf->GetX();;
				$pdf->SetFillColor(200);
				$pdf->Cell(20,$colheight,JText::_('tpl_status'),1,0,'R',1);
				$pdf->SetFillColor(210);
				if( $count_status > 0 ) {
					foreach ($status_detail as $status_name => $status_date) {
						$pdf->Cell(40,$colheight,utf8_encode($status_name),1,0,'L',1);
					}
				} else {
						$pdf->Cell(40,$colheight,JText::_('no_last_status_logged'),1,0,'L',1);
				}
				$pdf->Ln($colheight);
				
				$pdf->SetFillColor(200);
				$pdf->SetX ($detail_start_x);
				$pdf->Cell(20,$colheight,JText::_('dl_date'),1,0,'R',1);
				$pdf->SetFillColor(240);
				if( $count_status > 0 ) {
					foreach ($status_detail as $status_name => $status_date) {
						$pdf->Cell(40,$colheight, date($supportConfig->date_long,$status_date),1,0,'L',1);
					}
				} else {
						$pdf->Cell(40,$colheight,JText::_('no_last_status_logged'),1,0,'L',1);
				}
				$pdf->Ln($colheight);

				$pdf->SetFillColor(200);
				$pdf->SetX ($detail_start_x);
				$pdf->Cell(20,$colheight,JText::_('duedate_explain_length_time'),1,0,'R',1);
				$pdf->SetFillColor(240);
				if( $count_status > 0 ) {
					unset($time_temp);
					foreach ($status_detail as $status_name => $status_date) {
						$time_temp[] = $status_date;
					}
					$time_temp[] = $nowtime;
					
					$cicle = count($time_temp)-1;
					if ($cicle > 0) {
						for ($t=0; $t < $cicle; $t++) {
							$time_dif = $time_temp[$t+1] - $time_temp[$t];
							$pdf->Cell(40,$colheight,get_formated_duration($time_dif),1,0,'L',1);
						}
					} else {
							$pdf->Cell(40,$colheight,'-',1,0,'L',1);
					}										
				} else {
						$pdf->Cell(40,$colheight,JText::_('no_last_status_logged'),1,0,'L',1);
				}
				$pdf->Ln($colheight);

				
				$pdf->SetFillColor(200);
				$pdf->SetX ($detail_start_x);
				$pdf->Cell(20,$colheight,JText::_('user'),1,0,'R',1);
				$pdf->SetFillColor(240);
				if( $count_status > 0 ) {
					$cicle = count($user_detail)-1;
					if ($cicle > 0) {
						for ($t=0; $t < $cicle; $t++) {
							$pdf->Cell(40,$colheight,utf8_encode(getUser($user_detail[$t])),1,0,'L',1);
						}
					} else {
							$pdf->Cell(40,$colheight,'-',1,0,'L',1);
					}										
				} else {
						$pdf->Cell(40,$colheight,JText::_('no_last_status_logged'),1,0,'L',1);
				}

			} else {
				$pdf->Cell($detail_width,$detail_height,JText::_('no_status_change'),1,0,'C',1);
			}
			$pdf->Ln($colheight);
			$pdf->Ln($colheight);

		}
		
		
		
	}
		$pdf->SetFillColor(254);

		$pdf->Ln($colheight);
		$pdf->Cell($colwidth[0],$colheight,JText::_('tmpl_msg17'));
		$pdf->Cell($colwidth[1],$colheight,'');
		$pdf->Cell($colwidth[2],$colheight,'');
		$pdf->Cell($colwidth[3],$colheight,'');
		$pdf->Cell($colwidth[4],$colheight,'');
		if ($f_customfields == 1) 
		{
			$pdf->Cell(count($custom_fields)*$colwidth[5],$colheight,'');
		}
		$pdf->Cell($colwidth[6],$colheight,'');
		$pdf->Cell($colwidth[7],$colheight,$total_msg);
		$pdf->Cell($colwidth[8],$colheight,convDECtoHHMM($total) );
		$pdf->Ln($colheight);
}


@ob_end_clean();
if(ob_get_contents()) {
	// debug				
	$what = ob_get_contents();
	die("<b>Registo de Erro</b>: O que se encontra na header:<br /> <hr /> ".htmlentities($what));
}
// Outputs
$pdf->Output();
ini_set('zlib.output_compression', $ob); 
