<?php
/**
 * iMaQma Helpdesk Component
 * www.imaqma.com
 *
 * @package iMaQma Helpdesk
 * @copyright (C) 2000-2011 Components Lab, Lda.
 * @license GNU/GPL
 * 
 * $Id: reportstatus.php 337 2012-01-22 17:24:30Z pdaniel $
 * $LastChangedDate: 2012-01-22 17:24:30 +0000 (dom, 22 Jan 2012) $
 *
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

$ob = @ini_get("zlib.output_compression") && extension_loaded("zlib");
@ob_end_clean();
@ini_set('zlib.output_compression', 'Off'); 

require_once ( JPATH_SITE . '/components/com_maqmahelpdesk/pdf/fpdf_extention.php' );

$year = JRequest::getVar( 'year', 0, 'GET', 'int' );
$month = JRequest::getVar( 'month', 0, 'GET', 'int' );
$id_workgroup = JRequest::getVar( 'id_workgroup', 0, 'GET', 'int' );
$f_status = JRequest::getVar( 'f_status', 0, 'GET', 'int' );
$id_client = JRequest::getVar( 'id_client', 0, 'GET', 'int' );
$f_staff = JRequest::getVar( 'f_staff', 0, 'GET', 'int' );

$supportConfig = GetConfig();
$database = JFactory::getDBO();

$sql ="
SELECT 
  DISTINCT(s.`description`) as status,
  COUNT(l.`id_ticket`) as tickets,
  SUM(IF(
			l.`time_elapse`='0',
			(TIMEDIFF(NOW(), l.`date_time`)),
			l.`time_elapse`
	    )
	  ) AS lenght
FROM 
  jos_support_log l
    LEFT JOIN jos_support_ticket t  
      ON  l.id_ticket=t.id
	LEFT JOIN #__support_status s
	  ON s.`id` = l.`value`
WHERE 
  YEAR(l.`date_time`)='".$year."' AND 
  MONTH(l.`date_time`)='".$month."'  AND 
  l.`field` = 'status'
  ".($f_status>0 ? "AND l.value='".$f_status."'" : "")."
  ".($id_client>0 ? "AND l.id_user='".$id_client."'" : "")."
  ".($id_workgroup>0 ? "AND t.id_workgroup='".$id_workgroup."'" : "")."
GROUP BY 
  l.`value` 
ORDER BY 
  l.`value`, 
  l.`date_time` 
";
$database->setQuery( $sql );
$rows = $database->loadObjectList();

// Get workgroup name
if( $id_workgroup > 0 ) {
	$database->setQuery( "SELECT wkdesc FROM #__support_workgroup WHERE id='".$id_workgroup."'" );
	$wk_desc = prepare_txt($database->loadResult());
}else{
	$wk_desc = JText::_('all_workgroups');
}

// get status id
if( $f_status > 0 ) {
	$sql = "SELECT `description` AS text FROM #__support_status WHERE id='".$f_status."'";
	$database->setQuery($sql);
	$status_desc = prepare_txt($database->loadResult());
} else {
	$status_desc = JText::_('all_status');
}


// get staff name
if( $f_staff > 0 ) {
	$database->setQuery( "SELECT name FROM #__users WHERE id='$f_staff'" );
	$staff_desc = $database->loadResult();
} else {
	$staff_desc = JText::_('all_staff');
}
		
		
$pdf_orientation = "L"; 	// (L)andscape 	(P)ortrait
$pdf_unit = "mm";			// mm		pt		cm		in
$pdf_page_format = "A4";	// a3			a4		a5		letter		legal

$pdf=new PDF($pdf_orientation, $pdf_unit, $pdf_page_format);
$font1 = "Helvetica";

$pdf->AliasNbPages();
$pdf->SetFont($font1,'',10);


$colwidth=array(60,20,55,55);
$colheight = 8;

// Page 1 - Ticket Header
$pdf->AddPage();
$pdf->Bookmark(JText::_('status_report2'));
$pdf->SetFillColor(254);

# TITLE
$pagetitle = returnMonthDesc($month)." ".$year." / ".prepare_txt($wk_desc)." / ".prepare_txt($status_desc) . " / ". prepare_txt($staff_desc);
$pdf->SetFont($font1,'B',12);
$pdf->Cell(0,$colheight,$pagetitle,0,'C');
$pdf->Ln($colheight);


# TABLE HEADER
$pdf->SetFillColor(120);
$pdf->SetFont($font1,'B',9);
$pdf->Cell($colwidth[0],$colheight,JText::_('status'),'B',0,'L',1);
$pdf->Cell($colwidth[1],$colheight,JText::_('ticket_report'),'B',0,'R',1);
$pdf->Cell($colwidth[2],$colheight,JText::_('duedate_explain_length_time')." ".JText::_('time'),'B',0,'R',1);
$pdf->Cell($colwidth[3],$colheight,JText::_('average'),'B',0,'R',1);
$pdf->Ln($colheight);

# TABLE BODY	
if (count($rows) == 0) {
	$pdf->Cell(array_sum($colwidth),$colheight,JText::_('no_results'));
} else {
	$k = 0;
	for( $x=0; $x<count($rows); $x++ ) {
	
		if (fmod($x,2) == 0)
			$pdf->SetFillColor(235);
		else 
			$pdf->SetFillColor(225);

		$row = $rows[$x];
		$pdf->Cell($colwidth[0],$colheight,prepare_txt($row->status),'R',0,'L',1);
		$pdf->Cell($colwidth[1],$colheight,$row->tickets,'R',0,'R',1);
		$pdf->Cell($colwidth[2],$colheight,get_formated_duration($row->lenght),'R',0,'C',1);
		$avg = $row->lenght / $row->tickets;
		$pdf->Cell($colwidth[3],$colheight,get_formated_duration($avg),'R',0,'C',1);
		$pdf->Ln($colheight);
	}
}


@ob_end_clean();
if(ob_get_contents()) {
	// debug				
	$what = ob_get_contents();
	die("<b>Registo de Erro</b>: O que se encontra na header:<br /> <hr /> ".htmlentities($what));
}
// Outputs
$pdf->Output();
ini_set('zlib.output_compression', $ob); 
?>		