<?php
/**
* @package Frontend-User-Access plugin for Payplans (plg_payplans_frontenduseraccess)
* @version 2.1.1
* @copyright Copyright (C) 2008 - 2012 Carsten Engel. All rights reserved.
* @license GNU/GPL http://www.gnu.org/licenses/gpl-2.0.html 
* @author http://www.pages-and-items.com
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class PayplansAppfrontenduseraccess extends PayplansApp{	

	protected $_location = __FILE__;
	
	// applicable only if frontenduseraccess exist
	public function _isApplicable(PayplansIfaceApptriggerable $refObject){
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_frontenduseraccess');
	}	

	public function onPayplansSubscriptionAfterSave($prev, $new){		
	
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		// check the status
		if($new->getStatus() != $this->getAppParam('on_status', PayplansStatus::NONE)){
			return true;
		}
		
		//get user id
		$user_id = $new->getBuyer();
		
		//get new group(s) as array
		$fua_group = $this->getAppParam('addToGroup');
		
		//get keep groups
		$keep_groups = $this->getAppParam('keep_groups');
		
		//get remove groups
		$remove_groups = $this->getAppParam('removeFromGroup');
				
		if($user_id){
			$this->update_fua_group($user_id, $fua_group, $keep_groups, $remove_groups);
		}

		return true;
	}
	
	function update_fua_group($user_id, $fua_groups_array, $keep_groups, $remove_groups){
	
		$database = JFactory::getDBO();	
		
		//make sure $fua_group is an array
		//in payplans when this is one value it is parsed as a string?
		if(!is_array($fua_groups_array)){
			$fua_groups_array = array($fua_groups_array);
		}
		
		$database->setQuery("SELECT user_id, group_id "
		." FROM #__fua_userindex "
		." WHERE user_id='$user_id' "
		." LIMIT 1 "
		);
		$rows = $database->loadObjectList();
		$user_id_index = 0;
		$group_id_index = '';
		foreach($rows as $row){				
			$user_id_index = $row->user_id;
			$group_id_index = $row->group_id;	
		}

		if($group_id_index!='' && $keep_groups ) {
			$groups_array = array_unique(array_merge($fua_groups_array, $this->csv_to_array($group_id_index)));
		}else{
			$groups_array = $fua_groups_array;
		}
		
		//make sure $remove_groups is an array
		//in payplans when this is one value it is parsed as a string?
		if(!is_array($remove_groups)){
			$remove_groups = array($remove_groups);			
		}
		$temp_array = array();
		foreach($groups_array as $group){
			if(!in_array($group, $remove_groups)){
				$temp_array[] = $group;
			}
		}
		$groups_array = $temp_array;
		
		sort($groups_array);

		$fua_group = $this->array_to_csv($groups_array);

		if($user_id_index){	
			if($fua_group=='""'){
				$database->setQuery("DELETE FROM #__fua_userindex WHERE user_id='$user_id'");
			}else{		
				$database->setQuery( "UPDATE #__fua_userindex SET group_id='$fua_group' WHERE user_id='$user_id' ");
			}
		}else{			
			$database->setQuery( "INSERT INTO #__fua_userindex SET user_id='$user_id', group_id='$fua_group' ");
		}
		$database->query();
	}

	function csv_to_array($json){		
		$array = array();
		$temp = explode(',', $json);
		for($n = 0; $n < count($temp); $n++){
			$value = str_replace('"','',$temp[$n]);
			$array[] = $value;
		}
		return $array;
	}

	function array_to_csv($array){	
		$return = '';	
		for($n = 0; $n < count($array); $n++){
			if($n){
				$return .= ',';
			}
			$row = each($array);
			$value = $row['value'];
			if(is_string($value)){
				$value = addslashes($value);
			}	
			$return .= '"'.$value.'"';		
		}		
		return $return;
	}


}
?>