<?php 
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license	    GNU/GPL, see LICENSE.php
* @package	    PayPlans
* @subpackage	pdfInvoice
* @contact 	    payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.filesystem.archive' );
jimport( 'joomla.document.document' );

class plgPayplansPdfinvoice extends XiPlugin
{
	var $_name = 'pdfinvoice';	
	
	/**
	 * load plugin's view and controller
	 */
	public function onPayplansSystemStart()
	{
		//autoload view and controller
        $dir = dirname(__FILE__).DS.'pdfinvoice';
        PayplansHelperLoader::addAutoLoadFile($dir.DS.'pdfinvoiceadminview.php', 'PayplansadminViewReports');
		PayplansHelperLoader::addAutoLoadFile($dir.DS.'pdfinvoicecontroller.php', 'PayplansadminControllerReports');
        return true;
	}

	/**
	 * set plugin template for backend and front end
	 */
	public function onPayplansViewBeforeRender(XiView $view, $task)
	{
		//add submenu when plugin in enabled
		if(XiHelperJoomla::getPluginStatus('pdfinvoice','payplans')){
			XiAbstractView::addSubmenus('Reports');
			
			if(($view instanceof PayplansadminViewReports) && ($task == 'display')){
				$view->setTpl('admin');
				$templates = $this->_getTemplatePath($this->_name);
				foreach($templates as $tmpl)
					$view->addTemplatePath($tmpl);
			}
			
			if(($view instanceof PayplanssiteViewInvoice) && ($task == 'thanks' || $task == 'display')){
				$position = "pp-invoice-thanks-action";
				$html 	  = $this->_render("download_pdfhtml",null,'default');
				return array($position => $html);
			}
		}
		return true;
	}	

	function onAfterRoute()
	{
		$mainframe = PayplansFactory::getApplication();
		$option    = JRequest::getCmd('option');
		$action    = JRequest::getcmd('action');
		if(!( $option == 'com_payplans' && 
			( isset($action) && ($action == 'adminPdfInvoice' || $action == 'sitePdfInvoice')))){
			return;
		}		

		//if user exist
		if(PayplansFactory::getUser()->get('id')){
			//for backend
			if($action == 'adminPdfInvoice' ){
				if(!$this->doAdminAction())
					return ;
				if(!$this->createZipOfFiles()){
					PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_NO_RESULT_FOUND'));
				}
				return;
			}
			//for frontend with action sitePdfInvoice
			else{
			    $this->_streamPdf($this->doSiteAction());
			}
		}
		PayplansFactory::getApplication()->enqueueMessage(XiText::_('PLG_PAYPLANS_PDFINVOICE_ACTIVATE_YOUR_ACCOUNT_FIRST'),'error');
		return ;
	}
	
	/**
	 * delete all files and folders used in pdf generation
	 */
	function onPayplansCron()
	{
		if(!PayplansFactory::getSession()->get('pdfinvoice_lock',0)){
			$folders = JFolder::folders(dirname(__FILE__).DS.'pdfinvoice','pdfinvoices');
			foreach ($folders as $folder){
				$this->deleteFolder(dirname(__FILE__).DS.'pdfinvoice'.DS.$folder);
			}
		}
		return true;
	}
	
	/**
	 * Start processing invoice for front end
	 */
	function doSiteAction($invoiceKey = 0)
	{	
		$invoice_key   		  = empty($invoiceKey) ? JRequest::getVar('invoice_key',0) : $invoiceKey;
		$record->invoice_id   = XiHelperUtils::getIdFromKey($invoice_key);
		$record->created_date = null;

		//get last record for transaction to get created date
		$last_record              = array_pop(PayplansFactory::getInstance('transaction','model')
											->loadRecords(array('current_invoice_id'=>$record->invoice_id)));
		if(!empty($last_record)){
			$transaction          = PayplansTransaction::getInstance( $last_record->transaction_id, null, $last_record);
			$record->created_date = $transaction->getCreatedDate();
		}
		$pdf = $this->getContentForPdf($result = array($record) , 1);
		return $pdf;
	}
	
	/**
	 * stream the pdf
	 */
	protected function _streamPdf($pdf)
	{
		$user = PayplansFactory::getUser();
		$pdf->stream('pdfinvoice'.$user->id.'.pdf');
		return;
	}
	
	/**
	 * start processing for invoices
	 */
	function doAdminAction()
	{
		$mysess      = PayplansFactory::getSession();
		$count	     = $mysess->get('pdfinvoice_count',1);
		$deleteFiles = JRequest::getVar('pdfinvoice_deleteFiles',0);
		$limitStart  = $mysess->get('pdfinvoice_start',0);
		//delete folders related to the login user,if exist
		if($deleteFiles){
			$this->deleteUserFiles();
			$this->clearSessionVariables();
		}
		
		//if invoice key is given then use site side's function
		if(JRequest::getVar('pdfinvoice_invoiceKey','0')){
			$this->_streamPdf($this->doSiteAction(JRequest::getVar('pdfinvoice_invoiceKey')));
			return;
		}
		
		//else get result for in between given dates
		$result 	= $this->getResultForInvoices();
		if(isset($result['result']) && !empty($result['result'])){
			$this->createFolder($this->getContentForPdf($result['result']), $count);
		}

		//if total result is greater than processed result then set next limit and refresh the page 
		if(isset($result['totalResult']) && 
		         $result['totalResult']   >  ($limitStart + count($result['result']))){
			$mysess->set('pdfinvoice_count',++$count);
			$mysess->set('pdfinvoice_start', ($limitStart + count($result['result'])));
			$this->doRefresh();
			exit;
		}
		return true;
	}
	
	/**
	 * get the result invoices to be generated
	 */
	function getResultForInvoices()
	{
		$mysess  	  = PayplansFactory::getSession();
		$txnDateFrm   = $mysess->get('pdfinvoice_txnDateFrm',null);
		$txnDateTo    = $mysess->get('pdfinvoice_txnDateTo',null);
		$invoiceKey   = 0;
		//get variables from URL 
		if( empty($txnDateFrm) || empty($txnDateTo )){
			$txnDateFrm  = JRequest::getVar('pdfinvoice_txnDateFrm','00-00-0000');
			$txnDateTo  = JRequest::getVar('pdfinvoice_txnDateTo','00-00-0000');
			//if all fields are blank then return false
			if(empty($txnDateFrm) && empty($txnDateTo))
				return false;
			elseif (empty($txnDateFrm) && !empty($txnDateTo)){
				$txnDateFrm = $txnDateTo;
			}
			elseif (empty($txnDateTo) && !empty($txnDateFrm))
				$txnDateTo  = $txnDateFrm; 
				
			//also set in session for future use
			$mysess->set('pdfinvoice_txnDateFrm',$txnDateFrm);
			$mysess->set('pdfinvoice_txnDateTo',$txnDateTo);
		}
		
	    $result['totalResult'] = $mysess->get('pdfinvoice_total',null);		
		//get total result only for the first time,deciding it through variable 'pdfinvoice_deleteFiles'
		if(JRequest::getVar('pdfinvoice_deleteFiles',0)){
			$result['totalResult'] = $this->getTotalResults($txnDateFrm,$txnDateTo);
			$mysess->set('pdfinvoice_total',$result['totalResult']);			
		}
		
		$result['result'] = $this->_getResultInvoices($txnDateFrm,$txnDateTo);
		return $result;
	}
	
	/**
	 * build condition to be applied in query
	 */
	function _getResultInvoices($txnDateFrm,$txnDateTo)
	{
		$mysess  	= PayplansFactory::getSession();
		$limit 	    = $this->params->get('invoice_limit');
		$limitStart = $mysess->get('pdfinvoice_start',0);
		$query      = new XiQuery();
		$records    = $query->select('`invoice_id`,`created_date`')
		                    ->from('`#__payplans_transaction`')
		                    ->where("Date(`created_date`)   >= '".$txnDateFrm."'")
		                    ->where("Date(`created_date`)   <= '".$txnDateTo."'" )
		                    ->limit($limit,$limitStart)
						    ->dbLoadQuery()
		                    ->loadObjectList();
		return $records;
	}
	
	/**
	 * set content in a pdf file and save it in a folder
	 */
	function getContentForPdf($result)
	{
	    $this->loadRequiredClasses();
		$contents = $this->includeHeader();
		if($result){
			foreach($result as $row){
				$content = $this->getTemplate($row);
				if(!$content){
					continue;
				}
				$contents .= $content;
			}
		}
		//create pdf file
		$contents.= "</body></html>";
		$pdf      = new DOMPDF();
		$pdf->set_paper("a4", "portrait");
		$pdf->load_html($contents);
		$pdf->render();
		return $pdf;
	}
	
	/**
	 *  Creating folder of given pdf files
	 */
	function createFolder($pdf, $count = 0 , $userId = null)
	{
		$user	  = PayplansFactory::getUser($userId);
		$dir_path = dirname(__FILE__).DS.'pdfinvoice'.DS.'pdfinvoices'.$user->id;
		if(!is_dir($dir_path))
			mkdir($dir_path);
		file_put_contents($dir_path.DS.'invoice'.$count.'.pdf', $pdf->output());
		return ;
	}	
	
	/**
	 * get template for pdf file
	 */
	function getTemplate($record)
	{	
		//get instances
		$invoice        = PayplansInvoice::getInstance($record->invoice_id);
		if(!$invoice)
			return false; 
		$payment_status = $invoice->getStatus();
		$user    		= PayplansUser::getInstance($invoice->getBuyer());
		$record->invoice_number = XiHelperUtils::getKeyFromId($record->invoice_id);
		$record->details        = XiText::_("PLG_PAYPLANS_PDFINVOICE_TRANSACTION_DETAILS");
		$record->description    = XiText::_("PLG_PAYPLANS_PDFINVOICE_ITEM_DESC");
		if(!is_null($record->created_date)){
			$record->created_date   = is_object($record->created_date)?$record->created_date:(new XiDate($record->created_date));
		}
		//check payment status
		switch($payment_status)
		{
			case PayplansStatus::INVOICE_REFUNDED:
				$record->payment_status .= XiText::_("PLG_PAYPLANS_PDFINVOICE_REFUNDED");
				$record->details 		 = XiText::_("PLG_PAYPLANS_PDFINVOICE_REFUND_DETAILS");
				$record->description     = XiText::_("PLG_PAYPLANS_PDFINVOICE_REFUND_DESC");
				break;
				
			case PayplansStatus::INVOICE_PAID :
				$record->payment_status .= XiText::_("PLG_PAYPLANS_PDFINVOICE_PAID");
				break;
				
			default :
				$record->payment_status .= XiText::_("PLG_PAYPLANS_PDFINVOICE_CONFIRMED");	
		}
	
		$this->_assign('invoice', $invoice);
		$this->_assign('record', $record);	
		$this->_assign('user', $user);
		return $this->_render('pdfcontent',null,'default');
	}
	
	/**
	 * delete folder and contained files
	 */
	function deleteFolder($dirPath)
	{
		if(is_dir($dirPath)){	
			$files = JFolder::files($dirPath);
			foreach ($files as $file){
				unlink($dirPath.DS.$file);
			}
			JFolder::delete($dirPath);
		}
		return true;	
	}
	
	/**
	 * Delete all existing files in invoices folder
	 */
	function deleteUserFiles($userId = null)
	{   
		$user 	= PayplansFactory::getUser($userId);
		//delete files and folder before and after processing
		$this->deleteFolder(dirname(__FILE__).DS.'pdfinvoice'.DS.'pdfinvoices'.$user->id);
		return true;
	}
	
	/**
	 * clear all session variables
	 */
	function clearSessionVariables()
	{
		$mysess   = PayplansFactory::getSession();
		$sessVars = array('pdfinvoice_start','pdfinvoice_count','pdfinvoice_deleteFiles',
						  'pdfinvoice_txnDateFrm','pdfinvoice_txnDateTo','pdfinvoice_total');
		foreach ($sessVars as $var){
			$mysess->clear($var);
		}
		return true;	
	}
	
	/**
	 * get total result exist in between the given dates
	 */
	function getTotalResults($txn_from , $txn_to)
	{	
		//set lock variable so that files/folders can be restricted to delete through cron  
	    PayplansFactory::getSession()->set('pdfinvoice_lock',PayplansFactory::getSession()->get('pdfinvoice_lock',0)+1);
		$query  = new XiQuery();
		$result = $query->select('COUNT(*)')
		                ->from('`#__payplans_transaction`')
		                ->where('Date(`created_date`) >= "'.$txn_from.'"')
		                ->where('Date(`created_date`) <= "'.$txn_to.'"')
		                ->dbLoadQuery()
		                ->loadResult();
		return $result;
	}
	
	/**
	 * Create zip of pdf files 
	 */
	function createZipOfFiles()
	{
		$user 			   = PayplansFactory::getUser();
		$dir_path 		   = dirname(__FILE__).DS.'pdfinvoice'.DS.'pdfinvoices'.$user->id.DS;
		$archive_file_name = $dir_path."pdfinvoices".$user->id.".zip";
		$files             = JFolder::files($dir_path);
		$zip               = new ZipArchive();
		 //create the file and throw the error if unsuccessful
	    if ($zip->open($archive_file_name, ZIPARCHIVE::CREATE ) !== TRUE) {
	       exit("cannot open <$archive_file_name>\n");
	    }
	
	    //add each files of $file_name array to archive
	    foreach($files as $file){
	       $zip->addFile($dir_path.$file,$file);
	    }
		$zip->close();
	    //then send the headers to force download the zip file
	    if(file_exists($archive_file_name)){
		    header("Content-type: application/zip");
		    header("Content-Disposition: attachment; filename=pdfInvoices.zip");
		    header("Pragma: no-cache");
		    header("Expires: 0");
		    readfile("$archive_file_name");
		    $this->deleteUserFiles();
		    $this->clearSessionVariables();
		    
		    //unset lock variable so that cron can dekete the dummy folders if any
			PayplansFactory::getSession()->set('pdfinvoice_lock',PayplansFactory::getSession()->get('pdfinvoice_lock',0)-1);
		    exit;
	    }
	    return false;
	}	
	
	/**
	 * Refresh page for processing properly 
	 */
	function doRefresh()
	{
		$app 		 = PayplansFactory::getApplication();
		$currentUrl  = JURI::getInstance();
		//remove delete_files variable from url
		$currentUrl->delVar('pdfinvoice_deleteFiles');
		$redirectUrl = $currentUrl->toString();
       	$app->redirect($redirectUrl);
	}
	
	/**
	 * set header of pdf file 
	 */
	function includeHeader()
	{
		return $this->_render('pdfheader',null,'default');
	}
		
	/**
	 * load required classes of dompdf
	 */
	function loadRequiredClasses()
	{
		require_once dirname(__FILE__).DS.'pdfinvoice'.DS.'dompdf0.6'.DS."dompdf_config.inc.php";
	    $files = JFolder::files(DOMPDF_INC_DIR);
	    foreach ($files as $file){
			$class = JFile::stripExt($file);
			$class = JFile::stripExt($class);
			$frags = explode('_',$class);
		
			for($i=0; $i < count($frags); $i++)
				$frags[$i] = JString::ucfirst($frags[$i]);
				
			$class = implode ('_',$frags);
			XiHelperLoader::addAutoLoadFile(DOMPDF_INC_DIR.DS."$file",$class);
		}
		return;
	}
}

