<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	Frontend
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();

//jimport('joomla.html.parameter');

if(PAYPLANS_TEST_MODE_FIELDS){
	class XiAbstractParameter extends Xiform{}
}
else{
	class XiAbstractParameter extends XiLegacyParameter
	{
		function __construct($data='', $path = '')
		{
			parent::__construct($data, $path);
			
			// Set base path, this way other paths can be added automatically
			$this->addElementPath(PAYPLANS_PATH_ELEMENTS);
		}
		
		function render($name = 'params', $group = '_default')
		{
			if (!isset($this->_xml[$group])) {
				return false;
			}
	
			$parameter = $this;
			return XiHelperTemplate::partial('default_partial_parameters',compact('parameter', 'name', 'group'));
		}
		
		function renderToArray($name = 'params', $group = '_default')
		{		
			if (!isset($this->_xml[$group])) {
				return array();
			}
			$results = array();
			$params = $this->getParams($name, $group);
			foreach($params as $result) {
				//$result = $this->getParam($param, $name);
				$result[2] = XiText::_($result[2]);
				$result[3] = XiText::_($result[3]);
				$result['name'] = $name;
				$result['group'] = $group;
				
				$results[$result[5]] = $result;
			}
			return $results;
		}
	  
		/**
		 * @access	public
		 * @param	object	An XML object
		 * @deprecated payplans 2.4
		 * @since	payplans 2.3
		 */
		function setXML( &$xml )
		{
			if (is_object( $xml ))
			{
				if ($dir = $xml->attributes( 'addpath' )) {
					foreach(explode(',', $dir) as $d){
						$this->addElementPath( JPATH_ROOT . str_replace('/', DS, trim($d)) );
					}
				 	$xml->removeAttribute('addpath');
				}
			}
			
			parent::setXML($xml);
		}
  	}
}

class XiParameter extends xiAbstractParameter
{
	function bind($data, $group = '_default')
	{		
		if ( is_array($data) ) {
			return $this->loadArray($data, $group);
		} elseif ( is_object($data) ) {
			return $this->loadObject($data, $group);
		} else {
			return $this->loadINI($data, $group);
		}
	}
	
	function loadINI($data, $namespace = null, $options = array())
	{	
		return $this->loadString($data, 'XiINI', $options);
	}
}
